<?php 
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * Fjl                 : admin/addons/e_security.php
 * Kezds               : Pntek, 2006. december 1. 20:58
 * Utoljra mdostva   : saxus; 2007. februr 10. 14:23
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 

if (!defined('MUPORTAL')) { die('File hacking'); }

// ha definilva van a GET_ADDON_INFO konstans, akkor
// a $modinfo tmbben meg kell adni a bvtmny nevt s 
// verziszmt. Ezt csak a modul f fjlban kell 
// megadni _post s _func uttag fjlokban TILOS!
if (defined('GET_ADDON_INFO'))
{
	global $addon;
	
	$addon = array(
		'title'			=> 'Biztonsgi ellenrzs',
		'version'		=> '0.3.2',
		'minver'		=> '0.3.0',
		'author'		=> 'saxus',
		'homepage'		=> 'http://saxus.muportal.hu/',
		'email'			=> 'saxus@muportal.hu',
		'description'	=> "Ellenriz nhny muPortal s PHP belltst, amelybl kvetkeztetni lehet a rendszernk biztonsgra."
	);
	
} else {
	
	
	define('SEC_INFO',		1);
	define('SEC_PASSED',	2);
	define('SEC_WARNING',	3);
	define('SEC_SECHOLE',	4);

function CreateReport( $status = SEC_INFO, $title, $message )
{
	global $template;
	
	switch ($status) {
		case SEC_INFO :
			$status = 'Informci';
			$sicon	= 'info';
		break;
		case SEC_PASSED :
			$status = 'Rendben';
			$sicon	= 'passed';
		break;
		case SEC_WARNING :
			$status = 'Figyelmeztets';
			$sicon	= 'warning';
		break;
		case SEC_SECHOLE :
			$status = 'Biztonsgi rs';
			$sicon	= 'failed';
		break;
	} 
	
	$template->UseTpl('security_item', array(
		'STATUS'	=> $status,
		'ICON'		=> $sicon,
		'TITLE'		=> $title,
		'MSG'		=> $message,
	));
}
	
/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

	global $template, $conf;
	
	$template->LoadPackedFile('e_security');
	
	$template->UseTpl('base_switcher_styled', array(
		'STYLE'	=> 'width: 520px;'
	));

	
	$template->UseTpl('security_begin');
	
	$template->UseTpl('security_header', array(
		'TITLE'		=> 'muPortal belltsai'
	));


	$warn = ($conf['user_signHTML'] == 1);
	$warn = (isset($conf['news_enableHTML'])) ? 
		($warn || ($conf['news_enableHTML'] == 1)) : $warn;

	CreateReport( ($warn) ? SEC_WARNING : SEC_PASSED,
		'HTML kdok engedlyezse',
		'Amennyiben engedlyezve vannak a HTML kdok, lehetsget adunk a rosszindulat 
		felhasznlknak, hogy olyan JavaScript kdokat helyeznek el az oldalon, 
		amelyek segtsgvel ellophatjk ms ltogatk szemlyes adatait.'
	);
	
	
	CreateReport((strlen($conf['security_key']) < 8 ) ? SEC_WARNING : SEC_PASSED,
		'Oldal azonostkulcsa',
		'Amennyiben tl rvid azonostkulcsot hasznlunk, jelentsen nvelhetjk
		az oldal elleni tmadsok eslyt.'
	);
	
	
	CreateReport((file_exists('install.php') || file_exists('update.php')) ? SEC_SECHOLE : SEC_PASSED,
		'Fennfelejtett install.php vagy update.php',
		'Fontos, hogy ne felejtsk fenn sem a telept, sem a frisstszkriptet, 
		ellenkez esetben knnyen komoly krokat okozhatnak az oldalunkban.'
	);


	CreateReport(($conf['email_enable'] == 2 ) ? SEC_WARNING : SEC_PASSED,
		'E-Mail kld engedlyezse',
		'Amennyiben nem muszj, lehetleg ne engedlyezzk brkinek az E-Mail kld
		hasznlatt, ezzel megelzve azt, hogy spam-kldnek hasznljk az oldalt.'
	);
	
	CreateReport(($conf['debug'] == 1 ) ? SEC_SECHOLE: SEC_PASSED,
		'Hibakeres engedlyezse',
		'les oldalon soha ne engedlyezzk a hibakeres mdot, ugyanis sok
		informcit elrulhat egy esetleges tmadnak.'
	);
	
	CreateReport((is_writeable('config.php')) ? SEC_WARNING: SEC_PASSED,
		'<code>config.php</code> rsvdettsge',
		'Ajnlott rsvdett tenni a <code>config.php</code> fjlt, ezzel
		megelzve a vletlen mdostst.'
	);
	
	
	CreateReport(($conf['user_regmethod'] == 0) ? SEC_WARNING: SEC_PASSED,
		'Regisztrci megerstse',
		'Ajnlott ignyelni regisztrcikor a megerstst a felhasznlktl,
		ezzel megelzve a "felesleges" regisztrcikat.'
	);


	$template->UseTpl('security_header', array(
		'TITLE'		=> 'PHP belltsai'
	));

	
	CreateReport(((ini_get('display_errors') == 1) || (ini_get('display_errors') == 'On'))
		? SEC_SECHOLE : SEC_PASSED,
		'Hibk kijelzse',
		'les szerveren nagyon ajnlatos a hibk kirst kikapcsolni, ugyanis 
		egy-egy hibazenet hasznos informcival szolglhat brkinek, aki megprblja
		feltrni az oldalt. (display_errors)'
	);
	
	
	CreateReport(((ini_get('register_globals') == 1) || (ini_get('register_globals') == 'On'))
		? SEC_SECHOLE : SEC_PASSED,
		'Globlis vltozk regisztrlsa',
		'A globlis vltozk regisztrlsa komoly biztonsgi rst jelenthet 
		egy-egy rosszul megrt PHP szkript esetn. Tovbb felesleges regisztrlsokkal
		lasstja a PHP rtelmezt, ugyanis a muPortal nem ignyli ezt a belltst. (register_globals)'
	);

	CreateReport(((ini_get('register_long_arrays') == 1) || (ini_get('register_long_arrays') == 'On'))
		? SEC_INFO : SEC_PASSED,
		'Hossz tmbk regisztrlsa',
		'A PHP 4.1.0-s verzija ta elrhetek a rvid szupergloblis tmbk a rgi,
		hossz nev tmbbk helyett. Mivel egy mai PHP szkript mr nem ignyli
		ezeket a tmbbket, ezrt sebessg szempontjbl clszer ezt a belltst
		kikapcsolni. (register_long_arrays)'
	);
	
	
	CreateReport(((ini_get('magic_quotes_gpc') == 1) || (ini_get('magic_quotes_gpc') == 'On'))
		? SEC_INFO : SEC_PASSED,
		'Magic_Quotes_GPC',
		'A PHP egyik szolgltatsa, hogy az adatbzisnak kldtt krsekben a
		specilis karaktereket automatikusan az adatbzis szmra biztonsgosan 
		feldolgozhat formra alaktja t. Azoban ez a bellts felesleges sebessgcskkenst
		okozhat, valamint a PHP 6-ban ez a funkci bizotnsgi okok miatt meg fog sznni.
		A muPortal kpes lekezelni azt, ha ez a funkci ki van kapcsolva, emiatt rdemes
		kikapcsolni. (magic_quotes_gpc)'
	);
	
	
	CreateReport(((ini_get('open_basedir') != 1) && (ini_get('open_basedir') != 'On'))
		? SEC_WARNING : SEC_PASSED,
		'open_basedir',
		'Amennyiben egy megosztott szervert hasznlunk, s szeretnnk megvdeni
		a fjljainkat, clszer bekapcsolni az open_basedir opcit, ezzel megakadlyozhatjuk,
		hogy a PHP szkriptek "kimsszanak" abbl a knyvtrbl, amelyikben tallhat. (open_basedir)'
	);
	
	$template->UseTpl('security_header', array(
		'TITLE'		=> 'MySQL kapcsolat belltsai'
	));
	
	global $cfg;
	@require('config.php');
		
	CreateReport(((strtolower(trim($cfg['db_user'])) == 'root') ? SEC_SECHOLE : SEC_PASSED),
		'MySQL felhasznl',
		'Ne hasznljuk a root felhasznlval a MySQL szervernket. Egy sikeres tmads
		esetn komoly krokat okozhat az, ha a az adatbzisban tl sok joga van a felhasznlnak.
		Clszer egy olyan felhasznlt hasznlni, amelyiknek, csak a <code>SELECT</code>,
		<code>INSERT</code>, <code>UPDATE</code> s <code>DELETE</code> krsekre van jogosultsga.'
	);
	
	
	CreateReport(((strtolower(trim($cfg['db_pasw'])) == '') ? SEC_SECHOLE : SEC_PASSED),
		'MySQL felhasznl jelszava',
		'Ne hasznljuk jelsz nlkl az adatbzis-kapcsolatot! Amennyiben kvlrl elrhet
		a MySQL adatbzis-szerver, az esetleges tmadk komoly krokat okozhatnak az adatbzisban.'
	);
	
	unset($cfg);
	
}

?>