<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * Fjl                 : admin/forms/f_content_editor.php
 * Kezds               : Szerda, 2006. jlius 19.
 * Utoljra mdostva   : saxus; Sun Nov 12 13:41:03 CET 2006 13:41:03
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 

if (!defined('MUPORTAL')) { die('File hacking'); }

global $mode;

switch ($mode) {
	case 'add' : {
		$title = 'Egyszer tartalom hozzadsa';
		$v = array(
			'id'		=> -1,
			'bordertype' => 1,
			'php'	=> 0,
			'title'	=> '',
			'content' => '',
			'regmode' => 0,
			'date_begin' => time(),
			'date_end' => '',
		);
		break;
	}	
	case 'edit' : {
		$title = 'Tartalom szerkesztse';
		break;
	}
}

$form = new QuickForm();
 
$form->FormProperty('caption', $title);
$form->FormProperty('bordertype', FT_USERDEF);
$form->FormProperty('width', '600px');
$form->FormProperty('form_action', true);

$form->AddField('page', 'content');
$form->AddField('mode', $mode);
$form->AddField('id', $v['id']);

$form->SetAdjust( FA_LEFT );

$form->AddComponent( FC_TEXT, 'title', array(
  FP_CAPTION	=> 'Tartalom cme',
  FP_VALUE		=> $v['title'],
  FP_MAXLENGTH	=> 255,
));
 
 
$form->AddComponent( FC_TEXT, 'date_begin', array(
  FP_CAPTION		=> 'Idzts',
  FP_HELPMSG		=>
		'<em>Lehetsg van a hrek, cikkek, stb. idztett megjelentsre. Idztst nem ktelez megadni, ebben az esetben automatikusan megjelenik.</em>
		 <em>Ha meg kvnunk admi idztst, akkor ide brmit megadhatunk, amit a PHP-s strtotime() fggvny kpes rtelmezni.</em>
		 <em>Javasolt formtumok pldul:</em>
		 <ul>
		 	 <li><b>v-h-nap ra:perc</b></li>
			 <li><b>+1 day</b>: 1 nappal ksbb</li>
		  	 <li><b>+1 week</b>: 1 httel ksbb</li>
			 <li><b>+1 week 2 days 4 hours 2 secounds</b>: 1 httel, kt nappal 4 rval s kt msodperc mlva</li>
	 	 </ul>',
  FP_VALUE		=> ($v['date_begin'] != 0) ? ADate($v['date_begin']) : '',
  FP_MAXLENGTH		=> 19,
));

$form->AddComponent( FC_TEXT, 'date_end', array(
  FP_CAPTION		=> 'Tartalom rvnyessge',
  FP_HELPMSG		=> '<em>Amennyiben csak egy ideig kvnod megjelentetni a tartalmat, megadhatjuk a lejratt. A mezt hasonlan kell kitlteni, mint az idzts mezt. Ha nem kvnsz lejratot megadni, ne adj meg semmit.</em>',
  FP_VALUE			=> ($v['date_end'] != 0) ? ADate($v['date_end']) : '',
  FP_MAXLENGTH		=> 19,
));
 
$form->SetAdjust( FA_RIGHT );


$form->AddComponent( FC_LISTBOX, 'phpmode', array(
  FP_CAPTION		=> 'Feldolgozsi md',
  FP_HELPMSG		=> '<ul>
 				<li><b>Hagyomnyos szveg:</b> ez esetben a rendszer gy kezeli, mint pldul egy cikket s a rendszerben hasznlt formzsokat rvnyesti is rajta.</li>
				<li><b>HTML kd:</b> a rendszer semmilyen mdon nem nyl bele a tartalomba, az mdosts nlkl kerl kiratsra, mg a sortrsek sem kerlnek vgrehatjsra.</li>
				<li><b>PHP kd (bufferelt):</b> a tartalom PHP kdknt vgrehatjsra kerl, de a kimenet egy ideiglenes trolba kerl elszr. Javasolt, ha pldul az <code>echo</code> vagy a <code>print</code> fggvnyt kvnjuk hasznlni.</li>
                <li><b>PHP kd (bufferels nlkli):</b> a tartalom szintn PHP kdknt kerl vgrehatjsra, de a kimenet kezelst mindenkpp a muPortl mintarendszern keresztl kell vgrehajtani.</li>
			</ul>
			<em>PHP kd esetn nem ktelez a <code>&lt;?php</code> bevezet s a <code>?&gt;</code> lezr tag, viszont nem lehet "vegyteni". Csak PHP kd szerepelhet. </em>
			<em><b>Megjegyzs:</b> bonyolultabb PHP kdok esetn rdemes sajt modult rni a nagyobb sebessg rdekben.</em>',
  FP_VALUE		=> $v['php'],
  FP_ITEMS		=> array(
   0		=> 'Hagyomnyos szveg',
   1		=> 'HTML kd',
   2		=> 'PHP kd (bufferelt)',
   3		=> 'PHP kd (bufferels nlkli)',
  ),
));


$form->AddComponent( FC_RADIO, 'brdtype', array(
   FP_CAPTION		=> 'Fejlc megjelentse',
   FP_HELPMSG		=> '<em>Megjelentse a fejlcet s ezzel egytt a tartalom cmt. Egyes designeknl ez azzal jr, hogy a tartalom egy keretbe kerl.</em>
						<em>Ez akkor hasznos, ha pldul a megszokott moduloktl eltr keretre van szksgnk vagy PHP-val egynileg kell lekezelni a keretet.</em>',
   FP_VALUE			=> $v['bordertype'],
   FP_ITEMS			=> array(
			 1		=> 'Igen',
   			 0		=> 'Nem',
   ),
));

$form->AddComponent( FC_LISTBOX, 'regmode', array(
   FP_CAPTION		=> 'Kik tekinthetik meg az oldalt',
   FP_VALUE			=> $v['regmode'],
   FP_ITEMS		=> array(
			0		=> 'Brki',
   	    	1		=> 'Csak regisztrlatlan',
    		2		=> 'Csak regisztrlt',
   ),
));

$form->SetAdjust( FA_NORMAL );

$form->AddComponent( FC_TEXTAREA, 'text', array(
    FP_VALUE		=> $v['content'],
));
   

$form->AddComponent( FC_SUBMITBTTN, false, array(
    FP_BACK		=> 'admin.php?page=content&mode=list',
));
   
$form->Generate();

?>