<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * Fjl                 : admin/componentmgr.php
 * Kezds               : Szerda, 2006. februr 12.
 * Utoljra mdostva   : saxus; Sun Nov 12 13:28:50 CET 2006 13:28:50
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 
 
if (!defined('MUPORTAL')) { die('File hacking'); }

/*******************************************************************************
 *
 *									konstansok
 *
 *******************************************************************************/


// Form tpusok
define('FT_NORMAL', 0);
define('FT_NARROW', 1);
define('FT_USERDEF', 2);
define('FT_NONE', 3);

// Szlessgek
define('FW_AUTO', 0);

// Pozci
define('FA_NORMAL', 0);
define('FA_LEFT', 1);
define('FA_RIGHT', 2);

// Komponensek

define('FC_TEXTAREA', 0);
define('FC_LISTBOX', 1);
define('FC_RADIO', 2);
define('FC_RADIOGROUP', 3);
define('FC_TEXT', 4);
define('FC_SUBMITBTTN', 5);
define('FC_LINE', 6);
define('FC_TEMPLATE', 7);
define('FC_BOX_BEGIN', 8);
define('FC_BOX_END', 9);

// Tulajdonsgok
define('FP_CAPTION',		0);		// Cmkknek
define('FP_HELPMSG',		1);		// Sgszveg
define('FP_VALUE', 			2);		// rtk
define('FP_RADIO_TRUE',		3);		// Checkbox igen
define('FP_RADIO_FALSE',	4);		// 			nem
define('FP_ITEMS',			5);		// Elemlistkhoz
define('FP_HEIGHT',			6);		// Magassg
define('FP_VALIDATOR',		7);		// Ellenrz script
define('FP_READONLY',		8);		// Csak olvashat
define('FP_PASSWORD',		9);		// Jelsz
define('FP_MAXLENGTH',		10);	// Maximlis hossz
define('FP_BACK',			11);	// Vissza gomb
define('FP_RESET',			12);	// Reset gomb
define('FP_CAP_SUBMIT',		20);
define('FP_CAP_BACK',		21);
define('FP_CAP_RESET',		22);
define('FP_BORDER',			30);	// Doboz kerete
define('FP_PADDING',		31);	// Behzs
define('FP_MARGIN',			32);	// Trkz




/*******************************************************************************
 *
 *								QuickForm class
 *
 *******************************************************************************/

class QuickForm 
{

var $result = '';

// Form belltsait tartalmaz tmb
var $form_sett;

// rlapmezk
var $form_fields = array();

// Igazts
var $adjust = FA_NORMAL;

// Mr felhasznlt nevek
var $names = array();

// Buffer
var $buffer = array();

/**********************************************
 * Constructor
 */
function QuickForm ()
{
	global $template;
	
	$template->LoadPackedFile('components');
	
	// Alap form tulajdonsgok belltsa
	$this->form_sett = array(
		// Kinzet
		'caption'		=> false,			// Form cme		(str)
		'bordertype'	=> FT_NONE,			// Form tpusa		(const)
		'width'			=> FW_AUTO,			// Szlessg		(const, int)	
		'style'			=> '',				// Tovbbi stlus	(str)
		'method'		=> 'post',			// rlap kldsi metdus (str)
		
		// Funkci
		'form_action'	=> false,			// rlap-e			(str)		
	);
	
	$this->SetAdjust( FA_NORMAL );
}


/*********************************************
 * Form tulajdonsgainak mdostsa
 */
function FormProperty( $name = '', $value = '')
{
	$this->form_sett[ $name ] = $value;
}


/*********************************************
 * Rejtett rlapmez hozzadsa
 */
function AddField( $name = '', $value = '')
{
	$this->form_sett['form_action'] = true;
	
	$this->form_fields[ $name ] = $value;
}


/*********************************************
 * Igazts belltsa
 */
function SetAdjust( $a )
{
	if ($this->form_sett['bordertype'] == FT_NARROW) {
		return false;
	}
	
	global $template;
	
	if ($this->adjust == $a) {
		return false;
	}
	
	if ($this->adjust != FA_NORMAL) {		
		if ($a == FA_NORMAL) {
			$this->result .= $template->PrepareTpl('CFAClear');
		} else {
			$this->result .= $template->PrepareTpl('CFAClose');
		}
	}
	
	$this->adjust = $a;
	
	switch ($a) {
		//case FA_NORMAL: {  break; }
		case FA_LEFT: { $this->result .= $template->PrepareTpl('CFALeft'); return true; }
		case FA_RIGHT: { $this->result .= $template->PrepareTpl('CFARight'); return true; }
		case FA_NORMAL: { return true; }
	}
	
	return true;
}


/*********************************************
 * Komponens hozzadsa
 */
function AddComponent( $type, $name = false, $prop = false )
{
	if ($name !== false) {
		
		if (in_array( $name, $this->names)) {
			Msg_Die( WARNING, 'QuickForm->AddCompnent(): a(z) "'.$name.'" nevet egyszer mr felhasznltk ezen a formon!');
		} else {
			$this->names[] = $name;
		}
		
	}
	
	switch ($type)
	{
		case FC_TEXTAREA:	{ $this->Component_Textarea($name, $prop);	 break; }
		case FC_LISTBOX:	{ $this->Component_Listbox($name, $prop);	 break; }
		case FC_RADIO:		{ $this->Component_Radio($name, $prop);		 break; }
		case FC_RADIOGROUP:	{ $this->Component_RadioGroup($name, $prop); break; }
		case FC_TEXT:		{ $this->Component_Text($name, $prop);		 break; }
		case FC_SUBMITBTTN:	{ $this->Component_SubmitBttn($name, $prop); break; }
		case FC_LINE:		{ $this->Component_Line(); 					 break; }
		case FC_TEMPLATE:	{ $this->Component_Template($name, $prop);	 break; } 
		case FC_BOX_BEGIN:	{ $this->Component_Box_Begin($name, $prop);	 break; }
		case FC_BOX_END:	{ $this->Component_Box_End();				 break; }
	}
}


/*******************************************************************************
 * 								  KOMPONENSEK								   *
 *******************************************************************************/
 

/*-------------------------------------
 * Textarea hozzadsa
 */
function Component_Textarea ($name = false, $prop = array())
{
	if ($name === false) { return false; }
	
	global $template;
	
	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_HELPMSG		=> false,
		FP_HEIGHT		=> false, 		// false == auto
		FP_VALUE		=> false,
		FP_VALIDATOR	=> false,		// false == nix
		FP_READONLY		=> false,
	), $prop);
	
	$this->result .= $template->PrepareTpl('CFormTextarea', array(
		'CAPTION'	=> ($prop[FP_CAPTION] !== false) ? '<label for="CF_'.$name.'">'.htmlspecialchars( $prop[FP_CAPTION] ).'</label>' : '',
		'HELP'		=> $this->CompUtil_HelpMsg( $prop[FP_HELPMSG] ),
		'NAME'		=> $name,
		'READONLY'	=> ($prop[FP_READONLY])	? ' readonly="readonly"' : '',
		'STYLE'		=> ($prop[FP_HEIGHT] !== false ) ? ' style="height: '.$prop[FP_HEIGHT].';"' : '',
		'TEXT'		=> ($prop[FP_VALUE] !== false) ? htmlspecialchars( $prop[FP_VALUE] ) : '',
	));
	
	return true;
}


/*-------------------------------------
 * Lenyl lista
 */
function Component_Listbox ($name = false, $prop = array())
{
	if ($name === false) { return false; }
	
	global $template;

	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_HELPMSG		=> false,
		FP_VALUE		=> false,
		FP_ITEMS		=> array(),		// Listaelemek
	), $prop);
		
	$items = '';
	
	foreach ($prop[FP_ITEMS] as $k => $v) {
		$ch = ($k == $prop[FP_VALUE]) ? ' selected="selected"' : '';
		$items .= "\t".'<option value="'.$k.'"'.$ch.'>'.$v.'</option>'."\n";
	}
	
	$this->result .= $template->PrepareTpl('CFormListBox', array(
		'NAME'		=> $name,
		'CAPTION'	=> ($prop[FP_CAPTION] !== false) ? '<label for="CF_'.$name.'">'.htmlspecialchars( $prop[FP_CAPTION] ).'</label>' : '',
		'HELP'		=> $this->CompUtil_HelpMsg( $prop[FP_HELPMSG] ),
		'ITEMS'		=> $items
	));
	
	return true;
}


/*-------------------------------------
 * Igen/Nem rdigomb
 */
function Component_Radio ($name = false, $prop = array())
{
	if ($name === false) { return false; }
	
	global $template;
	
	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_HELPMSG		=> false,
		FP_VALUE		=> 0,
		FP_RADIO_TRUE	=> '1',			// Alaprtelmezett rtkek igazhoz 
		FP_RADIO_FALSE	=> '0',			// s hamishoz
	), $prop );
		
	$this->result .= $template->PrepareTpl('CFormRadioBox', array(
		'NAME'		=> $name,
		'CAPTION'	=> htmlspecialchars( $prop[FP_CAPTION] ),
		'HELP'		=> $this->CompUtil_HelpMsg( $prop[FP_HELPMSG] ),
		'VAL_TRUE'	=> $prop[FP_RADIO_TRUE],
		'VAL_FALSE'	=> $prop[FP_RADIO_FALSE],
		'HIGHL_T'	=> ($prop[FP_VALUE] == $prop[FP_RADIO_TRUE])	? ' checked="checked"' : '',
		'HIGHL_F'	=> ($prop[FP_VALUE] == $prop[FP_RADIO_FALSE])	? ' checked="checked"' : '',
	));
	
	return true;
}


/*-------------------------------------
 * Egyni rdigombok
 */
function Component_RadioGroup ($name = false, $prop = array())
{
	if ($name === false) { return false; }
	
	global $template;
	
	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_HELPMSG		=> false,
		FP_VALUE		=> false,
		FP_ITEMS		=> array(),		// Listaelemek
	), $prop);
	
	$items = '';
	
	reset($prop[FP_ITEMS]);
	$i = 0;
	
	foreach ($prop[FP_ITEMS] as $k => $v) {
		$i++;
		$ch = ($k == $prop[FP_VALUE]) ? ' checked="checked"' : '';
		$items .= "\t".
			'<input type="radio" name="n_'.$name.'" class="ch" value="'.$k.'" id="CF_'.$name.'_'.$i.'"'.$ch.' /> '.
			'<label for="CF_'.$name.'_'.$i.'">'.$v.'</label><br />'."\n";
	}
	
	$this->result .= $template->PrepareTpl('CFormRadioGroup', array(
		'NAME'		=> $name,
		'CAPTION'	=> ( $prop[FP_CAPTION] !== false) ? htmlspecialchars( $prop[FP_CAPTION] ) : '',
		'HELP'		=> $this->CompUtil_HelpMsg( $prop[FP_HELPMSG] ),
		'ITEMS'		=> $items
	));
	
	return true;
}


/*-------------------------------------
 * Szvegmez
 */
function Component_Text ($name = false, $prop = array())
{
	if ($name === false) { return false; }
	
	global $template;
	
	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_HELPMSG		=> false,
		FP_VALUE		=> false,
		FP_VALIDATOR	=> false,
		FP_READONLY		=> false,
		FP_PASSWORD		=> false,
		FP_MAXLENGTH	=> false,
	), $prop);
	
	if ($prop[FP_PASSWORD]) {
		$class = ' class="passwd"';
		$type = 'password';
	} else {
		$class = '';
		$type = 'text';
	}
	
	$this->result .= $template->PrepareTpl('CFormText', array(
		'CAPTION'	=> ($prop[FP_CAPTION] !== false) ? '<label for="CF_'.$name.'">'.htmlspecialchars( $prop[FP_CAPTION] ).'</label>' : '',
		'HELP'		=> $this->CompUtil_HelpMsg( $prop[FP_HELPMSG] ),
		'NAME'		=> $name,
		'MAXLG'		=> ($prop[FP_MAXLENGTH] !== false) ? ' maxlength="'.$prop[FP_MAXLENGTH].'" ' : '',
		'VALUE'		=> ($prop[FP_VALUE] !== false) ? htmlspecialchars( $prop[FP_VALUE] ) : '',
		'READONLY'	=> ($prop[FP_READONLY])	? ' readonly="readonly"' : '',
		'TYPE'		=> $type,
		'STYLE'		=> $class,
	));
	
	return true;
}


/*-------------------------------------
 * Elklds
 */
function Component_SubmitBttn ($name = false, $prop = array())
{
	global $template;
	
	$prop = MergeArray( array(
		FP_CAP_SUBMIT	=> 'Elklds',
		FP_CAP_BACK		=> 'Mgse',
		FP_CAP_RESET	=> 'Visszallts',
		FP_RESET		=> true,
		FP_BACK			=> false
	), $prop);

	// Submit button
	$bttns = "\t".'<input class="bttn" type="submit" ';
	if ($name !== false) {
		$bttns .= 'name="'.$name.'" ';
	}
	$bttns .= 'value="'.htmlspecialchars( $prop[FP_CAP_SUBMIT] ).'" />'."\n";

	// Visszallts gomb
	if ($prop[FP_RESET] !== false) {
		$bttns .= "\t".'<input class="bttn" type="reset" value="'.htmlspecialchars( $prop[FP_CAP_RESET] ).'" />'."\n";
	}
	
	// Mgse gomb
	if ($prop[FP_BACK] !== false) {
		$bttns .= "\t".'<input class="bttn" type="button" value="'.htmlspecialchars( $prop[FP_CAP_BACK] ).'" onclick="location.href=\''.$prop[FP_BACK].'\';" />'."\n";
	}
	
	$this->result .= $template->PrepareTpl('CFormSubmit', array(
		'BTTNS'		=> $bttns
	));
}


/*-------------------------------------
 * Vzszintes vonal
 */
function Component_Line ()
{
	global $template;
	
	$this->result .= $template->PrepareTpl('CFCline');
}


/*-------------------------------------
 * Minta beszrsa
 */
function Component_Template($name = false, $prop = array())
{
	global $template;
	
	if (($name == '!') && (!is_array($prop))) {
		return $prop;
	} else {
		return $template->PrepareTpl( $name, $prop );
	}
}


/**************************************
 * Doboz kezdete
 */
function Component_Box_Begin($name = false, $prop = array())
{
	global $template;
	
	if (is_array($name)) { $prop = &$name; }
	
	$prop = MergeArray( array(
		FP_CAPTION		=> false,
		FP_BORDER		=> false,
		FP_MARGIN		=> false,
		FP_PADDING		=> false,
	), $prop);
	
	$style = '';
	
	if ($prop[FP_MARGIN]  !== false) { $style .= $prop[FP_MARGIN].';'; }
	if ($prop[FP_BORDER]  !== false) { $style .= $prop[FP_BORDER].';'; }
	if ($prop[FP_PADDING] !== false) { $style .= $prop[FP_PADDING].';'; }
	
	$this->result .= $template->PrepareTpl( 'CFCBoxBegin', array(
		'CAPTION'		=> ($prop[FP_CAPTION] !== false) ? $prop[FP_CAPTION] : '',
		'NAME'			=> ($name !== false) ? 'id="'.$name.'"' : '',
		'STYLE'			=> ($style != '') ? 'style="'.$style.'"' : '',
	));
}


/**************************************
 * Doboz vge
 */
function Component_Box_End()
{
	global $template;
	
	$this->result .= $template->PrepareTpl('CFCBoxEnd');
}

/*******************************************************************************
 * 						   KOMPONENS KIEGSZTK							   *
 *******************************************************************************/

/*-------------------------------------
 * Labeles rsz generlsa
 */
function CompUtil_HelpMsg ( $msg = false )
{
	global $template;
	
	return ($msg !== false) ? $template->PrepareTpl('CFormHelpMsg', array('TEXT' => $msg ))	: '';
}


/*********************************************
 * Generls
 */
function Generate()
{
	global $template;

	// rvidebb vltoz a belltsoknak
	$sett = &$this->form_sett;
	
	// Lezrjuk az igaztst, ha mg van
	$this->SetAdjust( FA_NORMAL );
	
	// Keret bevezetse, ha kell	
	if ($sett['bordertype'] != FT_NONE) {
		// Ha keskeny panelt ksztnk
		if ($sett['bordertype'] == FT_NARROW) {
			$template->UseTpl('CBoxBegin', array(
				'NARROW'	=> 'narrow',
				'STYLE'		=> ''
			));
		
		// Ha egyni panelt ksztnk
		} elseif ($sett['bordertype'] == FT_USERDEF) {
			$template->UseTpl('CBoxBegin', array(
				'NARROW'	=> 'narrow',
				'STYLE'		=> ($sett['width'] == FW_AUTO) ? '' : 'style="width: '.$sett['width'].';'.$sett['style'].'"'
			));
		
		// Ha hagyomnyos vagy listapanelt ksztnk
		} else {
			$template->UseTpl('CBoxBegin', array(
				'NARROW'	=> '',
				'STYLE'		=> ''
			));
		}
	}
	
	// Cmsor megjelentse, ha van
	if ($sett['caption'] !== false) {
		$template->UseTpl('CBoxTitle', array(
			'TITLE'	=> $sett['caption'] 
		));
	}
	
	// Form bevezet, ha kell
	if ($sett['form_action']) {
		$template->UseTpl('CFormBegin', array(
			'METHOD'	=> $sett['method']
		));
		
		reset($this->form_fields);
		
		foreach ($this->form_fields as $k => $v) {
			$template->UseTpl('#ECHO', '<input type="hidden" name="'.$k.'" value="'.$v.'" />'."\n");
		}
	}
	
	// Ha van megjelentend tartalom a formban, megjelentjk
	if ($this->result != '') {
		$template->UseTpl('CBoxEditCtrlsBgn');
		$template->AddToStack( $this->result ); $this->result = '';
		$template->UseTpl('CBoxEditCtrlsBgn');	
	}

	// Form lezrsa, ha kell	
	if ($sett['form_action']) {
		$template->UseTpl('CFormEnd');
	}
	
	// Keret lezrsa, ha kell	
	if ($sett['bordertype'] != FT_NONE) {
		$template->UseTpl('CBoxEnd');
	}
} // end Generate()

} // end class

?>