<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * Fjl                 : admin/includes/functions.php
 * Kezds               : Szerda, 2006. mjus 24.
 * Utoljra mdostva   : saxus; Sun Nov 12 13:48:45 CET 2006 13:48:45
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

/************************************
 * zenet kirsa - ELAVULT
 */
function Echo_Msg( $msg )
{
	global $template;

	$template->LoadFile('msg', 'msg');

	$template->UseTpl('msg', array(
		'MSG' => $msg
	));
}

/************************************
 * Helyi men kirsa, ha szksges
 */
function LocalMenu( $array = null, $file = '') //, $switcher = true )
{
	global $template;

	$template->UseTpl('localmenu'.$file, $array );
}

/************************************
 * Vlts a mensor s a f tartalmi rsz kzt
 */
function Switcher()
{
	global $template;

	$template->UseTpl('base_switcher');
}

/************************************
 * Cm megjelentse, ha szksges
 */
function ShowTitle( $title )
{
	global $template;
	
	$template->UseTpl('base_title', array(
		'TITLE'	=> $title
	));
}

/************************************
 * strtoint ltal rtelmezhet dtum ellltsa (elavult?)
 */
function ADate ( $date = false)
{
	global $conf;

	if ($date === false) { $date = time(); }

	if (isset($conf['date_timezone']) && ($conf['date_timezone'] != 0)) {
		$date += $conf['date_timezone'] * 3600;
	}

	return Date('Y-m-d H:i:s', $date);
}

/***********************************
 * Bejelentkezshez s azonostshoz szksges
 * hash ellltsa
 */
function GenAdminHash( $id )
{
	global $conf;

	return '#SECURE#'.md5('#SEC#'.$id.USER_IP).'#'.md5($conf['security_key']).'#MU#';
}

define('S_TEXT', 1);
define('S_BOOLEAN', 2);
define('S_LIST', 3);


/**************************************
 * Bellsok oldal ksztse
 *
 * A 0.9.0-s vltozatban a f kezelrszt
 * mrete miatt traktam kln fjlba
 * (settings_func.php)
 */
function muSettingsPage( $construction, $title = 'Belltsok', $redirect = NULL )
{
	global $template;

	if (!isset($redirect)) { $redirect = 'admin.php?page=settings'; }

	ShowTitle( $title );

	$template->LoadPackedFile('a_settings');

	$template->UseTpl('settings-begin', array(
		'REDIRECT' => $redirect
	));

	require_once('mu-sys/admin/modules/a_settings_func.php');

	createSettingsPage( $construction );

	$template->UseTpl('settings-end');
}

/**************************************
 * Form beillesztse
 */
function IncludeForm( $form, $action, $variables = array() )
{
	global $mode, $v;

	$mode = $action;
	$v = $variables;

	if (file_exists('mu-sys/admin/forms/f_'.$form.'.php')) {

		require('mu-sys/admin/includes/componentmgr.php');

		include('mu-sys/admin/forms/f_'.$form.'.php');

		$return = true;
	} else {
		Msg_Die( CRITICAL, 'Nem tallom a "'.$form.'" formot!');
		$return = false;
	}

	unset($mode);
	unset($v);

	return $return;
}

/**************************************
 * Kt tmbt egyest
 */
function MergeArray( $first = array(), $secound = array() )
{
	foreach ($secound as $k => $v) {
		$first[$k] = $v;
	}
	return $first;
}

/**************************************
 * Oldalakra bontshoz segdeszkz
 */
global $conf;

define( 'PERPAGE', $conf['default_listlg'] );

function CreatePageSwitcher( $total, $curr, $fields_ar, $perpage = PERPAGE )
{
	global $template;

	$template->LoadPackedFile('pageswitcher');

	if (!is_numeric($perpage) || !is_numeric($total) || !is_numeric($curr)) {
		return false;
	}

	$current = ceil( $curr / $perpage ) + 1;
	$all = floor( $total / $perpage ) + 1;

	$urlbase = 'admin.php?';
	$fields = '';
	$minfield = 'min';

	foreach ( $fields_ar as $k => $v ) {
		if ($v == '{!}') {
			$minfield = $k;
		} else {
			$fields .= '<input type="hidden" name="'.$k.'" value="'.$v.'" />';
		}

		$urlbase .= $k.'='.$v.'&amp;';
	}

	$urlbase = substr( $urlbase, 0, -5 );

	// Vissza gomb
	if ($current < 2) {
		$backbttn = $template->PrepareTpl( 'pageswitcher_prew_d' );
	} else {
		$backbttn = $template->PrepareTpl( 'pageswitcher_prew_a', array(
			'URL'	=> str_replace( '{!}', (($current-2)*$perpage), $urlbase)
		));
	}

	// Elre gomb
	if ($current >= $all) {
		$nextbttn = $template->PrepareTpl( 'pageswitcher_next_d' );
	} else {
		$nextbttn = $template->PrepareTpl( 'pageswitcher_next_a', array(
			'URL'	=> str_replace( '{!}', (($current)*$perpage), $urlbase)
		));
	}


	$pg = 0;
	$options = '';

	for ( $i = 0; $i < ($total); $i = $i + $perpage) {
		$pg++;

		$options .=
			'<option value="'.$i.'"'.
			(($pg == $current) ? ' selected="selected"' : '').
			'>'.$pg.'</option>';
	}


	return $template->PrepareTpl('pageswitcher', array(
		'NO'		=> $current,
		'TOTAL'		=> $all,

		'PDFIELDS'	=> $fields,

		'MINFIELD'	=> $minfield,
		'FIELDS'	=> $options,

		'BACK'		=> $backbttn,
		'NEXT'		=> $nextbttn
	));

}

/**************************************
 *
 */
function IncludeFile( $filename )
{
	if (file_exists('mu-sys/admin/'.$filename)) {
		require_once('mu-sys/admin/'.$filename);
	} else {
		global $template;

		$template->LoadFile('moderror');
		$template->UseTpl('moderror', array(
			'FILE'	=> $filename
		));
	}
}