<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM - MINIADMIN
 *
 ***************************************************************************
 *                               a_news.php
 *                            -------------------
 *   kezds               : Kedd, 2004. augusztus 3
 *   copyright            : (C) 2004-2006 muPortal Team
 *   email                : muportal@freemail.hu
 *   utoljra mdostva   : Pntek, 2007. februr 09. 17:32
 *   utoljra mdostotta : saxus
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

if (!defined('LOADED_NEWS'))
{
	/*******************************************************************/
	function News_List ()
	{
		global $db, $template;

		$template->UseTpl('base_switcher');

		ShowTitle( 'Hrek listja' );

		$min = (isset($_GET['min'])) ? $_GET['min'] : 0;

		$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'news');
		$count = $db->sql_fetch_array();

		$pgswitcher = CreatePageSwitcher( $count['count'], $min, array(
			'page'	=> 'news',
			'mode'	=> 'list',
			'min'	=> '{!}',
		));

		$template->AddToStack( $pgswitcher );


		$template->UseTpl('news_list_begin');

		$db->sql_query('SELECT news, COUNT(*) AS count
			FROM '.DBPREFIX.'news_comments
			GROUP BY news');

		$msgs = array();

		while ($row = $db->sql_fetch_array()) {
			$msgs[ $row['news'] ] = $row['count'];
		}

		$db->sql_query( 'SELECT
				n.id AS newsid, n.name, n.date, n.ip, n.title,
				n.highlighted, n.email, LEFT( n.text, 400) AS preview,
				u.name AS owner, c.title AS category
			FROM '.DBPREFIX.'news n
			LEFT JOIN '.DBPREFIX.'users u ON (n.userid = u.id)
			LEFT JOIN '.DBPREFIX.'news_category c ON (c.id = n.category)
			ORDER BY n.date DESC
			LIMIT '.$min.', '.PERPAGE );

		$res = $db->res;

		$i = 'd';

		$time = time();



		while ( $row = $db->sql_fetch_array( $res ) )
		{
			$i = ($i == 'w') ? 'd' : 'w';

			$flags = '';

			$flags .= ($row['highlighted'] == 1)?
				'<img src="mu-sys/tpl-admin/img/icon-flag.gif" class="flag" title="Kiemelt hr" alt="Kiemelt hr" />' : '';
			$flags .= ($row['date'] > $time)  ?
				(($flags == '') ? '<div class="flag">&nbsp;</div>' : '').
				'<img src="mu-sys/tpl-admin/img/icon-clock.gif" class="flag" title="Idztett hr" alt="Idztett hr" />'
					: '';

			$template->usetpl( 'news_list_item', array(
				'CLASS'		=> $i,
				'ID'		=> $row['newsid'],
				'TITLE'		=> htmlspecialchars($row['title']),
				'DATE'		=> FormatDate( $row['date'] ),
				'AUTHOR'	=> htmlspecialchars($row['name']),
				'OWNER'		=> (isset($row['owner'])) ? $row['owner'] : '-?-',
				'IP'		=> ($row['ip'] == '') ? '-?-' : $row['ip'],
				'CATEGORY'	=> (isset($row['category'])) ? $row['category'] : '(Egyik sem)',
				'EMAIL'		=> htmlspecialchars($row['email']),
				'COMMENTS'	=> (isset($msgs[ $row['newsid'] ] )) ? $msgs[ $row['newsid'] ] : 0,
				'FLAGS'		=> $flags,
				'PREVIEW'	=> htmlspecialchars( $row['preview'] )
			));
		}

		$template->UseTpl('news_list_end');

		$template->AddToStack( $pgswitcher );
	}

	/*******************************************************************/
	function News_Add ()
	{
		IncludeForm( 'news_editor', 'add' );
	}

	/*******************************************************************/
	function News_Edit ()
	{
		global $template, $db	;

		$id = $_GET['id'];

		$db->sql_query('SELECT name, email, title, date, category, highlighted, text FROM '.DBPREFIX.'news WHERE id='.$id.' LIMIT 1' );
		$row = $db->sql_fetch_array();

		$row['id'] = $id;

		IncludeForm( 'news_editor', 'edit', $row );
	}


	/*******************************************************************/
	function News_Delete ()
	{
		global $db;

		$id = $_GET['id'];

		$db->sql_query( 'DELETE FROM '.DBPREFIX.'news_comments WHERE news='.$id);
		$db->sql_query( 'DELETE FROM '.DBPREFIX.'news WHERE id='.$id);

		muRedirect( 'admin.php?page=news&mode=list', 'Hr trlve!');
		die();
	}


	/*******************************************************************/
	function News_Cat_List()
	{
		global $db, $template;

		$template->UseTpl('base_switcher');

		ShowTitle('Hrkategrik listja');

		$min = (isset($_GET['min'])) ? $_GET['min'] : 0;

		$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_category');
		$count = $db->sql_fetch_array();

		$pgswitcher = CreatePageSwitcher( $count['count'], $min, array(
			'page'	=> 'news',
			'mode'	=> 'cat_list',
			'min'	=> '{!}',
		));

		$template->AddToStack( $pgswitcher );

		$template->UseTpl('news_clist_begin');

		$i = 'd';

		$db->sql_query('SELECT category, COUNT(*) AS count
			FROM '.DBPREFIX.'news
			GROUP BY category');

		$count = array();
		while ($row = $db->sql_fetch_array()) {
			$count[ $row['category'] ] = $row['count'];
		}

		$db->sql_query('SELECT id, title, LEFT(description,400) AS preview
			FROM '.DBPREFIX.'news_category
			ORDER BY title ASC
			LIMIT '.$min.', '.PERPAGE);

		while ( $row = $db->sql_fetch_array( ))
		{
			$i = ($i == 'w') ? 'd' : 'w';

			$template->UseTpl('news_clist_item', array(
				'CLASS'		=> $i,
				'ID'		=> $row['id'],
				'TITLE'		=> htmlspecialchars($row['title']),
				'COUNT'		=> (isset($count[ $row['id'] ] )) ? $count[ $row['id'] ] : 0,
				'PREVIEW'	=> htmlspecialchars($row['preview'])
			));
		}

		$template->UseTpl('news_clist_end');

		$template->AddToStack( $pgswitcher );
	}

	/*******************************************************************/
	function News_Cat_Add()
	{
		IncludeForm( 'news_category', 'add' );
	}

	/*******************************************************************/
	function News_Cat_Edit()
	{
		global $db;

		$id = $_GET['id'];

		$db->sql_query('SELECT id, title, description FROM '.DBPREFIX.'news_category WHERE id='.$id);
		$row=$db->sql_fetch_array();

		IncludeForm( 'news_category', 'edit', $row );
	}

	/*******************************************************************/
	function News_Cat_Delete()
	{
		global $db;

		$id = $_GET['id'];

		$db->sql_query( 'DELETE FROM '.DBPREFIX.'news_category WHERE id='.$id.' LIMIT 1');
		$db->sql_query( 'UPDATE '.DBPREFIX.'news SET category = 0 WHERE category='.$id);

		muRedirect( 'admin.php?page=news&mode=cat_list', 'Hrkategria trlve!');
		die();
	}

	/*******************************************************************/
	function News_Settings()
	{
		global $template;

		$template->UseTpl('base_switcher');

		muSettingsPage( array(
				'!PAGE!::Hrek, hozzszlsok s hrklds belltsai',

				/**********************************/
				'Hrek',

				array(
					0 => 'news_limit',
					1 => 'Hrek a kezdlapon',
					2 => 'Mennyi hr jelenjen meg a kezdlapon maximum?',
					3 => S_TEXT,
					4 => 4
				),

				array(
					0 => 'news_highlight',
					1 => 'Kiemelt hrek',
					2 => 'Hogyan jelenjenek meg a kiemelt hrek a kezdlapon?',
					3 => S_LIST,
					4 => array(
						0 => 'Ugyangy, mint a tbbi (nincs kiemels)',
						2 => 'Ms sznnel',
						1 => 'Kiemelve az oldal tetejn',
					)
				),

				/**********************************/
				'Hozzszlsok',

				array(
					0 => 'news_enableHTML',
					1 => 'HTML kdok engedlyezse',
					2 => 'Engedlyezi-e a HTML kdok hasznlatt a hozzszlsokban? Biztonsgi szempontok miatt <b>nem javasolt!</b>',
					3 => S_BOOLEAN
				),

				array(
					0 => 'news_cmt_limit',
					1 => 'Hozzszlsok egy oldalon',
					2 => 'Mennyi hozzszls jelenjen meg egy oldalon egyszerre?',
					3 => S_TEXT,
					4 => 4
				),
				array(
					0 => 'news_cmt_usrmode',
					1 => 'Ki rhat hozzszlst?',
					2 => 'Kivlaszthatod, hogy brki vagy csak regisztrlt tagok rhatnak hozzszlst a hrekhez.',
					3 => S_LIST,
					4 => array(
						0 => 'Brki',
						1 => 'Csak regisztrlt tag'
					)
				),
				/*array(
					0 => 'news_quotelimit',
					1 => 'Idzet limit',
					2 => 'Hny karakter lehet maximum az idzet maximlis hossza vlasz esetn? Ha nem kvnja limitlni, rjon be <b>-1</b>-t!',
					3 => S_TEXT,
					4 => 5
				),*/

				'Hrklds',

				array(
					0 => 'sendnews_usr_mode',
					1 => 'Ki hasznlhatja a hrkldst?',
					2 => 'Eldntheted, hogy brki vagy csak regisztrlt tagok kldhessenek hreket a hrkldsen keresztl.',
					3 => S_LIST,
					4 => array(
						0 => 'Brki (nv nlkl is)',
						1 => 'Brki (csak nvvel s e-mail cmmel)',
						2 => 'Csak regisztrlt tag',
					)
				)

			), 'Hrek, hozzszlsok s hrklds belltsai', 'admin.php?page=news&amp;mode=settings'  );

	}

	/*******************************************************************/
	function Submited_List()
	{
		global $db, $template;

		$template->UseTpl('base_switcher');

		ShowTitle( 'Bekldtt hrek listja' );

		$min = (isset($_GET['min'])) ? $_GET['min'] : 0;

		$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_submited');
		$count = $db->sql_fetch_array();

		$pgswitcher = CreatePageSwitcher( $count['count'], $min, array(
			'page'	=> 'news',
			'mode'	=> 'submited',
			'min'	=> '{!}',
		));

		$template->AddToStack( $pgswitcher );

		$template->UseTpl('news_slist_begin');

		$db->sql_query('SELECT news, COUNT(*) AS count
			FROM '.DBPREFIX.'news_comments
			GROUP BY news');

		$msgs = array();

		while ($row = $db->sql_fetch_array()) {
			$msgs[ $row['news'] ] = $row['count'];
		}

		$db->sql_query( 'SELECT
				n.id AS newsid, n.name, n.email, n.sdate, n.ip, n.title,
				LEFT( n.text, 400) AS preview, n.userid,
				u.name AS owner, u.email AS ownermail
			FROM '.DBPREFIX.'news_submited n
			LEFT JOIN '.DBPREFIX.'users u ON (n.userid = u.id)
			ORDER BY n.sdate DESC
			LIMIT '.$min.', '.PERPAGE );

		$res = $db->res;

		$i = 'd';

		//$time = time();

		while ( $row = $db->sql_fetch_array( $res ) )
		{
			$i = ($i == 'w') ? 'd' : 'w';

			if (isset($row['userid']) || ($row['userid'] != 0)) {
				$username = $row['owner'];
				$usermail = $row['ownermail'];
			} else {
				$username = $row['name'];
				$usermail = $row['email'];
			}

			$template->usetpl( 'news_slist_item', array(
				'CLASS'		=> $i,
				'ID'		=> $row['newsid'],
				'TITLE'		=> htmlspecialchars( $row['title'] ),
				'DATE'		=> FormatDate( $row['sdate'] ),

				'AUTHOR'	=> htmlspecialchars($username),
				'EMAIL'		=> htmlspecialchars($usermail),

				'IP'		=> ($row['ip'] == '') ? '-?-' : $row['ip'],
				'PREVIEW'	=> htmlspecialchars( $row['preview'] )
			));
		}

		$template->UseTpl('news_slist_end');

		$template->AddToStack( $pgswitcher );
	}

	/*******************************************************************/
	function Submit_Delete ()
	{
		global $db, $_GET;

		$id = $_GET['id'];

		$db->sql_query( 'DELETE FROM '.DBPREFIX.'news_submited WHERE id='.$id.' LIMIT 1');

		muRedirect( 'admin.php?page=news&mode=submited_list', 'Bekldtt hr trlve!');
		die();
	}

	/*******************************************************************/
	function Submit_Confirm ()
	{

		IncludeForm( 'news_editor', 'submited', array(
			'id'	=> $_GET['id']
		));

	}
	define('LOADED_NEWS',true);
}

global $template, $db;

if (isset($_GET['mode'])) { $mode = $_GET['mode']; } else { $mode = 'list'; }

$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_submited');
$row = $db->sql_fetch_array();

$template->LoadPackedFile('a_news');
LocalMenu( array( 'COUNT' => $row['count'] ));

switch ($mode)
{
	// Hrek kezelse
	case 'list' : {
		News_List();
		break;
	}
	case 'add' : {
		News_Add();
		break;
	}
	case 'edit' : {
		News_Edit();
		break;
	}
	case 'delete' : {
		News_Delete();
		break;
	}

	// Kategrik kezelse
	case 'cat_list' : {
		news_Cat_List();
		break;
	}
	case 'cat_add' : {
		news_Cat_Add();
		break;
	}
	case 'cat_edit' : {
		news_Cat_Edit();
		break;
	}
	case 'cat_delete' : {
		news_Cat_Delete();
		break;
	}

	// Bekldtt hrek kezelse
	case 'submited' : {
		Submited_List();
		break;
	}
	case 'submited_delete': {
		Submit_Delete();
		break;
	}
	case 'submited_confirm': {
		Submit_Confirm();
		break;
	}

	// Belltsok
	case 'settings' : {
		News_Settings();
		break;
	}

/*	case 'comments' :
	{
		Comments_List();
		break;
	}
	case 'comments_delete' :
	{
		Comments_Delete();
		break;
	}*/
}

?>
