<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: functions.php 92 2008-01-08 18:27:22Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }


/******************************
 * Szveget HTML kompatibiliss
 * formz (pl.: Enter jelek)
 */
function formattext( $str )
{
	return str_replace("\n", '<br />', $str);
}


/**
 * URL link- alaktsa a szvegben
 *
 * @param string $text
 * 	Cserlend szveg
 * @return string
 */
function FormatURL($text, $safe = true)
{
	$callback = ($safe)	? 'Callback_CreateLink' : 'Callback_CreateSafeLink';
    return preg_replace_callback(
            '#(\s)http://(.*?)(\s)#s',
            $callback,
            ' '.$text.' ');
}


function Callback_CreateLink($a)
{
	return sprintf('%s<a href="http://%s">http://%s</a>%s',
		$a[1], $a[2], $a[2], $a[3]
	);
}

function Callback_CreateSafeLink($a)
{
	$a[1] = htmlspecialchars($a[1]);
	$a[2] = htmlspecialchars($a[2]);
	return Callback_CreateLink($a);
}


define('D_TODAY', mktime ( 0, 0, 0, Date('n'), (Date('j')), Date('Y') ));
define('D_YESTERDAY', D_TODAY-86400 );
define('D_TOMORROW', D_TODAY+86400 );

/*************************
 * Kiegszt fggvny a FormatDate -hoz:
 * Ha be van kapcsolva az, hogy a 'ma' s a
 * tegnmap feliratok megjelenhetnek dtumban,
 * akkor ezt hvja meg a FormatDate
 */
function FormatDate_TEXT( $date , $format = NULL )
{
	global $lang, $conf;

	// Ma
	if (( $date < D_TOMORROW ) && ( $date >= D_TODAY )) {
		return sprintf( $lang['today'], Date( (isset($format)) ? '' : $conf['timeformat'], $date ) );
	} // Tegnap
	elseif (( $date < D_TODAY ) && ( $date >= D_YESTERDAY ))
	{
		return sprintf( $lang['yesterday'], Date( (isset($format)) ? '' : $conf['timeformat'], $date ) );
	} else { // Egybb
		return Date( (isset($format)) ? $format : $conf['dateformat'], $date );
	}
}


/******************************
 * A drum formtum szveget ('YYYY-MM-DD HH:MM:SS') Konvertlja
 * t a config->dateformat-ban megadott formtumra
 */
function FormatDate( $date = false, $format = NULL )
{
	global $conf;

	if ($date === false) {
		$date = time();
	}

	if (isset($conf['date_timezone']) && ($conf['date_timezone'] != 0)) {
		$date += $conf['date_timezone'] * 3600;
	}

	if ($conf['date_today'] == 1) {
		return FormatDate_TEXT( $date, $format );
	} else {
	    return Date( (isset($format)) ? $format : $conf['dateformat'], $date );
	}
}


/******************************
 * Megnzi, hogy ltezik-e a $table-ban
 * $id-j sor
 */
function LiveID( $table, $id, $idfield = 'id' )
{
	global $db;

	$db->sql_query( 'SELECT id FROM '.DBPREFIX.$table.' WHERE '.$idfield.'='.$id.' LIMIT 1' );

	return ($db->sql_num_rows() == 1);
}


/******************************
 * Visszatr a futsidvel
 */
function TotalTime()
{
	global $start_time;

    $mtime = microtime();
    $mtime = explode(' ',$mtime);
    $current_time = $mtime[1] + $mtime[0];

	return substr(($current_time - $start_time), 0, 5);
}


/******************************
 * Ltrehozza a forwardert
 */
function Encode_Forwarder ( $get = NULL )
{
	global $conf;

	// Ha nem postolst vgznk, akkor az URL
	// szerepel az $_ENV supergloblis vltozban
	if (!defined('MU_POSTING'))
	{
		return ($_SERVER['QUERY_STRING'] != '') ? $_SERVER['QUERY_STRING'] : $conf['page_default'];
	}

	// Ha nincs megadva paramter, vagy nem
	// tmb, akkor a $get vltozt hasznljuk
	if (!isset($get) || !is_array($get) )
	{
		global $get;

		// Ha nem tmb, akkor nincs ms dolgunk
		// vele
		if (!is_array($get))
		{
			return $conf['page_default'];
		}
	}

	reset($get);

	$res = '';

	// Ltrehozzuk a forwardert
	foreach ($get as $k => $v) {
		$res .= $k.'='.$v.'&';
	}

	// Levlasztjuk a felesleges & jelet a sor
	// vgrl
	return substr( $res, 0, strlen( $res )-1 );
}


/******************************
 * A forwarder tartalmt
 * bontja szt egy tmbre
 */
function Decode_Forwarder ( $forwarder = '' )
{
	// Ha nincs megadva forwarder, akkor nem prbljuk meg
	// dekdolni.
	if ($forwarder == '' ) { return false; }

	$fw = array();

	// A sor vgre hozzrakunk egy '&' jelet, hogy megfeleljen
	// a mintnak
	$forward = $forwarder.'&';

	// Majd a mintbl elksztjk a PHP kdot...
	$forward = preg_replace( '#(.*?)=(.*?)&#', '$fw[\'\\1\'] = \'\\2\';', $forward );

	// 	..majd lefuttatjuk
	eval($forward);
	unset($forward);

	return $fw;
}


/******************************
 * Kibvtett vltozata a Die() parancsnak
 *
 * $code rtkei:
 *
 * MESSAGE:
 * Egyszer zenet megjelentse (jogosultsgi
 * problmk)
 *
 * WARNING
 * Figyelmeztets (minta hinyzik, nem ltez elem
 * az adatbzisban, stb.)
 *
 * ERROR
 * Slyos hibk a modul futtatsa sorn
 *
 * CRITICAL
 * Rendszerszint hiba (nincs adatbziskapcsolat,
 * templates rendszer nem aktv stb.)
 *
 * A MESSAGE, a WARNING s az ERROR szint hibk
 * megjelentse a module vagy a panel mintk kztt
 * trtnik, a CRITICAL szint hibk _minden_ esetben
 * HTML kdban kerlnek kirsra, s nem a mintarend-
 * szeren keresztl.
 * Ha nincs inicializlva a mintarendszer, akkor az
 * sszes hibazenet HTML kdknt kerl kirsra.
 *
 * Ha $dienow = true, akkor azonnal lell a szkript
 * futsa brmilyen szint is a hiba
 */

// Msg_Die $code rtkeinek deffinilsa

define('MESSAGE', 100);
define('WARNING', 101);
define('ERROR', 102);
define('CRITICAL', 103);

function Msg_Die ( $code, $msg_text = '', $msg_title = NULL, $dienow = NULL )
{
	global $lang, $template;

	if (!isset($msg_text)) { $msg_text = $lang['err_unknown']; }

	if ($msg_title == NULL)
	{
		switch ($code)
		{
			case MESSAGE :
				$msg_title = 'zenet';
			break;
			case WARNING :
				$msg_title = 'Figyelmeztets';
				break;
			case ERROR :
				$msg_title = 'Hiba';
				break;
			case CRITICAL :
				$msg_title = 'Kritikus hiba';
				break;
		}
	}

	if (defined('MUADMIN')) { Msg_Die_Admin( $msg_title, $msg_text ); }

	if (($code == CRITICAL) || ($dienow == TRUE) || (!defined('TPLSYS_INITIALIZED')))
	{
		HeadeR('Content-type: text/html');

		Echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="hu" lang="hu">

<head>
	<title>'.MP_VER_NAME.'</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
</head>

<body>
<h1>&micro;Portal - '.$msg_title.'</h1>

<p>'.$msg_text.'</p>

</body></html>';

		global $conf;
		if ($conf['debug'] == 1) { include('mu-sys/includes/debug.php'); }

		Die();
	}
	else
	{
		$template->LoadFile('errormsg_body');

		switch ($template->currentbrd)
		{
			case 'left' :
			case 'right' :
				$template->UseTpl('panel_begin', array(
					'TITLE' => $msg_title
				));
				$template->UseTpl('errormsg_body', array(
					'TEXT'	=> $msg_text
				));
				$template->UseTpl('panel_end');
			break;
			case 'main' :
			case 'module' :
				if ($msg_title !== false) {
					$template->UseTpl('module_begin', array(
						'TITLE' => $msg_title
					));
				}

				$template->UseTpl('errormsg_body', array(
					'TEXT'	=> $msg_text
				));

				if ($msg_title !== false) {
					$template->UseTpl('module_end');
				}
			break;
		}
	}
}


/**************************************
 * Visszahivatkozs
 */
function muRedirect ( $url, $msg = '', $time = 3 )
{
	global $conf, $template, $lang, $user;

	if (!defined('MUADMIN')) {
		$user->SaveUserData();

		// Ha be van kapcsolva a hibakeres md
		if ($conf['debug'] == '1') {
			ob_start();
			include('mu-sys/includes/debug.php');
			$debug = ob_get_contents();
			ob_end_clean();
		} else {
			$debug = '';
		}
	} else {
		$debug = '';
	}

	$template->loadfile( 'redirect' );

	if ($msg != '') { $msg = '<p>'.$msg.'</p>'; }


	echo $template->PrepareTpl('redirect', array(
		'URL' 		 => $url,
		'MSG'		 => $msg,
		'TIME'		 => $time,
		'L_REDIRECT' => sprintf($lang['redirect'], str_replace( '&', '&amp;', $url ) ),
		'L_TITLE'	 => $conf['page_title'],
		'DEBUG'		 => $debug
	));


	if (!defined('MUADMIN')) {
		if (defined('GZIP_STARTED')) { GZIP_DONE(); }
	}

	die();

}


/******************************
 * Az Msg_Die() MiniAdmin vltozata (ELAVULT!)
 */
function Msg_Die_Admin( $msg_title, $msg_text )
{
	echo '<b>&micro;Portal MiniAdmin - '.$msg_title.'</b><br><br>'.$msg_text;
	Die();
}


/******************************
 * (ELAVULT!) 0.4.0-ben eltvoltand TODO!!
 */
function getStr ( $val, $res = '' )
{
	return (isset($val)) ? $val : $res;
}


/**************************************
 * Nyelvi adatok kikeresse (ELAVULT!)
 */
function GetLang( $lng = NULL )
{
	if (substr( $lng, 0, 1 ) == '$')
	{
		global $lang;
		return $lang[ substr( $lng, 1 ) ];
	} else {
		return $lng;
	}
}


/************************************
 * PHP Mailer belltsa
 */
function SetupMailer ()
{
	global $conf;

	require_once('mu-sys/includes/class.phpmailer.php');

	$mail = new PHPMailer();

	$from 			= $conf['smtp_from'];				// Felad email cme
	$from_name		= $conf['smtp_fromname'];			// Felad neve

	$mail->Mailer	= $conf['smtp_method'];				// SMTP szerver tpus
	$mail->Host		= $conf['smtp_host'];				// SMTP szerver cme (,-vel a msodlagost is megtudod adni)

	// Ha van SMTP Authentikci
	if ($conf['smtp_user'] != '') {
		$mail->SMTPAuth = true; 					// SMTP azonosts (true, false)
		$mail->Username = $conf['smtp_user'];		// SMTP felhasznlnv
		$mail->Password = $conf['smtp_pasw'];		// SMTP jelsz
	} else {
		$mail->SMTPAuth = false;					// SMTP azonosts (true, false)
	}

	$mail->From = $from;
	$mail->FromName = $from_name;
	$mail->AddReplyTo($from, $from_name);			// Falad (,-vel a nevt is meglehet adni)
	$mail->WordWrap = 75;

	if ($conf['smtp_html'] == 1) {					// Engedlyezi, hogy HTML formj lehessen a levl
		$mail->IsHTML(true);
	} else {
		$mail->IsHTML(false);
	}

	$mail->CharSet = $conf['smtp_charset'];			// Karakterkszlet

	return $mail;
}


/**************************************
 *
 */
function CreatePgSwitcher( $total, $curr, $fields_ar, $perpage = -1, $ad_lft = false, $ad_rgt = false )
{
	global $template, $conf;

	if ($perpage == -1) {
		$perpage = $conf['default_listlg'];
	}

	if (!is_numeric($perpage) || !is_numeric($total) || !is_numeric($curr)) {
		return false;
	}

	$template->LoadPackedFile('c_pageswitcher');

	$current = ceil( $curr / $perpage ) + 1;
	$all = floor( $total / $perpage ) + 1;

	$urlbase = 'index.php?';
	$fields = '';
	$minfield = 'min';

	foreach ( $fields_ar as $k => $v ) {
		if ($v == '{!}') {
			$minfield = $k;
		} else {
			$fields .= '<input type="hidden" name="'.$k.'" value="'.$v.'" />';
		}

		$urlbase .= $k.'='.$v.'&';
	}

	$urlbase = substr( $urlbase, 0, -1 );

	// Vissza gomb
	if ($current < 2) {
		$backbttn = $template->PrepareTpl( 'pageswitcher_prew_d' );
	} else {
		$backbttn = $template->PrepareTpl( 'pageswitcher_prew_a', array(
			'URL'	=> str_replace( '{!}', (($current-2)*$perpage), $urlbase)
		));
	}

	// Elre gomb
	if ($current >= $all) {
		$nextbttn = $template->PrepareTpl( 'pageswitcher_next_d' );
	} else {
		$nextbttn = $template->PrepareTpl( 'pageswitcher_next_a', array(
			'URL'	=> str_replace( '{!}', (($current)*$perpage), $urlbase)
		));
	}


	$pg = 0;
	$options = '';

	for ( $i = 0; $i < ($total); $i = $i + $perpage) {
		$pg++;

		$options .=
			'<option value="'.$i.'"'.
			(($pg == $current) ? ' selected="selected"' : '').
			'>'.$pg.'</option>';
	}

	// Ez mit keres itt?
	//$template->AddToStack('</select>');

	return $template->PrepareTpl('pageswitcher', array(
		'NO'		=> $current,
		'TOTAL'		=> $all,

		'PDFIELDS'	=> $fields,

		'MINFIELD'	=> $minfield,
		'FIELDS'	=> $options,

		'BACK'		=> $backbttn,
		'NEXT'		=> $nextbttn,

		'ALFT'		=> $ad_lft,
		'ARGT'		=> $ad_rgt,
	));

}


/**************************************
 * Vletlenszeen generl egy sztinget
 */
function getRandStr( $ln = 8 ) {
        return substr( str_shuffle('0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz'), 0, $ln );
}


/**************************************
 * Hrmas tagols s tizedesvessz
 */
function muNumFormat( $n, $v = 2 )
{
	global $lang;

	return number_format( $n, $v, $lang['dp'], $lang['art'] );
}


/******************************
 * Fjlmret tszmolsa
 */
function CalcSize($size)
{
	global $lang;

	if ( $size > 2199023255552 ) {
		return sprintf ("%01.2f",$size / 1099511627776) . ' '.$lang['tb'];
	} elseif ( $size > 2147483648 ) {
		return sprintf ("%01.2f",$size / 1073741824) . ' '.$lang['gb'];
	} elseif ( $size > 2097152 ) {
		return sprintf ("%01.2f",$size / 1048576) . ' '.$lang['mb'];
	} elseif ( $size >= 2048 )  {
		return sprintf ("%01.2f",$size / 1024) . ' '.$lang['kb'];
	} else {
		return $size . ' '.$lang['byte'];
	}
}


/**************************************
 * Rekuzvan vgrehajtja az addslashes fggvnyt
 * a tmb minden elemre
 */
function AddSlashesToArray( $arr )
{
	if (!is_array($arr)) {
		return $arr;
	}

	foreach ($arr as $k => $v) {
		$arr[$k] = (is_array($v)) ? AddSlashesToArray( $v ) : addslashes($v);
	}

	return $arr;
}


/**************************************
 * Ellenrzi, hogy megfelel-e a levl formtuma
 */
function is_email( $mailaddr )
{
	return preg_match( '#^[a-z0-9\.\-_\+]+?@(.*?\.)*?[a-z0-9\-_]+?\.[a-z]{2,4}$#i', $mailaddr );
}


/************************************
 * Szting megrvidtse, ha egy adott hosszsgot meghalad
 */
function StrTrunc( $str = '', $maxln = 40 )
{
	if (strlen($str) > $maxln) {
		return substr( $str, 0, $maxln).'...';
	} else {
		return $str;
	}
}


/**************************************
 *
 */
function Callback_MODAT_Text($arr)
{
	global $lang;

	return str_replace(
		array('!name', '!date'),
		array($arr[1], FormatDate($arr[2])),
		$lang['cmt_moderated']
	);
}

?>