<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM
 *
 ******************************************************************************************************************************************************
 *                               modules.php
 *                            -------------------
 *   kezds               : Htf, 2004. jlius 12.
 *   copyright            : (c) 2004-2006 muPortal Team
 *   email                : muportal@freemail.hu
 *   utoljra mdostva   : Vasrnap, 2007 mrcius 16.
 *   utoljra mdostotta : saxus
 *
 ******************************************************************************************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

/***************************************
 * Modulokat kezel osztly
 ***************************************/

class mods
{
	var $modules = array();			// Elrhet
	var $usemods = array( 2 => array(), 1 => array(), 3 => array() );
	var $count;

	/*************************
	 * Modulkezel ltrehozsa
	 */
	function mods( )
	{
		global $db, $conf, $sess;

		if (($conf['system_acc'] == 1) && (isset($sess['cache_mods']))) {

			$this->modules	= &$sess['cache_mods'];
			$this->count	= count($sess['cache_mods']);

		} else {

			// Teleptett modulok lekrdezse
			$db->sql_query('SELECT module, page FROM '.DBPREFIX.'modules WHERE panel=2' );

			while ( $row = $db->sql_fetch_array() )
			{
				$this->modules[$row['module']] = $row['page'];
			}

			if ($conf['system_acc'] == 1) {
				$sess['cache_mods'] = $this->modules;
			}

			$this->count = $db->sql_num_rows();
		}
	}

	/**************************
	 * Futtats
	 */
	function Execute()
	{
		global $template, $db, $conf, $user, $_page;

		define('MU_MODULES', true);

		$regmode = ($user->logined) ? 2 : 1;

		// Modulok lekrdezse
		// Lekrdezsi felttelek :
		// 1. Az oldal megegyezik a keresett oldallal VAGY az sszes oldallal ('*')
		// 2. Regisztrcitol fggetlen VAGY belpett felhasznl|vendg md
		$db->sql_query( 'SELECT id, module, panel FROM '.DBPREFIX.'modules
			WHERE
				( panel != 0 )
			AND
				( type=3 OR type='.$regmode.')
			AND
				( page=\''.$_page.'\' OR page=\'*\')
			ORDER BY position' );

		while ($row = $db->sql_fetch_array()) {
			$this->usemods[$row['panel']][] = $row;
		}

		// Template-k elksztse
		$template->LoadPackedFile('base');
		$template->LoadPackedFile('rows');
		$template->LoadPackedFile('standards');

		$template->NewStack();
		$this->Execute_Modules( 2 );
		$center = $template->GetStackContent();
		$template->DestroyStack();

		if (($conf['panels'] == 1) || ($conf['panels'] == 3)) {

			$template->NewStack();

			$this->Execute_Modules( 1 );

			$left = $template->GetStackContent();
			$template->DestroyStack();

		} else {
			$left = '';
		}

		if ($conf['panels'] > 1) {
			$right = $template->NewStack();

			$this->Execute_Modules( 3 );

			$right = $template->GetStackContent();
			$template->DestroyStack();
		} else {
			$right = '';
		}


		$template->UseTpl('base_center', array(
			'LEFT'		=> $left,
			'RIGHT'		=> $right,
			'CENTER'	=> $center
		));

	}

	/***************************
	 * Modulok futtatsa
	 */
	function Execute_Modules( $panel = false )
	{
		global $_page, $__page__, $__modid__, $get, $template, $lang, $user;

		if ( $panel !== false )
		{
			// Eredmnyek mentse, nehogy a meghvott panel/modul felllrja
			$__page__ = '';
			$__modid__ = -1;

			if ( count($this->usemods[ $panel ] ) == 0 ) {

				if ( $panel == 2 ) {
					$template->UseTpl('center_begin');
					Msg_Die( WARNING, $lang['invalid_mod'] );
					$template->UseTpl('center_end');
				} else {
					return false;
				}

			} else {

				if ($panel == 1) {
					$pname = 'left';
				} elseif ($panel == 3) {
					$pname = 'right';
				} else {
					$pname = 'center';
				}

				$template->UseTpl( $pname.'_begin' );

				// Modulok vgrehajtsa
				foreach ( $this->usemods[ $panel ] as $row )
				{
					if (isset($this->modules[ $row['module'] ])) {
						$__page__ = $this->modules[ $row['module'] ];
					} else {
						$__page__ = (isset($get['page'])) ? $get['page'] : '';
					}

					$__modid__ = $row['id'];

					if (file_exists('mu-sys/modules/'.$row['module'].'.php')) {
						include('mu-sys/modules/'.$row['module'].'.php');
					} else {
						Msg_Die( CRITICAL, 'Nem tallom a '.$row['module'].' fjlt!' );
					}
				}

				$template->UseTpl( $pname.'_end' );
			}
		}

		return true;
	}

	/**************************
	 * Modul futtatsa s kilp
	 */
	function LoadModule( $mod = NULL, $post = false )
	{
		if ( isset( $mod ) )
		{
			global $db, $user;

			// A regisztrlt tagnak megfelelen belltjuk az
			// SQL krst
			$regmode = ($user->logined) ? 2 : 1;

			// A megfelel rtk-kel keressk ki az adatbzisbl
			// a modult
			if ( defined('MU_POSTING') ) {
				$sql = 'module=\''.$mod.'\'';
			} else {
				$sql = 'page=\''.$mod.'\'';
			}

			// Megnzzk, hogy aktv-e az adott modul
			$db->sql_query( 'SELECT module FROM '.DBPREFIX.'modules WHERE '.$sql.' AND ( type = 3 OR type='.$regmode.') AND position>=0' );

			// Ha nem volt modul tallhat, akkor lelltjuk a script
			// futst...
			if ( $db->sql_num_rows() == 0 )
			{
				Msg_Die( CRITICAL, 'Nem tallom a(z) \''.$mod.'\' modult!' );
			}
			// Klnben betltjk a modult
			else
			{
				// Kiolvassuk az eredmnytmbl a modul fjlnevt.
				$row = $db->sql_fetch_array();
				$mod = $row['module'];

				// Eltroljuk, hogy az adott modul milyen oldalon jelenik meg
				global $__page__;
				$__page__ = $this->modules[ $mod ];

				// Ha post md aktv, akkor hozzrakjuk a '_post'
				// uttagot...
				if ( $post ) { $mod = $mod.'_post'; }

				// ... s meghvjuk a modult
				include( 'mu-sys/modules/'.$mod.'.php' );
			}
		}
		else
		{
			Die();
		}
	}
}

?>
