<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * Fjl                 : packages/packager.php
 * Kezds               : Pntek, 2006. augusztus 18.
 * Utoljra mdostva   : saxus; Sun Nov 12 14:05:16 CET 2006 14:05:16
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 

if (!defined('MUPORTAL')) { Die('File hacking!'); }

define('PM_INFO', 1);
define('PM_FILES', 2);
define('PM_TABLES', 3);
define('PM_CONFIG', 4);
define('PM_MODULES', 5);
define('PM_MENU', 6);
define('PM_MENUITEM', 7);
define('PM_SQL', 8);

define('PMM_MSG', 0);
define('PMM_BB', 1);
define('PMM_BE', 2);
define('PMM_ITEM', 3);


/**************************************
 * Egy csomagfjl rtelmezse
 * TODO: Dokumentland a cosmagfjl formtuma!!!
 */
function pm_parse_package_file( $fname )
{
	$file = 'mu-sys/packages/'.$fname;
	if (!file_exists($file)) {
		return false;
	}
	
	$str = @fread( @fopen($file, 'r') , @filesize($file) ); 
	
	if ($str == '') {
		return false;
	}
	
	$str = explode("\n", $str );
	
	if (!is_array($str)) {
		return false;
	}
	
	$info = array();
	$files = array();
	$tables = array();
	$config = array();
	$modules = array();
	$menu = array();
	$menuitems = array();
	$sql = array();
	
	
	$__panels = array(
		'hide'	=> 0,
		'panel'	=> 1,
		'left'	=> 1,
		'right'	=> 3,
		'center'=> 2,
	);
	
	$__usrmode = array(
		'all'	=> 3,
		'vis'	=> 1,
		'reg'	=> 2, 
	);
	
	$__usrmode_mnu = array(
		'all'	=> 0,
		'vis'	=> 1,
		'reg'	=> 2, 
		'adm'	=> 3,
		'hide'	=> -1,
	);
	
	//foreach ($str as $r)
	while (list(,$r) = each($str))
	{		
		if (strpos($r,"\t") !== false) {
			$r = explode("\t",$r);
		} else {
			$r = array(
				0 => trim($r)
			);
		}
		
		switch ($r[0]) {
			case 'info' : {
				$info[$r[1]] = trim($r[2]);
				break;
			}
			case 'conf' : {
				$config[$r[1]] = trim($r[2]);
				break;
			}
			case 'file' : {
				$files[] = trim($r[1]);
				break;
			}
			case 'table' :
			case 'sql' :
			{
				if ($r[0] == 'table') {
					$name = trim($r[1]);
					$tables[$name] = '';
					$d = &$tables[$name];
				} else {
					$mode = (isset($r[1])) ? $r[1] : 'sql';
					$s = '';
					$d = &$s;
					$sql[] = array(
						0	=> '',
						1 	=> $mode
					);
					$d = &$sql[count($sql)-1][0];
				}
				
				do {
					list(,$r) = each($str);
					$r = trim($r);
					if ($r != '}}}') {
						$r = trim($r);
						$d .= $r."\n";
					}
				} while ($r != '}}}');				
				break;
			}
			case 'menu' :
			case 'module' : {
				$name = trim($r[1]);
				if ($r[0] == 'module') {
					$modules[$name] = array(
						'panel'	=> 2,
						'pos'	=> 0,
						'type'	=> 3,
						'page'	=> '*',
						'desc'	=> 'Nincs lers',
					);
					$d = &$modules[$name];
				} else {
					$menu[$name] = array(
						'panel'	=> 1,
						'pos'	=> 0,
						'type'	=> 3,
						'page'	=> '*',
						// 'desc'	=> 'Nincs lers',
					);
					$d = &$menu[$name];					
				}
		
				do {
					list(,$r) = each($str);
					$r = trim($r);
					if ($r != '}}}') {
						$r = explode("\t",trim($r));
						switch ($r[0]) {
							case 'panel' : {
								$d[$r[0]] = $__panels[$r[1]];
								break;
							}
							case 'type'	: {
								$d[$r[0]] = $__usrmode[$r[1]];
								break;
							}
							default : {
								$d[$r[0]] = $r[1];
								break;
							}
						}
						
					}
				} while ($r != '}}}');
				
				break;
			}
			case 'menuitem' : {
				$name = trim($r[1]);
				$menuitems[$name] = array(
					'menu'	=> false,
					'pos'	=> 0,
					'type'	=> 0,
					'url'	=> '',
				);
				$d = &$menuitems[$name];
		
				do {
					list(,$r) = each($str);
					$r = trim($r);
					if ($r != '}}}') {
						$r = explode("\t",trim($r));
						switch ($r[0]) {
							case 'type'	: {
								$d[$r[0]] = $__usrmode_mnu[$r[1]];
								break;
							}
							default : {
								$d[$r[0]] = $r[1];
								break;
							}
						}
						
					}
				} while ($r != '}}}');
				
				break;
			}
		}
	}
	
	return array(
		PM_INFO		=> $info,
		PM_FILES	=> $files,
		PM_TABLES	=> $tables,
		PM_CONFIG	=> $config,
		PM_MODULES	=> $modules,
		PM_MENU		=> $menu,
		PM_MENUITEM	=> $menuitems,
		PM_SQL		=> $sql,
	);
	

}

/**************************************
 * Csomagtelept
 */
class pm_installer
{
	var $packages = array();
	var $packreg = array();
	
	var $tables = array();
	var $config = array();
	var $modules = array();
	var $menus = array();
	var $menuitems = array();
	var $sql = array();
	
	var $dir = '';
	var $curpack = '';
	var $menus_exists = array();
	
	/**************************************
	 * Constructor
	 */
	function pm_installer( $d = 'mu-sys/packages/' )
	{
		$this->dir = $d;
	}
	
	/**************************************
	 * Naplzs
	 */
	function errorlog( $msg, $type = E_USER_NOTICE )
	{
		trigger_error( MP_VER_NAME.' v'.MP_VER_NUM.' telept: '.$msg.' (Csomagfjl: '.$this->curpack.')', $type);
	}
	
	/**************************************
	 * Csomag rtelmezse, teleptsi adatok
	 * ltrehozsa
	 */
	function addpackage( $filename )
	{
		// Ha mr rtelmezve lett, nem csinlunk semmit.
		if (in_array( $filename, $this->packages )) {
			return false;
		}

		// Fjl rtelmezse
		$package = pm_parse_package_file( $filename );
		
		$this->curpack = $filename;
		
		if (!is_array($package)) {
			return false;
		}
		
		// Tbla adatok mentse
		foreach ($package[PM_TABLES] as $name => $code ) {
			if (isset($this->tables[$name])) {
				$this->errorlog( 'Tbla duplikci ('.$name.')' );
			}
			$this->tables[$name] = $code;
		}

		// Belltsok mentse		
		foreach ($package[PM_CONFIG] as $name => $value ) {
			if (isset($this->config[$name])) {
				$this->errorlog( 'Bellts duplikci ('.$name.' => '.$value.')' );
			}
			$this->config[$name] = $value;
		}
		
		// Modulok mentse
		foreach ($package[PM_MODULES] as $name => $value ) {
			if (isset($this->modules[$name])) {
				$this->errorlog( 'Modul duplikci ('.$name.')' );
			}
			$this->modules[$name] = $value;
		}
		
		// Ha mr teleptve van a muPortal, lekrdezzk a jelenlegi menk listjt
		/*if (defined('MUPORTAL_INSTALLED')) {
			global $db;
			
			$db->sql_query('SELECT id, description FROM '.DBPREFIX.'modules WHERE module=\'p_menumgr\'');
			
			while ($row = $db->sql_fetch_array()) {
				$this->menus_exists[ $row['description'] ] = $row['id'];
			}
		}*/
		
		// Menk mentse
		foreach ($package[PM_MENU] as $name => $value ) {
			if (isset($this->menus[$name])) {
				$this->errorlog( 'Men duplikci ('.$name.')' );
			}
			$this->menus[$name] = $value;
		}
		
		// Menelemek mentse
		foreach ($package[PM_MENUITEM] as $name => $value ) {
			if (isset($this->menuitems[$name])) {
				$this->errorlog( 'Menelem duplikci ('.$name.')' );
			}
			if (isset($this->menus[$value['menu']])) {
				//$value['menu'] = $this->menus[$value['menu']];
				$this->menuitems[$name] = $value;
			} else {
				$this->errorlog( 'Hinyz men, menelem eldobva ('.$value['menu'].'; '.$name.')', E_USER_WARNING );
			}
		}
		
		// Egyb SQL krsek vgrehajtsa
		foreach ($package[PM_SQL] as $v ) {
			$this->sql[] = $v;
		}		
		
		// Megjegyezzk, hogy mr feldolgoztuk
		$this->packages[] = $filename;
		
		// Regisztrland modulok feljegyzse
		$this->packreg[$package[PM_INFO]['package']] = $package[PM_INFO]['version'];
		
		return;
	}
	
	/**************************************
	 * zenet kirsa
	 */
	function message( $type = PMM_MSG, $text = '' )
	{
		switch ($type) {
			case PMM_MSG : {
				echo '<p>'.$text.'</p>';
				break;
			}
			case PMM_BB : {
				if ($text !='') { echo '<h3>'.$text.'</h3>'; };
				echo '<ul>';
				break;
			}
			case PMM_BE : {
				echo '</ul>';
				if ($text !='') { echo '<p>'.$text.'</p>'; };

				break;
			}
			case PMM_ITEM : {
				echo '<li>'.$text.'</li>';
				break;
			}
		}
	}
	
	/**************************************
	 * Telepts vgrehajtsa
	 */
	function install()
	{
		global $db, $conf;
		
		$conf['debug'] = 1;

		// Tblk ltrehozsa
		$this->message( PMM_BB, 'Tblk ltrehozsa' );
		foreach ($this->tables as $name => $cols) {
			$db->sql_query('CREATE TABLE '.DBPREFIX.$name.' ('.$cols.')');
			$this->messagE( PMM_ITEM, DBPREFIX.$name.'... ksz.' );
		}
		$this->message( PMM_BE );
		
		// Belltsok beillesztse
		$this->message( PMM_BB, 'Belltsok ltrehozsa' );
		$tmp = 0;
		foreach ($this->config as $name => $value) {
			$db->sql_query('INSERT INTO '.DBPREFIX.'config (name, value) VALUES (\''.$name.'\', \''.$value.'\')');
			$tmp++;
		}
		$this->message( PMM_ITEM, 'Ksz, '.$tmp.' bellts hozzadva.');
		$this->message( PMM_BE );
		
		// Modulok teleptse
		$this->message( PMM_BB, 'Modulok teleptse' );
		foreach ($this->modules as $name => $v) {
			$db->sql_query(sprintf('INSERT INTO '.DBPREFIX.'modules
				(position, panel, type, page, module, description)
			VALUES
				(%d, %d, %d, \'%s\', \'%s\', \'%s\')',
				$v['pos'], $v['panel'], $v['type'], $v['page'], $name, $v['desc']
			));
			$this->message( PMM_ITEM, $name.'... Ksz.' );
		}
		$this->message( PMM_BE );

		// Menk teleptse
		$this->message( PMM_BB, 'Menk ltrehozsa' );
		foreach ($this->menus as $name => $v) {
			$db->sql_query(sprintf('INSERT INTO '.DBPREFIX.'modules
				(position, panel, type, page, module, description)
			VALUES
				(%d, %d, %d, \'%s\', \'p_menumgr\', \'%s\')',
				$v['pos'], $v['panel'], $v['type'], $v['page'], $name
			));
			$this->menus_exists[ $name ] = $db->sql_insert_id();
			$this->message( PMM_ITEM, $name.'... Ksz.');
		}
		$this->message( PMM_BE );
		
		// Menelemek ltrehozsa
		$this->message( PMM_BB, 'Menelemek hozzadsa' );
		$tmp = 0;
		foreach ($this->menuitems as $name => $v) {
			if (isset($this->menus_exists[ $v['menu'] ])) {
				
				$v['menu'] = $this->menus_exists[ $v['menu'] ];
				
				$db->sql_query(sprintf('INSERT INTO '.DBPREFIX.'menus_items
					(modid, position, regmode, title, url)
				VALUES
					(%d, %d, %d, \'%s\', \'%s\')',
					$v['menu'], $v['pos'], $v['type'], $name, $v['url']
				));
				
				$tmp++;
			} else {
				$this->errorlog('Nem tallom a(z) ('.$v['menu'].') ment! Menelem ('.$name.') kihagyva!', E_USER_WARNING );
			}
		}
		$this->message( PMM_ITEM, 'Ksz, '.$tmp.' menelem hozzadva.');
		$this->message( PMM_BE );
		
		// Egyb SQL krsek vgrehajtsa
		$this->message( PMM_BB, 'Egyb SQL krsek vgrehajtsa');
		$tmp = 0;
		foreach ($this->sql as $s) {
			if ($s[1] == 'sql') {
				$db->sql_query(str_replace('{DBPREFIX}', DBPREFIX, $s[0]));
			} else {
				eval( $s[0] );
			}
			$tmp++;
		}
		$this->message( PMM_ITEM, 'Ksz, '.$tmp.' SQL krs vgrehajtva.');
		$this->message( PMM_BE );
		
		// Csomagok regisztrlsa
		$this->message( PMM_BB, 'Csomagok regisztrlsa');
		$tmp = 0;
		foreach ($this->packreg as $name => $ver) {
			$db->sql_query('INSERT INTO '.DBPREFIX.'packages (package, version, installdate)
				VALUES (\''.$name.'\', \''.$ver.'\', '.time().')');
			$tmp++;
		}
		$this->message( PMM_ITEM, 'Ksz, '.$tmp.' csomag regisztrlva.');
		$this->message( PMM_BE );
	}
}

?>