<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM
 *
 ***************************************************************************
 *                               sessions.php
 *                            -------------------
 *   utoljra mdostva   : Vasrnap, 2004. oktber 31.
 *   copyright            : (c) 2004-2006 muPortal Team
 *   email                : muportal@freemail.hu
 *   utoljra mdostva   : Szombat, 2006. november 12.
 *   utoljra mdostotta : saxus
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/ 
 
if (!defined('MUPORTAL')) { die('File hacking'); }

/***************************
 * j azonostsi mdszer.
 * A rgi verzi azonostsi s hitelestsi rendszere knnyen kijtszhat
 * volt. Az j verzi minden ltogathoz hozzrendel egy azonost kulcsot
 * (authkey) Ezt minden oldalletltskor ellenrzi. A kulcson kvl
 * ellenrzi mg az IP cmet s a bngsz User-agentjt is. 
 */
function muSession_Init( )
{
	global $conf, $lang;
	
	// Session init
	session_start();
	Header('Cache-Control: cache');
	define('SESSID', session_id());
	
	if (isset($_SESSION[ 'muSess_'.$conf['security_key'] ]) && (muIssetCookie('authkey'))) {
	
		$GLOBALS['sess'] = &$_SESSION[ 'muSess_'.$conf['security_key'] ];
		
		$auth = muSessions_AuthUser();
	
		if ($auth != 0) {
			unset($_SESSION[ 'muSess_'.$conf['security_key'] ]);
			Msg_Die( CRITICAL, $lang['system_sessfail_'.$auth]."\n\n".
				sprintf($lang['system_fail_link'], 'index.php?'.$_SERVER['QUERY_STRING'] ) );
		}			
		$res = true;
		
	} else {
		
		$_SESSION[ 'muSess_'.$conf['security_key'] ] = muSessions_CreateAuthData();
		$GLOBALS['sess'] = &$_SESSION[ 'muSess_'.$conf['security_key'] ];
		
		$res = false;	
	}	
		
	return $res;
}

/**************************************
 * Azonost s kezdeti adatok ltrehozsa, ha mg nincs.
 */
function muSessions_CreateAuthData ()
{
	global $conf;
	
	$authkey = md5($conf['security_key']).'-'.md5( GetRandStr(255) );
	
	muSetCookie( 'authkey', $authkey, $conf['security_aklifetime']*60 );
	
	$res = array(
		'authkey'	=> $authkey,
		'ipaddr'	=> md5(USER_IP),
		'usragnt'	=> md5($_SERVER['HTTP_USER_AGENT']),
	);
	
	return $res;
}

/**************************************
 * Ellenrizzk, hogy a mr meglv azonost-kulcs 
 * megegyezik-e a sessionban trolt kulcsal.
 */
function muSessions_AuthUser ()
{
	global $conf, $sess;	

	$authkey = muGetCookie('authkey');
	muSetCookie( 'authkey', $authkey, $conf['security_aklifetime']*60 );

	// Azonost kulcs
	if ($sess['authkey'] != $authkey) { return 1; }
	if ($sess['ipaddr'] != md5(USER_IP)) { return 2; }
 	if ($sess['usragnt'] != md5($_SERVER['HTTP_USER_AGENT'])) { return 3; }
	
	return 0;
}




/**************************************
 * Sti belltsa
 */
function muSetCookie( $name, $value, $time)
{
	global $conf;
	
	$conf['cookie_domain'] = strtolower(trim($conf['cookie_domain']));
	if (($conf['cookie_domain'] != '') && ($conf['cookie_domain'] != 'localhost') && ($conf['cookie_domain'] != '127.0.0.1')) {
		
		if (substr($conf['cookie_path'], -1, 1) != '/') {
			$conf['cookie_path'] .= '/';
		}
		
		SetCookie( $conf['cookie_name'].'['.$name.']', $value, time() + $time, 
			$conf['cookie_path'], $conf['cookie_domain'] );
		
	} else {
		SetCookie( $conf['cookie_name'].'['.$name.']', $value, time() + $time );
	}
}

/**************************************
 * Sti rtknek lekrdezse
 */
function muGetCookie( $name, $default = false )
{
	global $conf;
	
	return (isset($_COOKIE[$conf['cookie_name']][$name] )) 
		? $_COOKIE[$conf['cookie_name']][$name] : $default;
}

/**************************************
 * Sti megltt vizsglja
 */
function muIssetCookie( $name )
{
	global $conf;
	
	return (isset($_COOKIE[$conf['cookie_name']][$name] ));
}

/**************************************
 * Sti trlse
 */
function muRmCookie ( $name )
{
	muSetCookie( $name, false, -3600 );	
}

?>