<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2007 muPortal Team
 *******************************************************************************
 * Fjl                 : includes/sql-mysql.php
 * Kezds               : Pntek, 2004. jlius 12.
 * Utoljra mdostva   : saxus; 2007. prilis 4
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

/***************************************
 * sql kezel osztly
 *
 * Megolds alaptlete, s egyes kdrszletek
 * a php-BB-bl szrmaznak.
 * http://www.phpbb.com
 ***************************************/

class sql_db
{
	var $connect;
	var $res;
	var $querys = 0;
	var $debug = array();

	/************
	 * SQL kezel osztly ltrehozsa
 	 */
	function sql_db ( $dbcfg = NULL )
	{
		if ( isset( $dbcfg ) && is_array( $dbcfg ) )
		{
			// Megnzzk, hogy meg van-e adva bellts (korbbi verzival val kompatibilits)
			$this->persistency = (isset($dbcfg['db_persistency'] )) ? $dbcfg['db_persistency'] : false;

			$this->connect =  ($this->persistency == true) ?
				@mysql_pconnect( $dbcfg['db_server'], $dbcfg['db_user'], $dbcfg['db_pasw'] )
					or $this->_connect_error() :
				@mysql_connect( $dbcfg['db_server'], $dbcfg['db_user'], $dbcfg['db_pasw'] )
					or $this->_connect_error();

			@mysql_select_db( $dbcfg['db_name'], $this->connect ) or $this->_dbselect_error();
		} else {
			Msg_Die(CRITICAL, 'Hibs adatbzisadatok!');
		}

		define('SQL', 'MySQL');

		define('SQL_ASSOC', MYSQL_ASSOC);
		define('SQL_BOTH', MYSQL_BOTH);
		define('SQL_NUM', MYSQL_NUM);
	}

	/**
	 * Kapcsoldsi hiba lekezelse
	 */
	function _connect_error()
	{
		global $conf;

		if ($conf['debug'] == 1) {

			$q = sprintf(
				'Kapcsolat tpusa: %s',
				(($this->persistency) ? 'Perzisztens' : 'Norml')
			);
			$t = 'Nem tudok csatlakozni az adatbzisszerverhez!';
		} else {
			$q = 'Nem tudok csatlakozni az adatbzisszerverhez!';
			$t = NULL;
		}

		Msg_Die( CRITICAL, $q, $t );
	}


	/**
	 * Adatbzis-kivlasztsi hiba lekezelse
	 */
	function _dbselect_error()
	{
		global $conf;

		if ($conf['debug'] == 1) {
			$q = sprintf( '<p>%s: %s</p>',
				@mysql_errno($this->connect),
				@mysql_error($this->connect)
			);
			$t = 'Nem tudom megnyitni az adatbzist!';
		} else {
			$q = 'Nem tudom megnyitni az adatbzist!';
			$t = NULL;
		}

		Msg_Die( CRITICAL, $q, $t );
	}

	/************
	 * SQL kapcsolat lezrsa
 	 */

	function sql_close ()
	{
		if ($this->connect) { @mysql_free_result($this->res); }
		@mysql_close($this->connect);
	}

	/**
	 * SQL hiba lekezelse
	 */
	function _query_error( $query = '' )
	{
		global $conf;

		if ($conf['debug'] == 1) {

			$q = sprintf(
				'<p><b>SQL Krs: </b><p>
				<hr />
				<p><pre>%s</pre></p>
				<hr />

				<p>%s: %s</p>', $query,
				@mysql_errno($this->connect),
				@mysql_error($this->connect)
			);
			$t = 'Hiba az SQL Krsben!';
		} else {
			$q = 'Hiba az SQL krsben!';
			$t = NULL;
		}

		Msg_Die( CRITICAL, $q, $t );
	}


	/**
	 * SQL krs vgrehajtsa
 	 */
	function sql_query( $query = '' )
	{
		global $conf;

		unset($this->res);

		if($query != '')
		{
			$this->res = @mysql_query($query, $this->connect) or $this->_query_error( $query );
			$this->querys++;

			if ($conf['debug']==1) {
				$this->sql_query_debug($query);
			}
		}
	}

	/**
	 * Egy string escapelse a kapcsolatnak megfelelen
	 */
	function sql_escape( $msg )
	{
		return @mysql_real_escape_string( $msg, $this->connect );
	}


	/**
	 * SQl krs naplzsa, ha kell
	 */
	function sql_query_debug ( $query )
	{
		$this->debug[] = array(
			'sql'	=> 	$query,
			'info'	=> mysql_info($this->connect)
		);
	}


	/**
	 * Lekrdezett sorok szma
	 */
	function sql_num_rows ()
	{
		return @mysql_num_rows( $this->res );
	}


	/**
	 * rintett sorok szma
	 */
	function sql_affected_rows ()
	{
		return @mysql_affected_rows( $this->connect );
	}


	/**
	 * Egy sor lekrse az SQL eredmnytmbbl
 	 */
	function sql_fetch_array( $res = NULL, $type = SQL_ASSOC )
	{
		if (isset($res)) {
			return @mysql_fetch_array( $res, $type );
		} else {
			if (isset($this->res)) {
				return @mysql_fetch_array( $this->res, $type );
			} else {
				return false;
			}
		}
	}


	/**
	 * Lekrdezi az utols mdostott sor id-jt
	 */
	function sql_insert_id ()
	{
		// FIGYELMEZTETS! Nem javasolt ez a mdszer, ha a bigint
		// tpus ID-t hasznlsz!!!
		return @mysql_insert_id( $this->connect );
	}


	/**
	 * tmb beillesztse egy tblba
	 */
	function sql_insert_array( $tablename, $array = array())
	{
		$names = '';
		$values = '';

		foreach ($array as $k => $v) {
			$names .= mysql_escape_string($k).',';
			$values .= '\''.mysql_escape_string($v).'\',';
		}

		$names = substr($names, 0, -1);
		$values = substr($values, 0, -1);

		$this->sql_query(sprintf('INSERT INTO %s (%s) VALUES (%s)',
			DBPREFIX.$tablename, $names, $values ));
	}


	/**
	 * Tbla frisstse tmb alapjn
	 */
	function sql_update_array( $tablename, $array = array(), $where = false, $escape = true )
	{
		$update = '';
		foreach ($array as $k => $v) {
			$update .= $k.'='.(($escape) ? '\''.mysql_escape_string($v).'\'' : $v).',';
		}
		$update = substr($update, 0, -1);

		if ($where !== false) {
			$update .= ' WHERE '.$where;
		}

		$this->sql_query(sprintf('UPDATE %s SET %s',
			DBPREFIX.$tablename, $update
		));
	}
}

?>