<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM
 *
 ***************************************************************************
 *                               templates.php
 *                            -------------------
 *   copyright            : (c) 2004-2007 muPortal fejlesztk
 *   website              : http://muportal.hu
 *	 id : $Id:$
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

/*****************************
 * Template osztly
 *
 * Megolds alaptlete, s egyes kdrszletek
 * a php-BB-bl szrmaznak.
 * http://www.phpbb.com
 *****************************/

class template
{
	var $_tpl = array();		// Mintk
	var $_loadedtpx = array();	// Betlttt Csomagolt template-k
	var $_tpldata;				// Kirand template-k
	var $stack = -1;				// Aktulis
	var $basestack = 1;			// Alap verem
	var $basedir = '';			// Alap knyvtr
	var $_replaces = array();	// Alaprtelmezett cserk

	var $RSSFeed = array();		// RSS Feed-k
	var $CurrentBrd;			// Aktulis keret

	/******************************
	 * Constructor
	 */
	function template()
	{
		global $conf;

		// Mintarendszer inicializlsa
		if (!file_exists('mu-sys/'.$conf['system_theme'])) {
			$conf['system_theme'] = 'tpl-base';
		}

		$this->currentbrd = 'main';
		$this->basedir = 'mu-sys/'.$conf['system_theme'].'/';
		$this->_replaces = array();

		$this->_tpldata = array( 0 => '', 1 => '' );
		$this->stack = 1;

		$this->TplConf['panel_differ'] = false;

		define('TPLSYS_INITIALIZED', true);
	}

	/******************************
	 * j verem ltrehozsa
	 */
	function NewStack()
	{
		$this->stack++;
		$this->_tpldata[ $this->stack ] = '';
		return $this->stack;
	}

	/*****************************
	 * Megsznteti az utols vermet
	 */
	function DestroyStack()
	{
		unset( $this->_tpldata[ $this->stack ] );
		$this->stack--;
	}

	/******************************
	 * Visszatr a verem tartalmval
	 */
	function GetStackContent()
	{
		return $this->_tpldata[ $this->stack ];

	}

	/******************************
	 * Hozzadja a veremhez
	 */
	function AddToStack( $cnt )
	{
		$this->_tpldata[ $this->stack ] .= $cnt;
	}

	/*******************************
	 * Fjlok hozzadsa a fjllisthoz
	 */
	function LoadFile ( $handle = NULL, $filename = NULL )
	{
		if (!isset($handle)) { return false; }

		if (!isset($filename)) { $filename = $handle; }

		if (isset( $this->_tpl[$handle] ) ) { return false; }

		$file = $this->basedir.$filename.'.tpl';

		// Fjl ltezsnek ellenrzse
		if (!file_exists($file)) {
			Msg_Die( CRITICAL, 'Template->LoadFile(): Nem tallom a \''.$file.'\' fjlt!');
		}

		// Fjl betltse
		$str = @fread( @fopen($file, 'r') , @filesize($file) );

		// Eltrols
		$this->_tpl[$handle] = $str;

		return true;
	}

	/*******************************
	 * Csomagolt template fjlok betltse
	 */
	function LoadPackedFile( $filename )
	{
		if (!isset($filename)) { return false; }

		// Csak egyszer tltjnk be egy-egy mintacsomagot
		if (in_array( $filename, $this->_loadedtpx )) { return true; }

		$file = $this->basedir.$filename.'.tpx';

		// Fjl ltezsnek ellenrzse
		if (!file_exists($file)) { Msg_Die( CRITICAL, 'Template->LoadPackedFile(): Nem tallom a \''.$file.'\' fjlt!'); }

		// Fjl betltse
		$tpl = @fread( @fopen($file, 'r') , @filesize($file) );

		// Specilis jelek szrse
		$tpl = str_replace('\\', '\\\\', $tpl);
		$tpl  = str_replace('\'', '\\\'', $tpl);
		$tpl  = str_replace("\n", '', $tpl);

		// PHP Kdot ksztnk a mintkbl...
		$tpl = preg_replace('#<!-- BEGIN (.*?) -->(.*?)<!-- END (.*?) -->#', "\n" . '$this->_tpl[\'\\1\'] = \'\\2\';', $tpl);

		// Vgrehajtuk azt
		eval($tpl);

		unset($tpl);

		$this->_loadedtpx[] = $filename;

		return true;
	}

	/*********************************
	 * Elkszt egy Mintt
	 */
	function PrepareTpl( $handle = NULL, $replace = NULL )
	{
		if (!isset($handle)) { Msg_Die( ERROR, 'Template->PrepareTpl(): Nincs megadva a minta neve!');	}

		if (!isset($this->_tpl[ $handle ])) {
			Msg_Die( CRITICAL, 'Template->PrepareTpl(): Nem tallom a \''.$handle.'\' mintt!');
		}

		$temp = $this->_tpl[$handle];

		// Kicserljk a szksges dolgokat
		if (isset($replace) && is_array($replace))
		{
			$replace += $this->_replaces;

			foreach ($replace as $k => $v) {
				$temp = str_replace( '{'.$k.'}' , $v, $temp);
			}
		}

		return $temp;
	}

	/*********************************
	 * Mintkat berakja a trltmbbe
	 */
	function UseTpl( $hnd = NULL, $rpl = NULL )
	{
		// Megjegyzs: gy gyorsabb, mintha az ob_start()-tal oldottam volna meg.
		// Igen, n is meglepdtem -- saxus

		if ( $hnd == '#ECHO' ) {
			$this->_tpldata[ $this->stack ] .= $rpl;
		} else {
			$this->_tpldata[ $this->stack ] .= @$this->PrepareTpl( $hnd, $rpl );
		}
	}

	/*********************************
	 * Valdi kirs megkezdse
	 */
	function Execute()
	{
		echo $this->_tpldata[ $this->basestack ];

	}

	/**************************************
	 * RSS Feed hozzadsa
	 */
	function AddRSSFeed( $title = '', $link = '' )
	{
		global $conf;
		
		$title = trim($title);
		$link  = trim($link);

		if ($conf['rss_enable'] == 1) {
			if (!isset($this->RSSFeed[$link])) {
				$this->RSSFeed[$link] = $title;
			}
		}
	}
	
	/**************************************
	 * 
	 */
	function GenerateRSSFeeds()
	{
		$res = '';
		foreach ($this->RSSFeed as $link => $title) {
			$res .= '<link rel="alternate" type="application/rss+xml" title="'.$title.'" href="rss.php?'.$link.'" />'."\n\t";
		}
		return $res;				
	}


	/*********************************
	 * Keret betltse
	 */
	function Border_Load()
	{
		$this->LoadPackedFile( 'panel' );
	}

	/*********************************
	 * Keret kezdtete
	 */
	function Border_Begin( $replace = NULL )
	{
		$this->UseTpl( 'panel_begin', $replace );
	}

	/*********************************
	 * Keret vge
	 */
	function Border_End( $replace = NULL )
	{
		$this->UseTpl( 'panel_end', $replace );
	}
}

/*****************************************************************************
 *
 *                             M O S O L Y O K
 *
 *****************************************************************************/

/*****************************
 * Mosolykezel osztly
 *****************************/
class smilies
{
	var $codes = array();
	var $repl = array();

	function smilies()
	{
		global $sess;

		if (isset($sess['smilies_repl']) && isset($sess['smilies_codes'])) {

			$this->codes = &$sess['smilies_codes'];
			$this->repl = &$sess['smilies_repl'];
			$this->count = count($this->codes);

			define('SMILIES_LOADED', true);
		}
	}

	/*********************************
	 * mosolylista ltrehozsa
 	 */
	function LoadSmilies()
	{
		if (!defined('SMILIES_LOADED'))
		{
			global $db, $template, $sess, $conf;

			// Elrhet mosolyok lekrdezse
			$db->sql_query( 'SELECT code, url FROM '.DBPREFIX.'smilies' );

			$this->count = 0;

			// Mosolyok eltrolsa
			while ($row = $db->sql_fetch_array() )
			{
				$this->codes[] = $row['code'];
				$this->repl[] = '<img src="'.$template->basedir.'smilies/'.$row['url'].'" height="15" width="15" border="0" alt="'.$row['code'].'" />';
			}

			// cacheles

			if ($conf['system_acc'] == 1) {
				$sess['smilies_codes'] = $this->codes;
				$sess['smilies_repl'] = $this->repl;
			}

			$this->count = count($this->codes);

			define('SMILIES_LOADED', true);
		}

	}

	/*********************************
	 * megformzz egy szveget a mosolylista
	 * alapjn
 	 */
 	function UseSmilies( $text )
 	{
 		if (!defined('SMILIES_LOADED')) { $this->LoadSmilies(); }

		return ($this->count != 0) ? str_replace( $this->codes, $this->repl, $text ) : $text;
 	}
}


?>