<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $id$
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 

 
if (!defined('MUPORTAL')) { die('File hacking'); }


define('USR_GUEST', -255);
define('USR_DISABLED', -2);
define('USR_UNACTIVATED', -1);
define('USR_USER', 0);
define('USR_ADMIN', 1);
define('USR_MODERATOR', 2);

define('LOGIN_OK', 0);
define('LOGIN_PWERR', 1);
define('LOGIN_DISABLED', 2);
define('LOGIN_UNACTIVATED', 3);


class user 
{

	var $userdata = array();
	var $userdata_updates = array();
	var $permissions = USR_GUEST;
	var $logined = false;
	var $userid = 0;
	var $savereq = false;

	function user() 
	{
		global $sess, $lang;
		
		$logined = (isset($sess['usr_logined'])) ? $sess['usr_logined'] : false;
		
		if ($logined !== false) {
			if ($this->AuthUser()) {

				$this->userdata = &$sess['userdata'];
				$this->permissions = $this->userdata['permissions'];
				$this->userid = $this->userdata['id'];
				
				if (($this->permissions != USR_GUEST) &&
					($this->permissions != USR_DISABLED) &&
					($this->permissions != USR_UNACTIVATED)) 
				{
					$this->logined = true;

					if (($this->permissions == USR_MODERATOR) && !defined('MUADMIN')) {
						$this->permissions = USR_ADMIN;
					}
				} else {
					$this->logined = false;
					$this->LogoutUser();
				}
			} else {
				
				$this->LogoutUser();
				Msg_Die( 
					CRITICAL, 
					$lang['system_authfail1']."<br /><br />".
					sprintf($lang['system_fail_link'], 'index.php?'.$_SERVER['QUERY_STRING'] )
				);
			}
		}
	}	
	
	
	/**************************************
	 * Felhasznl bejelentkeztetse
	 */
	function LoginUser( $name = '', $pasw = '' )
	{
		global $db, $sess;
		
		$name = $db->sql_escape(trim($name));
		$pasw = trim($pasw);
		
		$db->sql_query('SELECT * FROM '.DBPREFIX.'users WHERE 
			name=\''.$name.'\' AND
			pasw=\''.md5($pasw).'\' LIMIT 1');
		
		if ($db->sql_num_rows() == 0) {
			return LOGIN_PWERR;
		}

		$row = $db->sql_fetch_array();
		//unset($row['pasw']);
		
		if ($row['permissions'] == USR_DISABLED) {
			return LOGIN_DISABLED;
		} elseif ($row['permissions'] == USR_UNACTIVATED) {
			return LOGIN_UNACTIVATED;
		}
		
		$id = $row['id'];
		$sess['userdata'] = $row;
		$sess['userid'] = $id;
		$sess['usr_logined'] = md5( $row['id'].$row['name'].$sess['authkey'] );
		$this->userdata = &$sess['userdata'];
		$this->userdata_backup = $this->userdata;
		$this->permissions = $row['permissions'];
		$this->logined = true;
		$this->userid = $row['id'];

		$this->SetData('lastdate', time() );
		$this->SetData('lastip', USER_IP );
			
		return LOGIN_OK;
	}
	
	
	/**************************************
	 * Felhasznl kijelentkeztetse
	 */
	function LogoutUser()
	{
		global $sess;
		
		unset($sess['userdata']);
		unset($sess['userid']);
		unset($sess['usr_logined']);
		$this->permissions = USR_GUEST;
	}
	
	
	/**************************************
	 * Felhasznl hitelestse
	 */
	function AuthUser()
	{
		global $sess;
		
		return ($sess['usr_logined'] == md5( $sess['userid'].$sess['userdata']['name'].$sess['authkey'] ));
	}
	
	/**************************************
	 * Egy adat frisstse
	 */
	function SetData( $name = false, $value = false )
	{
		if ((!$this->logined) || ($name === false)) { 
			return false;
		}
		
		//if (isset($this->userdata[$name])) {			
			if ($this->userdata[$name] != $value) {
				$this->userdata_updates[$name] = $value;
				$this->savereq = true;
			}
		//}
		
		return true;
	}
	
	/**************************************
	 * Felhasznl adatainak frisstse
	 */
	function UpdateDatas( $data = false )
	{
		global $sess, $db;
		
		// Ellenrizzk, hogy felhasznl vagy admin, illetve ltezik
		// s tmb-e az userdata session tmb.
		if ((!$this->logined) || (!is_array($data))) {
		  	return false;
		}
		
		foreach ($data as $name => $value) {
			if (isset($this->userdata[$name])) {
				if ($this->userdata[$name] != $value) {
					$this->userdata_updates[$name] = $value;
					$this->savereq = true;
				}
			}
		}
		
		return true;
	}
	
	/**************************************
	 * Felhasznl adatainak mentse
	 */
	function SaveUserData()
	{
		global $db, $sess;
		
		if ((!$this->logined) || (!$this->savereq) || (count($this->userdata_updates) == 0)) {
		  	return false;
		}
		
		$updates = '';
		
		foreach ($this->userdata_updates as $k => $v) {
			$updates .= $k.'=\''.$db->sql_escape( $v ).'\', ';
			
			// Session frisstse
			$this->userdata[ $k ] = $v;
		}
					
		$updates = substr($updates, 0, -2);
		
		// SQL frisstse
		$db->sql_query('UPDATE '.DBPREFIX.'users SET '.$updates.' WHERE id='.$this->userid.' LIMIT 1');
		
		return true;		
		
	}
}

?>