<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2008 muPortal Team
 *******************************************************************************
 * $Id: m_articles.php 90 2008-01-08 17:32:21Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/


if (!defined('MU_MODULES')) { die('File hacking'); }

if (!defined('LOADED_M_ARTICLES')) {

/*************************
 * infdoboz megjelentse
 */
function show_ar_infobox()
{
	global $db, $lang, $template, $__page__;
	
	// Szksges mintacsomagok betltse
	$template->LoadPackedFile('c_infobox');
	
	// Megkezdjk a blokkot
	$template->UseTpl('module_nt_begin');
	$template->UseTpl('infobox_title', array( 
		'L_ALT' => $lang['menu_articles'],
		'HEADIMG'	=> 'head-articles.jpg'
	));
	
	$template->UseTpl('ibox_begin', array(
		'TITLE' => $lang['ar_new5']
	));

	// 5 Legjjabb cikk lekrdezse
	$db->sql_query('SELECT id, title, readed FROM '.DBPREFIX.'articles 
		WHERE date < '.time().' ORDER BY date DESC LIMIT 0, 5');

	$no = 1;
	while ( $row = $db->sql_fetch_array())
	{
		$template->UseTpl('ibox_item', array(
			'NO' => $no,
			'URL' => 'index.php?page='.$__page__.'&amp;id='.$row['id'],
			'TITLE' => htmlspecialchars($row['title']),
			'COUNT' => $row['readed']
		));
		$no++;
	}
	
	$template->UseTpl('ibox_end');
	
	// vltunk az '5 legjjabb cikk'-rl az
	// t legnpeszrbb cikkre
	$template->UseTpl('infobox_change');
	
	$template->UseTpl('ibox_begin', array(
		'TITLE' => $lang['ar_top5']
	));
	
	// 5 Legjjabb cikk lekrdezse
	$db->sql_query('SELECT id, title, readed FROM '.DBPREFIX.'articles ORDER BY readed DESC LIMIT 0, 5');

	$no = 1;
	while ( $row = $db->sql_fetch_array())
	{
		$template->UseTpl('ibox_item', array(
			'NO' => $no,
			'URL' => 'index.php?page='.$__page__.'&amp;id='.$row['id'],
			'TITLE' => htmlspecialchars($row['title']),
			'COUNT' => $row['readed']
		));
		$no++;
	}
	
	$template->UseTpl('ibox_end');
	
	//befejezzk a blokkot
	$template->UseTpl('infobox_end');
	$template->UseTpl('module_nt_end');
}

/**************************************
 * Kategrik megjelentse
 */
function show_articles_categorys()
{
	global $db, $lang, $template, $__page__, $conf;
	
	$template->LoadPackedFile('c_category');
	
	$db->sql_query('SELECT category, COUNT(*) AS c
		FROM '.DBPREFIX.'articles
		WHERE date < '.time().'
		GROUP BY category');
		
	$counts = array();
	
	while ($row = $db->sql_fetch_array()) {
		$counts[ $row['category'] ] = $row['c'];
	}
	
	$db->sql_query('SELECT id, title, description 
		FROM '.DBPREFIX.'articles_category 
		ORDER BY position ASC');
		
	$template->UseTpl('module_begin', array(
		'TITLE'		=> $lang['news_cattitle']
	));
	
	$dbres = $db->res;
		
	while ($row = $db->sql_fetch_array( $dbres )) {
		
		if (isset($counts[ $row['id'] ])) {
			
			$items = '';
			
			$db->sql_query('SELECT id, title FROM '.DBPREFIX.'articles 
			WHERE category = '.$row['id'].' AND date < '.time().' 
			ORDER BY date DESC LIMIT 0, 5');
			
			while ($row2 = $db->sql_fetch_array()) {
			
				$items .= $template->PrepareTpl('category_listitem', array(
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row2['id'],
					'TITLE'	=> htmlspecialchars($row2['title'])
				));
			}
			
		} else {
			$items = $template->PrepareTpl('category_noitem', array(
				'L_NOITEMS'	=> $lang['ar_none']
			));
		}
			
		if ($conf['url_allow_auto'] == 1) {
			$desc = FormatURL($desc);
		}
		
		$desc = ($row['description'] != '') ? formattext($row['description']) : $lang['ar_nodesc'];
		
		$template->UseTpl('category_block', array(
			'TITLE'		=> htmlspecialchars($row['title']),
			'DESC'		=> $desc,
			'URL'		=> 'index.php?page='.$__page__.'&amp;cid='.$row['id'],
			'COUNT'		=> sprintf( $lang['ar_count'], 
				(isset( $counts[ $row['id'] ] )) ? $counts[ $row['id'] ] : 0 ),
			'L_MORE'	=> $lang['ar_incat'],
			'ITEMS'		=> $items			
		));	
		
	}
	
	$template->UseTpl('module_end');
}

/*************************
 * Cikklista megjelentse
 */
function show_articleslist( $id = NULL )
{
	global $db, $lang, $template, $conf, $__page__, $get;

	$template->AddRSSFeed( $lang['tracecat'], 'articles/category/'.$id );
	
	$template->LoadPackedFile('c_category_items');
	
	$min = (isset($get['min'])) ? $get['min'] : 0;
	
	// Cm lekrdezse
	$db->sql_query('SELECT title, description FROM '.DBPREFIX.'articles_category WHERE id='.$id.' LIMIT 1');
	
	if ($db->sql_num_rows() == 0) {
		Msg_Die( WARNING, $lang['err_mo_category'] );	
		return false;
	}
	
	list($title, $descr) = $db->sql_fetch_array( null, SQL_NUM );
	
	$descr = htmlspecialchars($descr);
	if ($conf['url_allow_auto'] == 1) {
		$descr = FormatURL($descr);
	}
	$descr = formattext($descr);
	
	$db->sql_query('SELECT COUNT(*) AS count 
		FROM '.DBPREFIX.'articles WHERE 
		category='.$id.' AND date < '.time());
	list($count) = $db->sql_fetch_array( null, SQL_NUM );
	
	// Fejlc kirsa
	$template->UseTpl('module_begin', array(
		'TITLE'		=> $title		
	));
	
	$template->AddToStack(($descr != '') ? '<p>'.$descr.'</p>' : $lang['ar_nodesc']);
	
	if ($count == 0) {
		
		Msg_Die( WARNING, $lang['ar_none'], false );	
		
	} else {
			
		// Listzsi md lekrdezse
		if (isset($get['lm'])) {
			if (($get['lm'] == 'l') or ($get['lm'] == 'd')) {
				$lm = $get['lm'];
				muSetCookie( 'listmode', $lm, 5184000 );
			}			
		} else {
			$lm = muGetCookie( 'listmode', $conf['default_listmode'] );
		}

		// Listzsi md belltsa
		if ($lm == 'l') {
			$fields = 'id, title, date, author, readed';
			$limit = $conf['listitems_ml'];
		} else {
			$fields = 'id, title, date, author, readed, LEFT(text, 400) AS preview';
			$limit = $conf['listitems_ms'];
		}	
		
		$db->sql_query('SELECT '.$fields.' FROM '.DBPREFIX.'articles 
			WHERE category = '.$id.' AND date < '.time().' 
			ORDER BY date DESC
			LIMIT '.$min.', '.$limit);

		// Oldalvlaszt elksztse		
		$rgt = $template->PrepareTpl('catmodesw', array(
			'OD'		=> ($lm == 'd') ? ' selected="selected"' : '',
			'OL'		=> ($lm == 'l') ? ' selected="selected"' : '',
			'L_DETAILED'=> $lang['lm_simple'],
			'L_LISTED'	=> $lang['lm_list'],
		));
	
		$switcher = CreatePgSwitcher( $count, $min, array(
			'page'	=> $__page__,
			'cid'	=> $id,
			'min'	=> '{!}',
		), $limit, false, $rgt );
		
		$template->AddToStack( $switcher );
		
		if ($lm == 'l') {
			$template->UseTPl('catitem_lst-b');
		}

		while ($row=$db->sql_fetch_array()) {
			
			if ($lm == 'l') {

				$template->UseTPl('catitem_lst-i', array(
					'TITLE'	=> htmlspecialchars($row['title']),
					'INFO'	=> sprintf( '%s: <b>%s</b> - %s: <b>%s</b>',
						$lang['arc_author'], htmlspecialchars($row['author']),
						$lang['date'], FormatDate( $row['date'] ) ),
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row['id'],
				));

			} else {
				
				$template->UseTPl('catitem_simple', array(
					'L_MORE'=> $lang['ar_read'],

					'TITLE'	=> htmlspecialchars($row['title']),
					'INFO'	=> sprintf( '%s: <b>%s</b> - %s: <b>%s</b> - ',
						$lang['arc_author'], htmlspecialchars($row['author']),
						$lang['date'], FormatDate( $row['date'] ) ),
					'TEXT'	=> FormatText(htmlspecialchars(strip_tags($row['preview'])).'...'),
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row['id'],
				));
			}
			
		}

		if ($lm == 'l') {
			$template->UseTPl('catitem_lst-e');
		}

		$template->AddToStack( $switcher );
	}
	
	$template->UseTpl('module_end');
	
	return true;
}

/*************************
 * Egy cikk megjelentse
 */
function show_article( $id )
{
	global $db, $lang, $template, $__page__, $sess, $conf;
	
	$db->sql_query('SELECT title, date, author, email, readed, text FROM '.DBPREFIX.'articles 
		WHERE id = '.$id.' AND date < '.time().'
		LIMIT 1');
	
	// Ltezik?
	if ( $db->sql_num_rows() == 0 ) 
	{
		Msg_Die( WARNING, $lang['ar_missing']);
	} 
	else
	{		
		$row = $db->sql_fetch_array();
		
		if ((!isset($sess['m_articles_pr'])) || (!in_array($id, $sess['m_articles_pr']))) {
			$db->sql_query('UPDATE '.DBPREFIX.'articles SET readed=readed+1 WHERE id='.$id.' LIMIT 1');
			$sess['m_articles_pr'][] = $id;
			$row['readed']++;
		}

		$template->loadfile('m_articles');
		
		$template->UseTpl('module_begin', array(
			'TITLE'		=> htmlspecialchars($row['title'])
		));
			
		if ($conf['url_allow_auto'] == 1) {
			$row['text'] = FormatURL($row['text']);
		}
		$row['text'] = formattext($row['text']);
		
		$template->usetpl( 'm_articles', array(
			'L_DATE'	=> $lang['date'],
			'L_AUTHOR'	=> $lang['arc_author'],
			'L_READED'	=> $lang['ar_readed'],

			'NAME'		=> htmlspecialchars($row['author']),
			'EMAIL'		=> htmlspecialchars($row['email']),
			'DATE'		=> formatdate( $row['date'] ),
			'READED'	=> $row['readed'],
			'TEXT'		=> $row['text'],
		));
		
		$template->UseTpl('module_end');
	}
}
	
	// Megadjuk, hogy mr betltttk egyszer a modult
	define('LOADED_M_ARTICLES', true);
}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/
 
global $get, $template; 

$template->AddRSSFeed( $lang['ar_trace'], 'articles' );

 
// Ha meg van adva egy cikk ID-je, akkor csak azt
// az egy cikket jelenti meg, klnben...
if (isset( $get['id'] ))
{
	show_article( $get['id']);
} 
// ... megnzzk, hogy meg van-e adva kategria ID, 
// mert akkor az adott cikket jelentjk meg, 
// klnben...
elseif (isset( $get['cid'] ))
{
	show_articleslist( $get['cid'] );
}
// A kategrik listjt jelentjk meg.
else
{
	show_ar_infobox();
	show_articles_categorys();
}
 
?>