<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2008 muPortal Team
 *******************************************************************************
 * $Id: m_downloads.php 90 2008-01-08 17:32:21Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('LOADED_M_DOWNLOADS')) {

/*************************
 * infdoboz megjelentse
 */
function show_dl_infobox()
{
	global $db, $lang, $template, $__page__;

	// Szksges mintacsomagok betltse
	$template->LoadPackedFile('c_infobox');

	// Megkezdjk a blokkot
	$template->UseTpl('module_nt_begin');
	$template->UseTpl('infobox_title', array(
		'L_ALT' => $lang['menu_articles'],
		'HEADIMG'	=> 'head-downloads.jpg'
	));

	$template->UseTpl('ibox_begin', array(
		'TITLE' => $lang['dl_new5']
	));

	// 5 Legjjabb cikk lekrdezse
	$db->sql_query('SELECT id, title, stat FROM '.DBPREFIX.'downloads
		WHERE date < '.time().' ORDER BY date DESC LIMIT 0, 5');

	$no = 1;
	while ( $row = $db->sql_fetch_array())
	{
		$template->UseTpl('ibox_item', array(
			'NO' => $no,
			'URL' => 'index.php?page='.$__page__.'&amp;id='.$row['id'],
			'TITLE' => htmlspecialchars($row['title']),
			'COUNT' => $row['stat']
		));
		$no++;
	}

	$template->UseTpl('ibox_end');

	// vltunk az '5 legjjabb letlts'-rl az
	// t legnpeszrbb cikkre
	$template->UseTpl('infobox_change');

	$template->UseTpl('ibox_begin', array(
		'TITLE' => $lang['dl_top5']
	));

	// 5 Legjjabb letlts lekrdezse
	$db->sql_query('SELECT id, title, stat FROM '.DBPREFIX.'downloads ORDER BY stat DESC LIMIT 0, 5');

	$no = 1;
	while ( $row = $db->sql_fetch_array())
	{
		$template->UseTpl('ibox_item', array(
			'NO' => $no,
			'URL' => 'index.php?page='.$__page__.'&amp;id='.$row['id'],
			'TITLE' => htmlspecialchars($row['title']),
			'COUNT' => $row['stat']
		));
		$no++;
	}

	$template->UseTpl('ibox_end');

	//befejezzk a blokkot
	$template->UseTpl('infobox_end');
	$template->UseTpl('module_nt_end');
}

/**************************************
 * Kategrik megjelentse
 */
function show_downloads_categorys()
{
	global $db, $lang, $template, $__page__, $conf;

	$template->AddRSSFeed( $lang['dl_trace'], 'downloads' );
	$template->LoadPackedFile('c_category');

	$db->sql_query('SELECT category, COUNT(*) AS c
		FROM '.DBPREFIX.'downloads
		WHERE date < '.time().'
		GROUP BY category');

	$counts = array();

	while ($row = $db->sql_fetch_array()) {
		$counts[ $row['category'] ] = $row['c'];
	}

	$db->sql_query('SELECT id, title, description
		FROM '.DBPREFIX.'downloads_category
		ORDER BY position ASC');

	$template->UseTpl('module_begin', array(
		'TITLE'		=> $lang['news_cattitle']
	));

	$dbres = $db->res;

	while ($row = $db->sql_fetch_array( $dbres )) {

		if (isset($counts[ $row['id'] ])) {

			$items = '';

			$db->sql_query('SELECT id, title FROM '.DBPREFIX.'downloads
			WHERE category = '.$row['id'].' AND date < '.time().'
			ORDER BY date DESC LIMIT 0, 5');

			while ($row2 = $db->sql_fetch_array()) {

				$items .= $template->PrepareTpl('category_listitem', array(
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row2['id'],
					'TITLE'	=> htmlspecialchars($row2['title'])
				));
			}

		} else {
			$items = $template->PrepareTpl('category_noitem', array(
				'L_NOITEMS'	=> $lang['ar_none']
			));
		}
	
		if ($conf['url_allow_auto'] == 1) {
			$desc = FormatURL($desc);
		}
		$desc = ($row['description'] != '') ? formattext($row['description']) : $lang['ar_nodesc'];
		
		$template->UseTpl('category_block', array(
			'TITLE'		=> htmlspecialchars($row['title']),
			'DESC'		=> $desc,
			'URL'		=> 'index.php?page='.$__page__.'&amp;cid='.$row['id'],
			'COUNT'		=> sprintf( $lang['dl_count'],
				(isset( $counts[ $row['id'] ] )) ? $counts[ $row['id'] ] : 0 ),
			'L_MORE'	=> $lang['dl_incat'],
			'ITEMS'		=> $items
		));

	}

	$template->UseTpl('module_end');
}

/*************************
 * Letltslista megjelentse
 */
function show_downloadslist( $id = NULL )
{
	global $db, $lang, $template, $conf, $__page__, $get;

	$template->AddRSSFeed( $lang['dl_trace'], 'downloads' );
	$template->AddRSSFeed( $lang['dl_tr_cat'], 'downloads/category/'.$id );
	$template->LoadPackedFile('c_category_items');

	$min = (isset($get['min'])) ? $get['min'] : 0;

	// Cm lekrdezse
	$db->sql_query('SELECT title, description FROM '.DBPREFIX.'downloads_category WHERE id='.$id.' LIMIT 1');

	if ($db->sql_num_rows() == 0) {
		Msg_Die( WARNING, $lang['err_mo_category'] );
		return false;
	}

	list($title, $descr) = $db->sql_fetch_array( null, SQL_NUM );

	$descr = htmlspecialchars($descr);
	if ($conf['url_allow_auto'] == 1) {
		$descr = FormatURL($descr);
	}
	$descr = formattext($descr);
	
	$db->sql_query('SELECT COUNT(*) AS count
		FROM '.DBPREFIX.'downloads WHERE
		category='.$id.' AND date < '.time());
	list($count) = $db->sql_fetch_array( null, SQL_NUM );

	// Fejlc kirsa
	$template->UseTpl('module_begin', array(
		'TITLE'		=> $title
	));

	$template->AddToStack(($descr != '') ? '<p>'.$descr.'</p>' : $lang['dl_nodesc']);

	if ($count == 0) {

		Msg_Die( WARNING, $lang['dl_none'], false );

	} else {

		// Listzsi md lekrdezse
		if (isset($get['lm'])) {
			if (($get['lm'] == 'l') or ($get['lm'] == 'd')) {
				$lm = $get['lm'];
				muSetCookie( 'listmode', $lm, 5184000 );
			}
		} else {
			$lm = muGetCookie( 'listmode', $conf['default_listmode'] );
		}

		// Listzsi md vlasztsa
		if ($lm == 'l') {
			$fields = 'id, title, date, name, stat';
			$limit = $conf['listitems_ml'];
		} else {
			$fields = 'id, title, date, name, stat, LEFT(description, 400) AS preview';
			$limit = $conf['listitems_ms'];
		}

		$db->sql_query('SELECT '.$fields.' FROM '.DBPREFIX.'downloads
			WHERE category = '.$id.' AND date < '.time().'
			ORDER BY date DESC
			LIMIT '.$min.', '.$limit);

		// Oldalvlaszt elksztse
		$rgt = $template->PrepareTpl('catmodesw', array(
			'OD'		=> ($lm == 'd') ? ' selected="selected"' : '',
			'OL'		=> ($lm == 'l') ? ' selected="selected"' : '',
			'L_DETAILED'=> $lang['lm_simple'],
			'L_LISTED'	=> $lang['lm_list'],
		));

		$switcher = CreatePgSwitcher( $count, $min, array(
			'page'	=> $__page__,
			'cid'	=> $id,
			'min'	=> '{!}',
		), $limit, false, $rgt );

		$template->AddToStack( $switcher );

		if ($lm == 'l') {
			$template->UseTPl('catitem_lst-b');
		}

		while ($row=$db->sql_fetch_array()) {

			if ($lm == 'l') {

				$template->UseTPl('catitem_lst-i', array(
					'TITLE'	=> htmlspecialchars($row['title']),
					'INFO'	=> sprintf( '%s: <b>%s</b> - %s: <b>%s</b>',
						$lang['dl_uploader'], htmlspecialchars($row['name']),
						$lang['date'], FormatDate( $row['date'] ) ),
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row['id'],
				));

			} else {

				$template->UseTPl('catitem_simple', array(
					'L_MORE'=> $lang['dl_details'],

					'TITLE'	=> htmlspecialchars($row['title']),
					'INFO'	=> sprintf( '%s: <b>%s</b> - %s: <b>%s</b> - ',
						$lang['arc_author'], htmlspecialchars($row['name']),
						$lang['date'], FormatDate( $row['date'] ) ),
					'TEXT'	=> FormatText(htmlspecialchars(strip_tags($row['preview'])).'...'),
					'URL'	=> 'index.php?page='.$__page__.'&amp;id='.$row['id'],
				));
			}

		}

		if ($lm == 'l') {
			$template->UseTPl('catitem_lst-e');
		}

		$template->AddToStack( $switcher );
	}

	$template->UseTpl('module_end');
	return true;
}

/*************************
 * Egy letlts megjelentse
 */
function show_download( $id )
{
	global $template, $lang, $db, $get, $__page__, $conf;

	$template->AddRSSFeed( $lang['dl_trace'], 'downloads' );
	$template->AddRSSFeed( $lang['dl_tr_cat'], 'downloads/category/'.$id );

	// Adatok lekrdezse...
	$sql = 'SELECT title, filesize, name, email, description, stat, date FROM '.DBPREFIX.'downloads WHERE id='.$id;
	$db->sql_query( $sql );

	// Fjl ltezsnek ellenrzse
	if ($db->sql_num_rows() == 0) {
		Msg_Die( WARNING, $lang['dl_missing'] );
	} else {
		$row = $db->sql_fetch_array();

		// Mret tszmtsa (ha nagyobb, mint 1 Kb, akkor zrjelben byte-ban is kirja)
		$fs = ( $row['filesize'] > 1024 )
			? sprintf( '%s (%s '.$lang['byte'].')', CalcSize( $row['filesize'] ), $row['filesize'] )
			: CalcSize( $row['filesize'] );

		// Lers ellenrzse
		$desc = ( $row['description'] == NULL )
			? $lang['dl_nodesc']
			: htmlspecialchars($row['description']);
				
		if ($conf['url_allow_auto'] == 1) {
			$desc = FormatURL($desc);
		}
		$desc = FormatText($desc);

		// ... s kirsa
		$template->usetpl( 'module_begin', array (
			'TITLE' => sprintf( '%s - %s', StrTrunc($row['title'], 30), $lang['dl_details'] )
		));
		$template->usetpl( 'download_detail', array(
			'L_NAME'		=> $lang['dl_name'],
			'L_USERNAME'		=> $lang['dl_uploader'],
			'L_MAIL'		=> $lang['dl_email'],
			'L_FILESIZE'	=> $lang['dl_filesize'],
			// 'L_DESCRIPTION'	=> $lang['li_desc'],
			'L_STAT'		=> $lang['dl_dlcount'],
			'L_DATE'		=> $lang['dl_upload'],
			'L_DOWNLOAD'	=> $lang['dl_download'],

			// 'NAME' 			=> $row['title'],
			'UPLOADER'		=> $row['name'],
			'EMAIL'			=> $row['email'],
			'FILESIZE' 		=> $fs,
			'DESCRIPTION'	=> $desc,
			'STAT' 			=> $row['stat'],
			'DATE' 			=> FormatDate( $row['date'] ),
			'URL'			=> 'index.php?load='.$__page__.'&amp;mode=get&amp;id='.$id
		));
		$template->usetpl('module_end');
	}
}

/****7**************************
 * Krt fjl letltse
 */
function download_getfile ( $id )
{
	global $template, $lang, $db, $conf;

	// Kikeressk az adatbzisbl a megfelel adatokat
	$db->sql_query('SELECT category, title, name, url FROM '.DBPREFIX.'downloads WHERE id='.$id.' LIMIT 1' );

	if ($db->sql_num_rows() == 0)
	{
		Msg_Die( WARNING, $lang['dl_missing'], NULL, TRUE );
	}
	else
	{
		$row = $db->sql_fetch_array();

		// Majd frisstjk a statisztikt
		$db->sql_query('UPDATE '.DBPREFIX.'downloads SET stat=stat+1 WHERE id='.$id.' LIMIT 1');

		muRedirect(
			$row['url'],
			sprintf('<b>%s</b><br /><br />%s', $lang['dl_getfile'], sprintf( $lang['dl_wait'], $row['title']))
		);
	}
}


	// Megadjuk, hogy mr betltttk egyszer a modult
	define('LOADED_M_ARTICLES', true);
}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $get, $template;

if  (defined('MU_MODULES'))
{
	// Ha meg van adva egy letlts ID-je, akkor csak azt
	// az egy letltst jelenti meg, klnben...
	if (isset( $get['id'] ))
	{
		$template->LoadPackedFile('m_downloads');
		show_download( $get['id']);
	}

	// ... megnzzk, hogy meg van-e adva kategria ID,
	// mert akkor az adott letltst jelentjk meg,
	// klnben...
	elseif (isset( $get['cid'] ))
	{
		show_downloadslist( $get['cid'] );
	}
	// A kategrik listjt jelentjk meg.
	else
	{
		show_dl_infobox();
		show_downloads_categorys();
	}
} elseif (defined('MU_SELF')) {
	global $get;

	if ( isset($get['mode']) )
	{
		$mode = $get['mode'];
	}
	else
	{
		Msg_Die( ERROR, $lang['err_invalid_func']);
	}

	if ( isset($get['id']) )
	{
		$id = $get['id'];
	}
	else
	{
		Msg_Die( ERROR, $lang['err_missing_par']);
	}

	if ($mode = 'get')
	{
		$template->LoadPackedFile('m_downloads');
		download_getfile( $get['id'] );
	}
} else {
	die('File hacking');
}

?>