<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: m_email.php 51 2007-07-10 20:45:20Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }


/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $get, $conf, $db, $lang, $template, $user;

// Mintacsomagok betltse
$template->LoadPackedFile('m_email_form');


// Ellenrizzk, hogy be van-e kapcsolva a
// levlkld
if ($conf['email_enable'] == 0) {
	Msg_Die(WARNING, $lang['em_disabled'], $lang['em_sendtitle'] );
	return false;
}

// Ellenrizzk, hogy a felhasznl jogosult-e
// az E-mail kld hasznlatra
if (($conf['email_enable'] == 1) && (!$user->logined)) {
	Msg_Die(WARNING, $lang['em_onlyreg'], $lang['em_sendtitle'] );
	return false;
}

// postbl visszakapott zenet feldolgozsa feldolgozsa
if (defined('MU_EMAIL_POSTING')) {
	Msg_Die(MESSAGE, $get['#msg#'], (isset($get['#title'])) ? $get['#title'] : $lang['em_sendtitle']);
	return true;
}

// Postols sorn lett-e visszautastva a krs?
// Ha igen, rgi mezk rtkt ismt behelyettestjk
if (defined('M_EMAIL_FALLBACK')) {
	$errormsg = (isset($get['#msg#'])) ? $template->PrepareTpl('m_email_warning', array(
		'TEXT'	=> $get['#msg#']
	)) : '';

	// Korbbi mezk kitltse
	$f_subject	= (trim($_POST['subject']) != '') ? $_POST['subject'] : $lang['em_nosubject'];
	$f_msg 		= (trim($_POST['message']) != '') ? $_POST['message'] : '';
	$f_name		= (trim($_POST['name']) != '') ? $_POST['name'] : '';
	$f_email	= (trim($_POST['email']) != '') ? $_POST['email'] : '';
} else {
	$errormsg = '';

	$f_subject	= '';
	$f_msg		= '';
	$f_name		= '';
	$f_email	= '';
}


// cmzett feldolgozsa
if (isset($get['toid'])) {
	$db->sql_query('SELECT name, email, email_public, email_cansend FROM '.DBPREFIX.'users WHERE id='.$get['toid'].' LIMIT 1');

	if ($db->sql_num_rows() == 0) {
		Msg_Die(WARNING, $lang['em_notfound'], $lang['em_sendtitle'] );
		return false;
	} else {
		$row = $db->sql_fetch_array();
		$email_addr = $row['email'];
		$email_pub = ($row['email_public'] == 1);
		$name = $row['name'];

		// Ellenrizzk, hogy fogad-e leveleket errl az
		// oldalrl a felhasznl
		if ($row['email_cansend'] == 0) {
			Msg_Die(WARNING, sprintf( $lang['em_disallow'], $row['name'] ), $lang['em_sendtitle'] );
			return false;
		}
	}

	$hiddenfield = array(
		'type'		=> 'id',
		'id'		=> $get['toid'],
	);

// Ha base64-l kdolt levlcm szerepel az URL-ben
} elseif (isset($get['toaddr'])) {

		$email_addr = trim(base64_decode($get['toaddr']));
		$email_pub = true;
		$name = $lang['guest'];

		$hiddenfield = array(
			'type'		=> 'addr',
			'addr'		=> $email_addr,
			// 'name'	=> $name,
		);

		if (!is_email($email_addr)) {
			Msg_Die(WARNING, $lang['em_badformat'], $lang['em_sendtitle'] );
			return false;
		}

		// Valami ellenrzs, hogy robotok ne tudjanak kldeni?

// Klnben hibt jelznk
} else {
	Msg_Die(WARNING, $lang['bad_url'], $lang['em_sendtitle'] );
	return false;
}


// Nv s E-mail cm mezk
if ($user->logined) {
	$namefileds = '';
} else {
	$namefileds = $template->PrepareTpl('m_email_namefields', array(
		'L_EMAIL'	=> $lang['email_addr'],
		'L_NAME'	=> $lang['sn_yourname'],
		'EMAIL'		=> $f_email,
		'NAME'		=> $f_name,
	));
}


// Vgs form sszelltsa
$template->UseTpl('module_begin', array(
	'TITLE' => $lang['em_sendtitle']
));

$template->UseTpl('m_email_form', array(
	'WARNING'		=> $errormsg,
	'NAMEFIELDS'	=> $namefileds,

	'L_RCPT'	=> $lang['em_rcpt'],
	'L_SUBJECT'	=> $lang['em_subject'],
	'L_TEXT'	=> $lang['em_text'],
	'L_SUBMIT'	=> $lang['em_submit'],
	'L_SENDMECOPY'=>$lang['em_sendmecopy'],

	'SUBJECT'	=> $f_subject,
	'TEXT'		=> $f_msg,

	'MODE'	=> 'sendmail',
	'NAME'	=> (($email_pub) && (trim($email_addr) != ''))
		? sprintf('%s &lt;<a href="mailto:%s">%s</a>&gt;', htmlspecialchars($name), htmlspecialchars($email_addr), htmlspecialchars($email_addr))
		: $row['name'],
	'TO'	=> base64_encode(serialize($hiddenfield)),
));

$template->UseTpl('module_end');

?>