<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: m_email_post.php 51 2007-07-10 20:45:20Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MU_POSTING')) { die('File hacking'); }


class PM_Email_posting
{
	var $address;


	/**
	 * Konstruktor
	 */
	function PM_Email_posting()
	{
		global $get, $user, $lang, $conf, $mods;

		// visszatr oldal belltsa
		$get['page'] = $mods->modules['m_email'];

		// Be van-e kapcsolva az E-mail kld?
		if ($conf['email_enable'] == 0) {
			$this->ReturnToNormalMode($lang['em_disabled']);
			return false;
		}

		// Jogosult-e?
		if (($conf['email_enable'] == 1) && (!$user->logined)) {
			$this->ReturnToNormalMode($lang['em_onlyreg']);
			return false;
		}
	}


	/**
	 * Modul vgrehajtsa
	 */
	function Execute()
	{
		global $get, $user, $lang, $conf, $db;

		// Adatok lekrdezse s Hiddenfield feldolgozsa
		$this->subject= (trim($_POST['subject']) != '') ? $_POST['subject'] : $lang['em_nosubject'];
		$this->msg 	= (trim($_POST['message']) != '') ? $_POST['message'] : '';
		$this->address= @unserialize(@base64_decode($_POST['to']));

		// Hiddenfield feldolgozsa
		if (!is_array($this->address) || !isset($this->address['type'])) {
			$this->ReturnToNormalMode($lang['bad_request']);
			return false;
		} else {
			switch ($this->address['type']) {
				case 'id' :
					$db->sql_query('SELECT name, email, email_public, email_cansend
						FROM '.DBPREFIX.'users WHERE id='.$this->address['id'].' LIMIT 1');

					if ($db->sql_num_rows() == 0) {
						$this->ReturnToNormalMode($lang['em_notfound']);
						return false;
					} else {
						$row = $db->sql_fetch_array();
						$to_address = $row['email'];
						$to_name	= $row['name'];

						// Ellenrizzk, hogy fogad-e leveleket errl az
						// oldalrl a felhasznl
						if ($row['email_cansend'] == 0) {
							$this->ReturnToNormalMode(sprintf( $lang['em_disallow'], $row['name']));
							return false;
						}
					}
				break;
				case 'addr' :
					$to_address	= $this->address['addr'];
					// $to_name	= $lang['guest']
					$to_name = false;

					echo $to_address;

					if (!is_email($to_address)) {
						$this->ReturnToNormalMode($lang['em_badformat']);
						return false;
					}
				break;
				default :
					$this->ReturnToNormalMode($lang['bad_request']);
				break;
			}

		}

		// Adatok ellenrzse
		if ($this->msg == '') {
			$this->Fallback($lang['em_nomessage']);
			return false;
		}

		// Felad adatainak lekrdezse
		if ($user->logined) {
			$from_address	= $user->userdata['email'];
			$from_name		= $user->userdata['name'];
		} else {
			$from_address	= (isset($_POST['email']))	? trim($_POST['email']) : '';
			$from_name		= (isset($_POST['name']))	? trim($_POST['name']) : '';

			// Ha nem adta meg az adatait
			if ($from_address == '') {
				$this->Fallback($lang['sn_js_reqemail']);
				return false;
			}

			// Ha nem adta meg az adatait
			if (!is_email($from_address)) {
				$this->Fallback($lang['pl_email_notmailaddr']);
				return false;
			}

			// Ha nem adta meg az adatait
			if ($from_name == '') {
				$this->Fallback($lang['sn_js_reqname']);
				return false;
			}
		}




		// Mailer ltrehozsa...
		$mail = SetupMailer();

		// ...s belltsa
		if ($to_name != false) {
			$mail->AddAddress($to_address, $to_name);
		} else {
			$mail->AddAddress($to_address);
		}

		// Cmzettek lenullzsa
		$mail->ReplyTo = array();

		$mail->From		= $from_address;
		$mail->FromName = $from_name;
		$mail->AddReplyTo($from_address, $from_name);

		if (isset($_POST['sendmecopy'])) {
			$mail->AddBCC($from_address, $from_name);
		}

		$file = 'mu-sys/language/'.$conf['lang_default'].'/email_simple.txt';
		if (file_exists($file)) {
			$msg_sample =  @fread( @fopen($file, 'r') , @filesize($file) );

			$msg = str_replace(
				array(
					'{TEXT}',
					'{USERNAME}',
					'{URL}',
				),
				array(
					$this->msg,
					$from_name,
					$conf['site_url']
				), $msg_sample
			);
		}

		$mail->Subject	= $this->subject;
		$mail->Body		= $this->msg;

		if ($mail->Send()) {
			$this->ReturnToNormalMode($lang['em_send'], $lang['em_send_t']);
		} else {
			$this->Fallback($lang['em_fail'], $lang['em_failsend']);
		}


	} // PM_Email_posting



	/**
	 * Visszatrs a GET mdba
	 */
	function ReturnToNormalMode($msg, $title = false)
	{
		global $get;

		$get['#msg#'] = $msg;

		define('MU_EMAIL_POSTING', true);
	}


	/**
	 * Hiba esetn visszatrs az eredeti llapothoz
	 */
	function Fallback($errormsg = '')
	{
		global $get;

		if ($this->address['type'] == 'id') {
			$get['toid'] = $this->address['id'];
		} else {
			$get['toaddr'] = base64_encode($this->address['addr']);
		}
		$get['#msg#'] = $errormsg;

		define('M_EMAIL_FALLBACK', true);
	}

} // class PM_Email_posting

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

$pmodule = new PM_Email_posting();
$pmodule->Execute();

?>
