<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: m_forum.php 104 2008-04-14 12:35:53Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MUPORTAL')) { die('File hacking'); }

/**************************************
 * Lekrdezett tmk listzsa
 */
function Forum_PorcessTopics( $class = '', $result = false )
{
	global $db, $template, $__page__, $mods, $lang, $user;

	if ($result === false) {
		$result = $db->res;
	}

	// Tmk mentse, hsz-k szmnak lekrdezse
	$dbtmp = array();
	$cntmp = array();
	$idx = array();
	while ($row = $db->sql_fetch_array( $result )) {
		$dbtmp[] = $row;
		$idx[] = $row['topicid'];
	};

	if (count($idx) != 0) {

		$idx = implode(',',$idx);

		$db->sql_query('SELECT tid, COUNT(*) AS count
			FROM '.DBPREFIX.'forum_messages
			WHERE tid IN ('.$idx.')
			GROUP BY tid');

		// Hsz-szm mentse a $dbtmp tmbbe
		while ($row = $db->sql_fetch_array()) {
			$cntmp[ $row['tid'] ] = $row['count'];
		}
	}

	$res = '';

	$doicon = (($user->logined) && ($user->permissions == USR_ADMIN));

	foreach ($dbtmp as $row) {

		$owner = (isset($row['own_userid'])) ?
			'<a href="index.php?page='.$mods->modules['m_user'].'&amp;mode=details&amp;id='.$row['own_userid'].'">'.htmlspecialchars($row['own_name']).'</a>' :
			((isset($row['own_author'])) ? htmlspecialchars($row['own_author']) : $lang['cmt_anon']);

		$last = (isset($row['last_userid'])) ?
			'<a href="index.php?page='.$mods->modules['m_user'].'&amp;mode=details&amp;id='.$row['last_userid'].'">'.htmlspecialchars($row['last_name']).'</a>' :
			((isset($row['last_author'])) ? htmlspecialchars($row['last_author']) : $lang['cmt_anon']);

		$icon = ($doicon) ? $template->PrepareTpl('forum_modicon', array(
			'ID'	=> $row['topicid'],
			'L_MOD' => $lang['moderating']
		)) : '';

		$res .= $template->PrepareTpl('forum_topic', array(
			'CLASS'		=> ($class != '') ? ' class="'.$class.'"' : '',

			'TITLE'		=> htmlspecialchars($row['title']),
			'URL'		=> 'index.php?page='.$__page__.'&amp;tid='.$row['topicid'],
			'COUNT'		=> (isset($cntmp[ $row['topicid'] ])) ? $cntmp[ $row['topicid'] ] : 0,
			'MODICON'	=> $icon,

			'OWNER'		=> $owner,
			'DATE'		=> FormatDate( $row['create_date'] ),

			'LAST'		=> $last,
			'LASTDATE'	=> FormatDate( $row['last_date'] ),
			'LASTURL'		=> 'index.php?page='.$__page__.'&amp;tid='.$row['topicid'].'#comments',

		));


	}

	return $res;
}

/**************************************
 * Tmk listja
 */
function Forum_Topics()
{
	global $get, $template, $db, $conf, $lang, $__page__, $mods, $user;

	$template->LoadPackedFile('m_forum_topics');

	$min = (isset($get['min'])) ? $get['min'] : 0;

	$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'forum_topics');
	list($count) = $db->sql_fetch_array( null, SQL_NUM );

	$pgswitcher = CreatePgSwitcher( $count, $min, array(
				'page'	=> $__page__,
				'min'	=> '{!}',
			), $conf['m_forum_topiclimit']);

	// SQL krs alapja. Nekem tetszik.
	$sql_base = 'SELECT t.id AS topicid, t.mode, t.title, t.createdate AS create_date,
		t.own_author, t.own_userid, uo.name AS own_name,
		m.author AS last_author, m.userid AS last_userid, ul.name AS last_name, m.postdate AS last_date
		FROM '.DBPREFIX.'forum_topics t
		LEFT JOIN '.DBPREFIX.'forum_messages m ON (m.id = t.lastmid)
		LEFT JOIN '.DBPREFIX.'users ul ON (ul.id = m.userid)
		LEFT JOIN '.DBPREFIX.'users uo ON (uo.id = t.own_userid)
	';

	$topics = '';

	// Ha kell nzni a kiemelt tmkat is
	if ($min == 0) {
		$db->sql_query($sql_base.' WHERE mode=2 OR mode=3 ORDER BY last_date DESC');

		$skip = $db->sql_num_rows();

		// Csak akkor jelentjk meg a kiemelt tmk rszt, ha vannak
		// kiemelt tmk
		if ($skip > 0) {
			$topics .= $template->PrepareTpl( 'forum_topics_highlighted', array(
				'L_HIGHLIGHTED'	=> $lang['fo_highlighted'],
				'L_NORMALTOPICS'=> $lang['fo_normalcmts'],
				'TOPICS'		=> Forum_PorcessTopics('highl'),
			));
		}
	} else {
		$skip = 0;
	}

	// Tovbbi tmk lekrdezse
	$db->sql_query($sql_base.' WHERE mode != 2 AND mode != 3 ORDER BY last_date DESC
		LIMIT '.$min.', '.($conf['m_forum_topiclimit']-$skip));

	// Tmk feldolgozsa
	$topics .= Forum_PorcessTopics();


	// Kiiratsok
	$template->UseTpl('module_begin', array(
		'TITLE'		=> $lang['menu_forum'],
	));
	$template->UseTpl('forum_header', array(
		'L_FORUM'		=> $lang['menu_forum'],
		'L_NT'			=> $lang['fo_newtopic'],
		'UF'			=> 'index.php?page='.$mods->modules['m_forum'],
		'UNT'			=> 'index.php?page='.$mods->modules['m_forum'].'&amp;mode=newtopic',
		'SUB'			=> ''
	));

	// Ha nincsenek tmk figyelmeztetst jelentnk meg
	if ($topics == '') {
		$template->UseTpl('module_end');
		Msg_Die(WARNING, $lang['fo_notopics']);
	} else {

		if ($count > $conf['m_forum_topiclimit']) {
			$template->AddToStack($pgswitcher);
		}

		// Modertori segdeszkzk megjelentse
		if ($user->logined && ($user->permissions == USR_ADMIN)) {
			$template->UseTpl('forum_modarea', array(
				'L_CONF_DEL'=> $lang['mod_fo_delTopic'],
				'PAGE'		=> $__page__,
			));
		}

		$template->UseTpl('forum_base', array(
			'L_TOPIC'	=> $lang['fo_topics'],
			'L_COUNT'	=> $lang['fo_count'],
			'L_FIRST'	=> $lang['fo_first'],
			'L_LAST'	=> $lang['fo_last'],

			'TOPICS'	=> $topics
		));

		if ($count > $conf['m_forum_topiclimit']) {
			$template->AddToStack( $pgswitcher );
		}
		$template->UseTpl('module_end');
	}


}

/**************************************
 *
 */
function Forum_ShowTopic()
{
	global $get, $db, $template, $smilies, $user, $lang, $conf, $__page__, $mods, $METHOD;

	$forwarded = (($METHOD == 'POST') && ((isset($get['mode']) && ($get['mode'] == 'error_comment'))));

	$tid = ($forwarded) ? $_POST['id'] : $get['tid'];

	$template->LoadPackedFile('m_forum_topics');
	$template->AddRSSFeed( $lang['fo_tracetopic'], 'forum/topic/'.$tid );

	$db->sql_query('SELECT mode, title FROM '.DBPREFIX.'forum_topics
		WHERE id='.$tid.' LIMIT 1');

	if ($db->sql_num_rows() != 1) {
		Msg_Die( WARNING, $lang['fo_topicnotfound'] );
		return false;
	}

	// Fejlcadatok kirsa
	$topicdata = $db->sql_fetch_array();

	$template->UseTpl('module_begin', array(
		'TITLE'	=> htmlspecialchars($topicdata['title'])
	));

	$template->UseTpl('forum_header', array(
		'L_FORUM'		=> $lang['menu_forum'],
		'L_NT'			=> $lang['fo_newtopic'],
		'UF'			=> 'index.php?page='.$mods->modules['m_forum'],
		'UNT'			=> 'index.php?page='.$mods->modules['m_forum'].'&amp;mode=newtopic',
		'SUB'			=> $template->PrepareTpl('forum_header_sub', array(
			'TITLE'			=> htmlspecialchars($topicdata['title']),
			'UT'			=> 'index.php?page='.$mods->modules['m_forum'].'&amp;tid='.$get['tid'],
		))
	));

	$template->UseTpl('module_end');


	/*********************************
	 * Kommentkld kijelzse
	 */
	if (($conf['m_forum_regmode'] == 1) && !$user->logined) {

		Msg_Die(MESSAGE, $lang['news_cmt_onlyreg'], $lang['newmsg']);

	} elseif (($topicdata['mode'] == 1) || ($topicdata['mode'] == 3)) {

		Msg_Die(MESSAGE, $lang['fo_locked'], $lang['newmsg']);

	} else  {

		$template->LoadPackedFile('m_news_newcmt');

		$template->UseTpl( 'm_news_newcmt_begin', array (
			'POST' 		=> 'index.php',
			'MODULE'	=> 'm_forum',
			'ID' 		=> $tid,

			'L_NEWMSG' 	=> $lang['newmsg'],
		  	'L_REQ_TEXT'=> $lang['news_js_text']
		));

		// Regisztrcifgg belltsok feldolgozsa

		$msg = '';

		if (!$user->logined)
		{
			// Ha cookieban le van trolva a hozzszl
			// neve, akkor behelyetestjk, amgy resen
			// hagyjuk a mezt
			$name = (muIssetCookie('u_name')) ? muGetCookie('u_name') : '';
			$email = (muIssetCookie('u_email')) ? muGetCookie('u_email') : '';

			if ($forwarded) {
				$name = $_POST['msg_name'];
				$email = $_POST['msg_email'];
				$msg = htmlspecialchars($_POST['msg_message']);

				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}

			$template->UseTpl( 'm_news_newcmt_unreg', array(
				'L_NAME' 	=> $lang['name'],
				'L_EMAIL' 	=> $lang['email'],

				'USR_NAME'	=> htmlspecialchars($name),
				'USR_EMAIL' => htmlspecialchars($email)
			));
		}
		else
		{
			if ($forwarded) {
				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}
		}

		$template->UseTpl( 'm_news_newcmt_end', array(
			'L_MESSAGE' => $lang['message'],
			'MESSAGE'	=> $msg,
		));

	} // kommentkld

	// PgSwitcher adatok
	$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'forum_messages
		WHERE tid='.$tid);

	list($count) = $db->sql_fetch_array( null, SQL_NUM );


	// PageSwitcher s hasonlk
	$min = (isset($get['min'])) ? $get['min'] : 0;

	if ( $count > $conf['m_forum_cmt_limit']) {
		$switcher = CreatePgSwitcher( $count, $min, array(
			'page'		=> $__page__,
			'tid'		=> $tid,
			'min'		=> '{!}',
		), $conf['news_cmt_limit'] );

		$template->AddToStack( $switcher );
	}

	// Mosolyok betltse
	$smilies->LoadSmilies();

	// Kommentekhez ugrs
	$template->AddToStack('<a name="comments"></a>');

	$db->sql_query( 'SELECT c.id, c.author, c.email, c.userid, c.postdate, c.text,
			u.name AS u_name, u.email AS u_email, u.email_public AS u_pubmail, u.email_cansend AS u_cansend, u.user_sig AS u_sign, u.news_comments AS u_cmts
			FROM '.DBPREFIX.'forum_messages c
			LEFT JOIN '.DBPREFIX.'users u ON (c.userid = u.id)
			WHERE tid='.$tid.' ORDER BY postdate DESC LIMIT '.$min.', '.$conf['m_forum_cmt_limit'] );
	$msgno = $count - $min;

	if ($db->sql_num_rows() != 0) {

		$template->LoadPackedFile('m_news_comments');

		if ($user->permissions == USR_ADMIN) {
			$template->UseTpl('cmt_moderator_begin', array(
				'MODULE'		=> 'forum',
				'MODFILE'		=> 'm_forum',
				'ID'			=> $tid,
				'L_CONFIRM'		=> $lang['mod_confirm_chng'],
				'L_DEL_CONFIRM' => $lang['delete_confirm'],
			));
		}

		while ($row = $db->sql_fetch_array())
		{
		    $template->UseTpl('module_nt_begin');

		    $_id = $row['userid'];

			if (isset( $_id )) { // Ha regisztrlt

				$sign = $row['u_sign'];
				$info = $lang['member'];

				$author = htmlspecialchars($row['u_name']);

				$email = ($row['u_pubmail'] == 1 && $row['u_cansend']) ?
					$template->PrepareTpl( 'cmt_bttn_email_a', array(
						'L_EMAIL'	=> $lang['send_email'],
						'URL'		=> ($conf['email_enable'] != 0)
							? 'index.php?page='.$mods->modules[ 'm_email' ].'&amp;toid='.$row['userid']
							: 'mailto:'.htmlspecialchars($row['email'])
					)) :
					$template->PrepareTpl( 'cmt_bttn_email_d', array( 'L_EMAIL' => $lang['send_email'] ) );

				$profile = $template->PrepareTpl( 'cmt_bttn_prof_a', array(
					'L_PROFILE' => $lang['pl_profile'],
					'URL'		=> 'index.php?page='.$mods->modules['m_user'].'&amp;mode=details&amp;id='.$row['userid']
				));

			} else { // Ha nem regisztrlt

				$author = (isset($row['author'])) ? htmlspecialchars($row['author']) : $lang['cmt_anon'];

				$profile = $template->PrepareTpl( 'cmt_bttn_prof_d', array( 'L_PROFILE' => $lang['pl_profile'] ) );
				$email = (isset($row['email'])) ?
					$template->PrepareTpl( 'cmt_bttn_email_a', array(
						'L_EMAIL'	=> $lang['send_email'],
						'URL'		=> ($conf['email_enable'] != 0)
							? 'index.php?page='.$mods->modules['m_email'].'&amp;toaddr='.htmlspecialchars(base64_encode($row['email']))
							: 'mailto:'.htmlspecialchars($row['email'])
					)) :
					$template->PrepareTpl( 'cmt_bttn_email_d', array( 'L_EMAIL' => $lang['send_email'] ) );
					$sign = '';
					$info = $lang['guest'];
			}

			if (($user->logined) && ($user->permissions == USR_ADMIN)) {

				$mod = $template->PrepareTpl('cmt_moderator_tools', array(
					'U_DELETE'	=> 'index.php?page='.$__page__.'&amp;mode=delete&amp;tid='.$tid.'&amp;mid='.$row['id'],
					'L_DELETE'	=> $lang['delete'],
					'L_EDIT'	=> $lang['edit'],
					'NID'		=> $tid,
					'MID'		=> $row['id'],
					'NO'		=> $msgno,
				));

			} else {
				$mod = '';
			}

			// HTML Tagok szrse, ha kell
			$text = ( $conf['news_enableHTML'] != 1 )
				? htmlspecialchars( $row['text'] ) : $row['text'];

			// Mosolyok alkalnazsa a szvegen
			$text = $smilies->UseSmilies( $text );

			// Moderlva szveg cserje
			$text = preg_replace_callback(
				'#\[MODAT::(.*?)::(.[0-9]+?)\]#is',
				'Callback_MODAT_Text', $text
			);
								
			if ($conf['url_allow_auto_user'] == 1) {
				$text = FormatURL($text);
			}
			$text = FormatText($text);
			
			if ($conf['user_signHTML'] != 1) {
				$sign = htmlspecialchars($sign);
			}
			
			if ($conf['url_allow_auto_sign'] == 1) {
				$sign = FormatURL($sign, true);
			}		
			$sign = FormatText($sign);
			
		
			$template->usetpl('m_news_comments', array(
				'L_DATE' => $lang['date'],

				'ID'		=> $row['id'],
				'MOD'		=> $mod,

				'NO'		=> $msgno,
				'AUTHOR'	=> $author,

				'PROFILE'	=> $profile,
				'EMAIL'		=> $email,
				'INFO'		=> $info,

				'DATE'		=> formatdate($row['postdate']),
				'TEXT'		=> $text,
				'SIGN'  	=> $sign,
			));

			$msgno--;

			$template->UseTpl('module_nt_end');
		}
	}

	if ($user->permissions == USR_ADMIN) {
		$template->UseTpl('cmt_moderator_end');
	}

	if ( $count > $conf['m_forum_cmt_limit']) {
		$template->AddToStack( $switcher );
	}
	return true;
}


/**************************************
 * j frumtma ltrehozsa
 */
function Forum_Newtopic()
{
	global $template, $conf, $lang, $user, $get, $METHOD;

	$forwarded = (($METHOD == 'POST') && ($get['mode'] == 'error_topic'));

	/*********************************
	 * Kommentkld kijelzse
	 */
	if ($conf['m_forum_topicmode'] == 2) {

		Msg_Die( WARNING, $lang['fo_nt_disabled'], $lang['newtopic'] );

	} elseif
	   (($conf['m_forum_topicmode'] == 1) && !$user->logined) {

		Msg_Die( MESSAGE, $lang['news_cmt_onlyreg'], $lang['newtopic'] );

	} else {

		$template->LoadPackedFile('m_news_newcmt');

		$template->UseTpl( 'm_news_newcmt_begin', array (
			'POST' 		=> 'index.php',
			'MODULE'	=> 'm_forum',
			'ID' 		=> -1,

			'L_NEWMSG' 	=> $lang['newtopic'],
		  	'L_REQ_TEXT'=> $lang['news_js_text'],
		  	'L_REQ_TITLE'=>$lang['fo_nt_reqtitle'],
		));

		// Regisztrcifgg belltsok feldolgozsa

		if (!$user->logined)
		{
			// Ha cookieban le van trolva a hozzszl
			// neve, akkor behelyetestjk, amgy resen
			// hagyjuk a mezt
			$name = (muIssetCookie('u_name')) ? muGetCookie('u_name') : '';
			$email = (muIssetCookie('u_email')) ? muGetCookie('u_email') : '';

			if ($forwarded) {
				$name = $_POST['msg_name'];
				$email = $_POST['msg_email'];

				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}
			else
			{
				if ($forwarded) {
					$errormsg = $lang['news_err_'.$get['error']];
					$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
				}
			}

			$template->UseTpl( 'm_news_newcmt_unreg', array(
				'L_NAME' 	=> $lang['name'],
				'L_EMAIL' 	=> $lang['email'],

				'USR_NAME'	=> htmlspecialchars($name),
				'USR_EMAIL' => htmlspecialchars($email)
			));
		}
		else
		{
			if ($forwarded) {
				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}
		}

		$template->UseTpl( 'm_forum_topic_title', array(
			'L_TITLE'	=> $lang['fo_topictitle'],
			'USR_TITLE'	=> (isset($_POST['msg_title'])) ? htmlspecialchars($_POST['msg_title']) : '',
		));

		$template->UseTpl( 'm_news_newcmt_end', array(
			'L_MESSAGE' => $lang['message'],
			'MESSAGE'	=> (isset($_POST['msg_message'])) ? htmlspecialchars($_POST['msg_message']) : '',
		));

	} // kommentkld
}

/*********************************************************************************
 *                         MODERTORI SEGDESZKZK
 *********************************************************************************/


/**************************************
 * Hozzszls trlse
 */

global $user;

if ( $user->logined && ( $user->permissions == USR_ADMIN)) {

	// !! Egyeztetend a m_news_ajax.php/ModTools_DeleteCmt() -l!
	// 2007-02-11: traktam a fggvnyt az m_forum_func.php fjlba
	function ModTools_DeleteComment( $tid, $mid )
	{
		global $lang;

		require('mu-sys/modules/m_forum_func.php');

		if (mForum_ModTools_DeleteCmt($tid, $mid)) {
			Msg_Die( WARNING, $lang['mod_cmt_deleted'] );
		}
	}

	/**************************************
	* Egy tma trlse
	*/
	function ModTools_DeleteTopic( $tid )
	{
		global $db, $user, $mods, $lang;

		$db->sql_query('SELECT userid, COUNT(*) AS count
			FROM '.DBPREFIX.'forum_messages
			WHERE tid = '.$tid.' AND userid > 0
			GROUP BY userid');

		$res = $db->res;

		while ($row = $db->sql_fetch_array($res)) {
			if ($row['userid'] == $user->userid) {
				$user->SetData( 'news_comments', $user->userdata['news_comments']-$row['count'] );
			} else {
				$db->sql_query('UPDATE '.DBPREFIX.'users SET news_comments = news_comments-'.$row['count'].'
					WHERE id='.$row['userid'].' LIMIT 1');
			}
		}

		$db->sql_query('DELETE FROM '.DBPREFIX.'forum_messages WHERE tid = '.$tid );
		$db->sql_query('DELETE FROM '.DBPREFIX.'forum_topics WHERE id = '.$tid.' LIMIT 1' );

		muRedirect( 'index.php?page='.$mods->modules['m_forum'], $lang['mod_fo_deleted'] );
	}
}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $get, $conf, $template, $lang, $user;

$template->AddRSSFeed( $lang['fo_tracecmt'], 'forum/comments' );
$template->AddRSSFeed( $lang['fo_tracetopics'], 'forum/topics');


if (($user->logined) && ($user->permissions == USR_ADMIN) && isset($get['mode'])) {

	switch ($get['mode'])
	{
		case 'delete' :
		{
			if (!(isset($get['tid']) && isset($get['mid']))) {
				Msg_Die( WARNING, $lang['bad_url'] );
			} else {

				ModTools_DeleteComment( $get['tid'], $get['mid'] );
				Forum_ShowTopic( $get['tid'] );
			}

			break;
		}

		case 'deleteTopic' : {

			if (!isset($get['tid'])) {
				Msg_Die( WARNING, $lang['bad_url'] );
			} else {
				ModTools_DeleteTopic( $get['tid'] );
			}
		}
	}

}

$mode = (isset($get['mode']))
	? $get['mode']
	: ((isset($get['tid']))
		? 'topic' : 'topics');

switch ($mode) {
	case 'topics' : {
		Forum_Topics(); break;
	}
	case 'error_comment' :
	case 'topic' : {
		Forum_ShowTopic(); break;
	}
	case 'error_topic' :
	case 'newtopic' : {
		Forum_Newtopic(); break;
	}
	case 'msg' : {
		Msg_Die( WARNING, $get['msg'] );
		break;
	}
}

?>