<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2008 muPortal Team
 *******************************************************************************
 * $Id$
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/
 
if (defined('MU_MODULES')) 
{
	
	/**************************************
	 * Linkek listja
	 */
	function Links_List()
	{
		global $db, $lang, $template, $get, $__page__, $conf;
		
		$min = (isset($get['min'])) ? $get['min'] : 0;
		
		$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'links 
			WHERE date<'.time());
			
		list($count) = $db->sql_fetch_array( null, SQL_NUM );
		
		$db->sql_query( 'SELECT id, name, url, LEFT(description, 400) AS preview, statistic 
			FROM '.DBPREFIX.'links 
			WHERE date<'.time().' 
			ORDER BY statistic DESC
			LIMIT '.$min.', '.$conf['listitems_ml'] );
		
		if ($db->sql_num_rows() == 0)
		{
			Msg_Die(WARNING, $lang['li_nolinks']);
		} else {	
			$template->UseTpl('module_begin', array (
				'TITLE'		=> $lang['li_title']
			));
			
			$switcher = ($count < $conf['listitems_ml']) ? '' : CreatePgSwitcher( $count, $min, array(
				'page'	=> $__page__,
				'min'	=> '{!}',
			), $conf['listitems_ml']);
	
			
			$template->AddToStack( $switcher );
				
			$template->usetpl('m_links_begin');
							
			while ( $row = $db->sql_fetch_array())
			{
				if (isset($row['preview'])) {
					$desc = StrTrunc(FormatText(htmlspecialchars($row['preview'])), 398);
				} else {
					$desc = '<i>Nincs lers</i>';
				}
				
				$template->usetpl( 'm_links_item', array (
					'URL'	=> 'index.php?load='.$__page__.'&amp;id='.$row['id'],
					'I_NAME'=> htmlspecialchars($row['name']),
					'I_STAT'=> $row['statistic'],

					'DESC'	=> $desc,
					'VISITORS'=> $lang['li_showed'],
					'DURL'	=> 'index.php?page='.$__page__.'&amp;id='.$row['id'],
					'L_DETAILS'	=> $lang['dl_details'],
				));
			}
				
			$template->usetpl('m_links_end');
			$template->AddToStack( $switcher );
			$template->UseTpl('module_end');
		}
	}
	
	
	/**************************************
	 * Link rszletezse
	 */
	function Links_Details()
	{
		global $db, $template, $lang, $__page__, $get, $conf;
		
		if (!isset($get['id'])) {
			
			Msg_Die( WARNING, $lang['bad_url'] );
			
		} else {
			
			$id = $get['id'];
			
			$db->sql_query('SELECT name, description, url, date, statistic 
				FROM '.DBPREFIX.'links WHERE id='.$get['id'].' LIMIT 1');
				
			if ($db->sql_num_rows() == 0) {
			} else {
				$row = $db->sql_fetch_array();
				
				$template->UseTpl('module_begin', array(
					'TITLE'	=> $row['name']
				));
				
				$desc = htmlspecialchars($row['description']);
				if ($conf['url_allow_auto'] == 1) {
					$desc = FormatURL($desc);
				}
				$desc = FormatText($row['description']);
				
				$template->UseTpl('m_links_details', array(
					'L_VISIT'		=> $lang['li_visit'],
					'L_DATE'		=> $lang['date'],
					'L_VISITS'		=> $lang['li_showed'],
					
					'URL'			=> 'index.php?load='.$__page__.'&amp;id='.$id,
					'FURL'			=> htmlspecialchars($row['url']),
					'DATE'			=> FormatDate( $row['date'] ),
					'DETAILS'		=> $desc,
					'VISITS'		=> $row['statistic']
				));
				
				$template->UseTpl('module_end');
			}

			
		}
	}
	
	global $get, $template;
	
	$template->LoadPackedFile('m_links');
	$template->AddRSSFeed( $lang['li_trace'], 'links' );
	
	if (isset($get['id'])) {
		Links_Details();		
	} else {
		Links_List();
	}
}
elseif ( defined( 'MU_SELF' ) )
{
	global $db, $lang, $template, $get;
	
	if (isset($get['id']))
	{ 
		$id = $get['id']; 
	} else { 
		Msg_Die( ERROR, $lang['err_missing_par'], NULL, TRUE ); 
	};

	$db->sql_query( 'SELECT url FROM '.DBPREFIX.'links WHERE id='.$id.' LIMIT 1' );

	if ( $db->sql_num_rows() == 0 ) 
	{ 
		Msg_Die( WARNING, $lang['li_missing'], NULL, TRUE ); 
	}
	else
	{
		$row = $db->sql_fetch_array();
	
		muRedirect( $row['url'] );	
	
		// Statisztika frisstse, ha nem ez volt az utols
		if ((isset($_SESSION['m_links_lastlid'])) && ($_SESSION['m_links_lastlid'] != $id))
		{
			$db->sql_query( 'UPDATE '.DBPREFIX.'links SET statistic=statistic+1 WHERE id='.$id );
			$_SESSION['m_links_lastlid'] = $id;
		}
	}
}
else
{ 
	die('File hacking');
}
 
?>