<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: m_news.php 92 2008-01-08 18:27:22Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('MU_MODULES')) { die('File hacking'); }

if (!defined('LOADED_M_NEWS')) {


/*********************************
 * Hr(ek) megjelentse
 */
function show_news ( $min = NULL, $limit = NULL, $highlight = false )
{
	global $db, $template, $lang, $__page__, $news_dont_select, $get, $conf;

	$template->loadfile('m_news');

	$hl = ($conf['news_highlight'] == 2) ? 'n.highlighted, ' : '';

	$sql = 'SELECT n.id AS id, n.title, n.name, n.email, n.date, n.text, n.category, '.$hl.' c.title AS ctitle
		FROM '.DBPREFIX.'news n
		LEFT JOIN '.DBPREFIX.'news_category c ON (c.id = n.category) ';

	$dontselect = ($news_dont_select != '') ? ' AND ('.substr($news_dont_select, 4).')' : '';

	if ($highlight) {

		$sql .= ' WHERE highlighted=1 AND date <= '.time().' '.$dontselect.' ORDER BY date DESC LIMIT 1';

	} else {
		// Ellenrizzk, hogy van-e plussz paramter, s annak megfelelen
		// mdistjuk az SQL krst
		if (isset($min))
		{
			// Ha a limit is meg van adva, akkor limitljuk az eredmnyek szmt...
			if (isset($limit))
			{
				$cidwhere = (isset($get['cid'])) ? ' category='.$get['cid'].' AND ' : '';
				$sql .= 'WHERE '.$cidwhere.' date <= '.time().' '.$dontselect.' ORDER BY date DESC LIMIT '.$min.', '.$limit;
			}
			// Ha nincs, akkor meg csak egy-t runk ki.
			else
			{
				$sql .= ' WHERE n.id='.$min.' AND date <= '.time().' '.$dontselect.' LIMIT 1';
			}
		}
		else
		{
			$sql .= ' ORDER BY date DESC';
		}
	}

	// Hr(ek) lekrdezse

	$db->sql_query( $sql );

	$rows = array();
	$ids = array();
	$comments = array();

	while ($row = $db->sql_fetch_array())
	{
		$rows[] = $row;
		$ids[] = $row['id'];
	}

	if (count($ids) > 0) {
		if (count($ids) == 1) {
			$db->sql_query('SELECT COUNT(*) as count
				FROM '.DBPREFIX.'news_comments
				WHERE news = '.$ids[0]);

			$row = $db->sql_fetch_array();
			$comments[$ids[0]] = $row['count'];
		} else {
			$ids = implode(',',$ids);
			$db->sql_query('SELECT news, COUNT(*) as count
				FROM '.DBPREFIX.'news_comments
				WHERE news in ('.$ids.')
				GROUP BY news');

			while ($row = $db->sql_fetch_array()) {
				$comments[$row['news']] = $row['count'];
			}
		}
	}

	foreach ($rows as $row)
	{
		if ($highlight) { $news_dont_select .= ' OR n.id!='.$row['id']; }

		if (($limit == 1) && (isset($row['category'])) && ($row['category'] > 1)) {
			$template->AddRSSFeed( $lang['news_tracecat'], 'news/category/'.$row['category'] );
		}

		// Hozzszlsok sszeszmllsa
		/*$sql = 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_comments WHERE news='.$row['id'];
		$db->sql_query($sql);
		$row2 = $db->sql_fetch_array();*/

		$url = 'index.php?page='.$__page__.'&amp;id='.$row['id'].'#comments';

		// Kirs
		$template->UseTpl( (($highlight || (($conf['news_highlight'] == 2) && ($row['highlighted'] == 1)))
			? 'mod_link_hl_begin' : 'module_link_begin'),
		array(
			'TITLE' 	=> $row['title'],
			'URL'		=> $url,
		));

		if ($conf['url_allow_auto'] == 1) {
			$text = FormatURL($row['text']);
		}
		$text = formattext( $row['text']);

		$template->usetpl('m_news', array(
			'L_WRITED' 	=> $lang['writed'],
			'L_DATE' 	=> $lang['date'],
			'L_COMMENTS'=> $lang['comments'],

			'URL'		=> $url,
			'CATDESC'	=> ($row['category'] != 0) ? sprintf( $lang['news_category'], 'index.php?page='.$__page__.'&amp;cid='.$row['category'], $row['ctitle'] ) : '',
			'AUTHOR' 	=> htmlspecialchars($row['name']),
			'EMAIL'		=> htmlspecialchars($row['email']),
			'DATE' 		=> formatdate( $row['date'] ),
			'COMMENTS' 	=> (isset($comments[$row['id']])) ? $comments[$row['id']] : 0,
			'TEXT' 		=> $text,
		));

		$template->UseTpl( (($highlight || (($conf['news_highlight'] == 2) && ($row['highlighted'] == 1))) ? 'mod_link_hl_end' : 'module_link_end') );
	}
}

/*********************************
 * Hozzszlsok megjelentse
 */
function show_comments( $id, $show_news = true )
{
	global $db, $template, $lang, $conf, $get, $smilies, $user, $mods, $__page__, $METHOD;

	$template->AddRSSFeed( $lang['news_tracecmts'], 'news/comments/'.$id );

	$template->loadfile('m_news');
	$template->LoadPackedFile('m_news_newcmt');

	if (($METHOD == 'POST') && (isset($get['mode'])) && ($get['mode'] == 'error')) {
		$forwarded = true;
		$show_news = false;
	} else {
		$forwarded = false;
	}


	// Hozzszlshoz tartoz hr megjelentse
	if ($show_news) {
		show_news( $id );
	}

    /*********************************
	 * Kommentkld kijelzse
	 */
	if (($conf['news_cmt_usrmode'] == 1) && !$user->logined)
	{
	    Msg_Die( MESSAGE, $lang['news_cmt_onlyreg'], $lang['newmsg'] );
	}
	else
	{
		$template->UseTpl( 'm_news_newcmt_begin', array (
			'POST' 		=> 'index.php',
			'MODULE'	=> 'm_news',
			'ID' 		=> $id,

			'L_NEWMSG' 	=> $lang['newmsg'],
		  	'L_REQ_TEXT'=> $lang['news_js_text'],
		  	'L_REQ_TITLE'=>$lang['fo_nt_reqtitle'],
		));

		// Regisztrcifgg belltsok feldolgozsa

		$msg = '';

		if (!$user->logined)
		{
			// Ha cookieban le van trolva a hozzszl
			// neve, akkor behelyetestjk, amgy resen
			// hagyjuk a mezt
			$name = (muIssetCookie('u_name')) ? muGetCookie('u_name') : '';
			$email = (muIssetCookie('u_email')) ? muGetCookie('u_email') : '';

			if ($forwarded) {
				$name = $_POST['msg_name'];
				$email = $_POST['msg_email'];
				$msg = htmlspecialchars($_POST['msg_message']);

				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}

			$template->UseTpl( 'm_news_newcmt_unreg', array(
				'L_NAME' 	=> $lang['name'],
				'L_EMAIL' 	=> $lang['email'],

				'USR_NAME'	=> htmlspecialchars($name),
				'USR_EMAIL' => htmlspecialchars($email)
			));
		}
		else
		{
			if ($forwarded) {
				$errormsg = $lang['news_err_'.$get['error']];
				$template->AddToStack('<div class="form"><div class="text warning">'.$errormsg.'</div></div>');
			}
		}

		$template->UseTpl( 'm_news_newcmt_end', array(
			'L_MESSAGE' => $lang['message'],
			'MESSAGE'	=> $msg,
		));
	}

	// Ha be van lltva minimum hozzszls, akkor kihagyunk
	$min = (isset($get['min'])) ? $get['min'] : 0;

	// Hozzszlsok szmnak lekrdezse
	$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_comments WHERE news='.$id );
	$row = $db->sql_fetch_array();
	$msg_count = $row['count'];

	if ( $msg_count > $conf['news_cmt_limit'])
	{
		$switcher = CreatePgSwitcher( $msg_count, $min, array(
			'page'		=> $__page__,
			'id'		=> $id,
			'min'		=> '{!}',

		), $conf['news_cmt_limit'] );

		$template->AddToStack( $switcher );
	}

	// Mosolyok betltse
	$smilies->LoadSmilies();

	// Kommentekhez ugrs
	$template->AddToStack('<a name="comments"></a>');

	// Hozzszlsok lekrdezse
	$db->sql_query( 'SELECT c.id, c.author, c.email, c.userid, c.date, c.text,
		u.name AS u_name, u.email AS u_email, u.email_public AS u_pubmail, u.email_cansend AS u_cansend, u.user_sig AS u_sign, u.news_comments AS u_cmts
		FROM '.DBPREFIX.'news_comments c
		LEFT JOIN '.DBPREFIX.'users u ON (c.userid = u.id)
		WHERE news='.$id.' ORDER BY date DESC LIMIT '.$min.', '.$conf['news_cmt_limit'] );
	$msgno = $msg_count - $min;

	if ($db->sql_num_rows() != 0)
	{
		$template->LoadPackedFile('m_news_comments');

		if ($user->permissions == USR_ADMIN) {
			$template->UseTpl('cmt_moderator_begin', array(
				'ID'			=> $id,
				'MODULE'		=> 'news',
				'MODFILE'		=> 'm_news',
				'L_CONFIRM'		=> $lang['mod_confirm_chng'],
				'L_DEL_CONFIRM' => $lang['delete_confirm'],
				));
		}

		while ($row = $db->sql_fetch_array())
		{
		    $template->UseTpl('module_nt_begin');

		    $_id = $row['userid'];

			if (isset( $_id )) { // Ha regisztrlt

				$sign = $row['u_sign'];
				$info = $lang['member'];

				$author = htmlspecialchars($row['u_name']);

				// Ha engedlyezve van a levlklds
				if ((isset($mods->modules['m_email'])) && (($conf['email_enable'] == 2) || (($user->logined) && ($conf['email_enable'] == 1))))  {

					// Ha publikus az E-Mail cme
					if ($row['u_pubmail'] == 1 && $row['u_cansend']==1) {
						$email = $template->PrepareTpl( 'cmt_bttn_email_a', array(
							'L_EMAIL'	=> $lang['send_email'],
							'URL'		=> ($conf['email_enable'] != 0)
									? 'index.php?page='.$mods->modules[ 'm_email' ].'&amp;toid='.$row['userid']
									: 'mailto:'.htmlspecialchars($row['email'])
							));
					} elseif ($row['u_cansend'] == 1) {
						$email = $template->PrepareTpl( 'cmt_bttn_email_a', array(
							'L_EMAIL'	=> $lang['send_email'],
							'URL'		=> 'index.php?page='.$mods->modules[ 'm_email' ].'&amp;toid='.$row['userid']
						));
					} else {
						$email = $template->PrepareTpl( 'cmt_bttn_email_d', array( 'L_EMAIL' => $lang['send_email'] ) );
					}

				} else {
					$email = ($row['u_pubmail'] == 1) ?
						$template->PrepareTpl( 'cmt_bttn_email_a', array(
							'L_EMAIL'	=> $lang['send_email'],
							'URL'		=> 'mailto:'.htmlspecialchars($row['email']))
						) :
						$template->PrepareTpl( 'cmt_bttn_email_d', array( 'L_EMAIL' => $lang['send_email'] ) );
				}

				$profile = $template->PrepareTpl( 'cmt_bttn_prof_a', array(
					'L_PROFILE' => $lang['pl_profile'],
					'URL'		=> 'index.php?page='.$mods->modules['m_user'].'&amp;mode=details&amp;id='.$row['userid']
				));

			} else { // Ha nem regisztrlt

				$author = (isset($row['author'])) ? htmlspecialchars($row['author']) : $lang['cmt_anon'];

				$profile = $template->PrepareTpl( 'cmt_bttn_prof_d', array( 'L_PROFILE' => $lang['pl_profile'] ) );
				$email = (isset($row['email'])) ?
					$template->PrepareTpl( 'cmt_bttn_email_a', array(
						'L_EMAIL'	=> $lang['send_email'],
						'URL'		=> ($conf['email_enable'] != 0)
							? 'index.php?page='.$mods->modules['m_email'].'&amp;toaddr='.htmlspecialchars(base64_encode($row['email']))
							: 'mailto:'.htmlspecialchars($row['email'])
					)) :

				$template->PrepareTpl( 'cmt_bttn_email_d', array( 'L_EMAIL' => $lang['send_email'] ) );
				$sign = '';

				$info = $lang['guest'];
			}

			if (($user->logined) && ($user->permissions == USR_ADMIN)) {

				$mod = $template->PrepareTpl('cmt_moderator_tools', array(
					'U_DELETE'	=> 'index.php?page='.$__page__.'&amp;mode=delete&amp;id='.$id.'&amp;mid='.$row['id'],
					'L_DELETE'	=> $lang['delete'],
					'L_EDIT'	=> $lang['edit'],
					'NID'		=> $id,
					'MID'		=> $row['id'],
					'NO'		=> $msgno,
				));

			} else {
				$mod = '';
			}

			// HTML Tagok szrse, ha kell
			$text = ($conf['news_enableHTML'] != 1)
				? htmlspecialchars( $row['text'] ) : $row['text'];

			// Mosolyok alkalnazsa a szvegen
			$text = $smilies->UseSmilies( $text );

			// Moderlva szveg cserje
			$text = preg_replace_callback(
				'#\[MODAT::(.*?)::(.[0-9]+?)\]#is',
				'Callback_MODAT_Text', $text
			);

			if ($conf['url_allow_auto_user'] == 1) {
				$text = FormatURL($text, ($conf['news_enableHTML'] != 1));
			}
			$text = formattext($text);

			if ($conf['user_signHTML'] != 1) {
				$sign = htmlspecialchars($sign);
			}

			if ($conf['url_allow_auto_sign'] == 1) {
				$sign = FormatURL($sign, true);
			}
			$sign = FormatText($sign);


			$template->usetpl('m_news_comments', array(
				'L_DATE' => $lang['date'],

				'ID'		=> $row['id'],
				'MOD'		=> $mod,

				'NO'		=> $msgno,
				'AUTHOR'	=> $author,

				'PROFILE'	=> $profile,
				'EMAIL'		=> $email,
				'INFO'		=> $info,

				'DATE'		=> formatdate( $row['date'] ),
				'TEXT'		=> $text,
				'SIGN'  	=> $sign,
			));

			$msgno--;

			$template->UseTpl('module_nt_end');
		}


		if ($user->permissions == USR_ADMIN) {
			$template->UseTpl('cmt_moderator_end');
		}

		if ( $msg_count > $conf['news_cmt_limit'])
		{
			$template->AddToStack( $switcher );
		}
	}
	else
	// Ha nincs hozzszls, akkor kirjuk, hogy nincs hozzszls
	{
		$template->loadfile('m_news_nocmt');

		$template->usetpl('m_news_nocmt', array( 'L_NOCOMMENTS' => $lang['nocomments'] ) );
	}
}

/**************************************
 * Kategria-lers mutatsa
 */
function show_category_desc( $cid )
{
	global $template, $db, $lang, $__page__;

	$template->AddRSSFeed( $lang['news_traceThisCat'], 'news/category/'.$cid );

	$db->sql_query('SELECT title, description FROM '.DBPREFIX.'news_category WHERE id='.$cid.' LIMIT 1');
	$row = $db->sql_fetch_array();

	$template->LoadFile('m_news_catdesc');

	$template->UseTpl('module_begin', array(
		'TITLE'	=> htmlspecialchars($row['title'])
	));

	$template->UseTpl('m_news_catdesc', array(
		'TEXT' => htmlspecialchars($row['description']),
		'URL' => 'index.php?page='.$__page__.'&amp;mode=categorys',
		'L_MORE' => $lang['news_morecat'],
	));

	$template->UseTpl('module_end');


}

/**************************************
 * Kategrialista ksztse
 */
function show_category_list()
{
	global $template, $db, $lang, $__page__;

	$db->sql_query('SELECT category FROM '.DBPREFIX.'news');
	$count = array();

	while ($row = $db->sql_fetch_array()) {
		if (isset($count[ $row['category'] ])) {
			$count[ $row['category'] ]++;
		} else {
			$count[ $row['category'] ] = 1;
		}
	}

	$db->sql_query('SELECT * FROM '.DBPREFIX.'news_category ORDER BY title ASC');

	$template->UseTpl('module_begin', array(
		'TITLE'	=> $lang['news_cattitle']
	));

	$template->LoadFile('m_news_catlist');

	while ($row = $db->sql_fetch_array()) {
		$template->UseTpl('m_news_catlist', array(
			'L_COUNT' 	=> $lang['news_count'],
			'L_MORE' 	=> $lang['news_newsInCat'],
			'TITLE'		=> htmlspecialchars($row['title']),
			'TEXT'		=> htmlspecialchars($row['description']),
			'URL'		=> 'index.php?page='.$__page__.'&amp;cid='.$row['id'],
			'COUNT'		=> (isset( $count[ $row['id'] ] )) ? $count[ $row['id'] ] : 0
		));
	}

	$template->UseTpl('module_end');
}


/*********************************************************************************
 *                         MODERTORI SEGDESZKZK
 *********************************************************************************/


/**************************************
 * Hozzszls trlse
 */

global $user;

if ($user->logined && ($user->permissions == USR_ADMIN)) {

	// !! Egyeztetend a m_news_ajax.php/ModTools_DeleteCmt() -l!
	function ModTools_DeleteComment( $cid, $mid )
	{
		global $db, $lang, $user;

		// Ellenrizzk, hogy valaki volt-e a hozzszls
		$db->sql_query('SELECT userid FROM '.DBPREFIX.'news_comments WHERE id='.$mid.' AND news='.$cid.' LIMIT 1');

		if ($db->sql_num_rows() == 0) {
			return false;
		}

		$row = $db->sql_fetch_array();

		if ((isset($row['userid'])) && (is_numeric($row['userid'])) && ($row['userid'] > 0)) {

			// Ha az UserID a modertor, az user rtegre bzzuk
			if ($row['userid'] == $user->userid) {
				$user->SetData( 'news_comments', $user->userdata['news_comments']-1 );
			} else {
				$db->sql_query('UPDATE '.DBPREFIX.'user SET news_comments = news_comments-1
					WHERE id='.$row['userid'].' LIMIT 1');
			}
		}

		$db->sql_query('DELETE FROM '.DBPREFIX.'news_comments WHERE id='.$mid.' AND news='.$cid.' LIMIT 1');

		Msg_Die( WARNING, $lang['mod_cmt_deleted'] );

		return true;
	}
}

	// Megadjuk, hogy mr betltttk egyszer a modult
	define('LOADED_M_NEWS', true);
}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $get, $conf, $template, $lang, $user, $db;

$template->AddRSSFeed( $lang['news_trace'], 'news' );
$template->AddRSSFeed( $lang['news_tracecmt'], 'news/comments' );

// Megnzzk, hogy meg van-e adva md
if (isset($get['mode']))
{
	switch ($get['mode'])
	{
		case 'onlyregusr' :
		{
		    global $lang;
			Msg_Die( WARNING, $lang['news_onlyreg'] );
			break;
		}
		case 'missing' :
		{
		    global $lang;
			Msg_Die( ERROR, $lang['news_missing'] );
			break;
		}
		case 'error' :
		{
			// global $lang;
			// Msg_Die( WARNING, $lang['pl_alreadreged']);
			show_comments( $_POST['id'] );
			break;
		}
		case 'categorys' :
		{
			show_category_list();
			break;
		}
	}

	if (($user->logined) && ($user->permissions == USR_ADMIN)) {

		switch ($get['mode'])
		{
			case 'delete' :
			{
				if (!(isset($get['id']) && isset($get['mid']))) {
					Msg_Die( WARNING, $lang['bad_url'] );
				} else {
					ModTools_DeleteComment( $get['id'], $get['mid'] );
					show_comments( $get['id'], true );
				}

				break;
			}
		}

	}
}
else
{
	global $news_dont_select;

	$news_dont_select = '';

	if (isset($get['cid'])) {
		show_category_desc($get['cid']);

		$min = (isset($get['min'])) ? $get['min'] : 0;

		$db->sql_query('SELECT COUNT(*) AS count FROM '.DBPREFIX.'news
			WHERE category = '.$get['cid'].' AND date < '.time());
		list($count) = $db->sql_fetch_array( null, SQL_NUM );

		$switcher =  CreatePgSwitcher( $count, $min, array(
			'page'	=> $__page__,
			'cid'	=> $get['cid'],
			'min'	=> '{!}',
		), $conf['news_limit']);

		$template->AddToStack( $switcher );

		show_news( $min, $conf['news_limit'], false );

		$template->AddToStack( $switcher );
	}
	else
	{
		// Megnzzk meg van-e adva ID, klnben az alaprtelmezett
		// mdot adjuk meg
		if (isset($get['id']))
		{
			show_comments( $get['id'] );
		}
		else
		{
			if ((!isset($get['cid'])) && ($conf['news_highlight'] == 1)) {
				show_news( 0, 1, true );
			}

			show_news( 0, $conf['news_limit'] );
		}
	}
}

?>