<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM
 *
 * SENDNEWS MODULE
 *
 ***************************************************************************
 *                               m_sendnews.php
 *                            -------------------
 *   kezds               : Kedd, 2004. augusztus 3.
 *   copyright            : (C) 2004 Portal Team
 *   email                : muportal@freemail.hu
 *   utoljra mdostva   : Pntek, 2005. szeptember 22.
 *   utoljra mdostotta : saxus
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/ 
 
if (!defined('MU_MODULES')) { die('File hacking'); }

if (!defined('LOADED_M_SENDNEWS')) {
	
	/***************************
	 * Lekrdezi hny hrt kldtek be
	 */
	function sendnews_GetNewsCount()
	{
		global $db;
		
		$sql = 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_submited';
		$db->sql_query( $sql );
		$line = $db->sql_fetch_array();
		return $line['count'];
	}
	
	/**************************************
	 * 
	 */
	function sendnews_Submit( $warnmode = false )
	{
		global $user, $conf, $template, $lang;
		
		if ((!$user->logined) && ($conf['sendnews_usr_mode'] == 2))
		{
		    Msg_Die( WARNING, $lang['sn_olnyreg'] );
		}
		else
		{
			// Template-k betltse
			$template->LoadPackedFile( 'm_sendnews_form' );

			// Kirs
			$template->usetpl( 'module_begin', array( 'TITLE' => $lang[ 'sn_title' ]) );

			// Figyelmeztetsek, ha kellenek
			if ($warnmode) {
				$ws = 'class="wrn"';
				$wsu = ($conf['sendnews_usr_mode'] == 1) ? $ws : '';
				$wp = $template->PrepareTpl('m_sendnews_wp', array(
					'L_WARN'		=> $lang['sn_warn'],
				));
				
				$_title = (isset($_POST['news_title'])) ? htmlspecialchars($_POST['news_title']) : '';
				$_text = (isset($_POST['news_text']))	? htmlspecialchars($_POST['news_text']) : '';
			} else {
				$ws = '';
				$wsu = '';
				$wp = '';
				
				$_title = '';
				$_text = '';
			}

			// Bejelentkezs ellenrzse
			if ($user->logined) { 
				$regmode = 'false'; 
				$unreg	= '';
			}
			else
			{
				$regmode = 'true';
				
				if ($warnmode) {
					$name = muGetCookie( 'u_name', '' );
					$email = muGetCookie( 'u_email', '' );
				} else {
					$name = (isset($_POST['news_name'])) ? $_POST['news_name']: '';
					$email = (isset($_POST['news_email'])) ? $_POST['news_email']: '';
				}
				

				$unreg = $template->PrepareTpl( 'm_sendnews_form_unreg', array(
					'L_NAME'		=> $lang['sn_yourname'],
					'L_EMAIL'		=> $lang['sn_youremail'],
					'NAME'          => $name,
					'EMAIL'         => $email,
					'R_WARN'		=> $wsu,
				));
			}


			// Ha megkveteli az admin a nevet s az email cimet, 
			// megjelentjk a figyelmeztetst			
			if ($conf['sendnews_usr_mode'] == 1) {
				$warn = $template->PrepareTpl('m_sendnews_warn', array(	
					'L_REQUIRE'	=> $lang['sn_require'],
				));
			} else {
				$warn = '';
			}
			

			$template->usetpl( 'm_sendnews_form', array(
				'REGMODE'       => $regmode,
				'R_WARN'		=> $ws,
				
				'UNREG'			=> $unreg,

				'L_REALYSEND'	=> $lang['sn_realysend'],
				'L_REQ_NAME'	=> $lang['sn_js_reqname'],
				'L_REQ_EMAIL'	=> $lang['sn_js_reqemail'],
				'L_REQ_TEXT'	=> $lang['sn_js_reqtext'],
				'L_REQ_TITLE'	=> $lang['sn_js_title'],
				'L_CONFIRM'		=> $lang['sn_js_confirm'],
				
				'L_TEXT'		=> $lang['sn_text'],
				'L_TITLE'		=> $lang['sn_news_title'],

				'L_SUBMIT'		=> $lang['sn_submit'],
				'L_REQUIRE'		=> $lang['sn_require'],
				'L_CURRENTWAIT'	=> sprintf( $lang['sn_curwait'], sendnews_GetNewsCount()),
				
				'WARN'			=> $warn,
				'WARNTOP'		=> $wp,
				
				'TITLE'			=> $_title,
				'TEXT'			=> $_text,
			));

			$template->usetpl( 'module_end' );
		}
	}

}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $template, $lang, $get, $conf, $user;

$mode = (isset($get['mode'])) ? $get['mode'] : 'submit';

switch ($mode)
{
	case 'onlyreg' :
	{
	    Msg_Die( WARNING, $lang['sn_olnyreg'] );
	    break;
	}
	case 'submit' :
	{
		sendnews_Submit();
		break;
	}
	case 'warning' : 
	{
		sendnews_Submit( true );
		break;
	}
	
	case 'done' :
	{
		$template->LoadFile( 'm_sendnews_done', 'm_sendnews_done' );
		
		$template->usetpl( 'module_begin', array( 'TITLE' => $lang[ 'sn_title' ]) );
		$template->usetpl( 'm_sendnews_done', array (
			'L_DONE' => $lang['sn_done'],
			'L_WAIT' => sprintf( $lang['sn_curwait'], sendnews_GetNewsCount() )
		));
		$template->usetpl( 'module_end' );
		break;
	}
	case 'unauthorized' :
	{
		Msg_Die( WARNING, $lang['pl_alreadreged']);
		break;
	}	
}

 
?>
