<?php
/***************************************************************************
 *
 * PORTAL CONTENT MANAGEMENT SYSTEM
 *
 * STATISTIC MODULE
 *
 ***************************************************************************
 *                              m_statistic.php
 *                            -------------------
 *   kezds               : Htf, 2004 augusztus 2.
 *   copyright            : (c) 2004-2006 Portal Team
 *   email                : muportal@freemail.hu
 *   Utoljra mdostva   : saxus; 2006. november 27.
 *   utoljra mdostotta : saxus
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/ 
 
if (!defined("MU_MODULES")) { die("File hacking"); }

if (!defined("LOADED_M_STATISTIC")) {


/**************************************
 * Listz
 */
function statistic_lister( $title, $metric, $url, $idfield = 'id', $titlefield = 'title', $countfield = 'count' )
{
	global $db, $template;
	
	$template->UseTpl('m_statistic_listbegin', array(
		'TITLE'	=> $title
	));
	
	while ($row = $db->sql_fetch_array()) {
		$template->UseTpl('m_statistic_listitem', array(
			'URL'	=> sprintf( $url, $row[ $idfield ] ),
			'TITLE'	=> $row[ $titlefield ],
			'DESC' => sprintf( $metric, $row[ $countfield ] )
		));
	}
	
	$template->UseTpl('m_statistic_listend');
}


/************************
 * 
 */
function statistic_basic ()
{
	global $template, $lang, $conf, $db, $mods; // , $__page__;
	
	// Template-k elksztse
	$template->LoadPackedFile('m_statistic');
	
	// Kirs
	$template->usetpl('module_begin', array( 'TITLE' => $lang['menu_statistic']));

	
	/****************************
	 * Ltogatottsgi statisztikk
	 */
	
	if ($conf['enable_stat'] == 1) {
	
		// sszes ltogat
		$db->sql_query( 'SELECT SUM(visitors) AS total FROM '.DBPREFIX.'stat' );
		$row = $db->sql_fetch_array();
		$stat_vis_total = $row['total'];
	
		// Napi ltogatk	
		$today = date('Ymd');
		$db->sql_query( 'SELECT visitors FROM '.DBPREFIX.'stat WHERE tdate=\''.$today.'\' LIMIT 1' );
		if ($db->sql_num_rows() == 0) {
			$stat_vis_today = 0;
		} else {
			$row = $db->sql_fetch_array();
			$stat_vis_today = $row['visitors'];
		}
		
		$template->usetpl('m_statistic_head', array( 
			'T_VISITORS' 	=> sprintf( $lang['st_title_visitors'], $conf['page_name'] ),
			'S_TOTAL' 		=> sprintf( $lang['st_vis_total'], $stat_vis_total ),
			'S_TODAY' 		=> sprintf( $lang['st_vis_today'], $stat_vis_today ),
		));
	}


	/****************************
	 * Tovbbi statisztikk
	 */

		
	$template->usetpl('m_statistic_begin', array( 
		'T_OTHER' 		=> $lang['st_title_other']
	));
			
	if (isset( $mods->modules['m_news']))
	{
		// Hrek szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'news' );
		$row = $db->sql_fetch_array();
	
		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_news'],
			'S_ITEM' => $row['count']
		));

		// Hozzszlsok szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'news_comments' );
		$row = $db->sql_fetch_array();	
			
		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_comments'],
			'S_ITEM' => $row['count']
		));
	}	
	
	if (isset( $mods->modules['m_articles']))
	{
		// Cikkek szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'articles' );
		$row = $db->sql_fetch_array();

		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_articles'],
			'S_ITEM' => $row['count']
		));
	}
	
	// Letltsek


	if (isset($mods->modules['m_downloads']))
	{
		$db->sql_query( 'SELECT COUNT(*) AS count, SUM(stat) AS c_stat, SUM(stat*filesize) AS total 
			FROM '.DBPREFIX.'downloads' );
		$row = $db->sql_fetch_array();

		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_downloads'],
			'S_ITEM' => $row['count']
		));
		
		// letltsek szma
		/*if ($row['count'] != 0) 
		{
			$db->sql_query( 'SELECT  AS count FROM '.DBPREFIX.'downloads' );
			$row = $db->sql_fetch_array();
		}*/

		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_downcount'],
			'S_ITEM' => (isset($row['c_stat'])) ? $row['c_stat'] : 0
		));
		
		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_trafictotal'],
			'S_ITEM' => CalcSize((is_numeric($row['total'])) ? $row['total'] : 0),
		));
	}
	
	// Frum statisztikk
	if (isset( $mods->modules['m_forum']))
	{
		// Tmk szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'forum_topics' );
		$row = $db->sql_fetch_array();
		
		$template->UseTpl('m_statistic_item', array(
			'L_ITEM' => $lang['st_forum_topics'],
			'S_ITEM' => $row['count']
		));
		
		// Hozzszlsok szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'forum_messages' );
		$row = $db->sql_fetch_array();
		
		$template->UseTpl('m_statistic_item', array(
			'L_ITEM' => $lang['st_forum_posts'],
			'S_ITEM' => $row['count']
		));
	}
	
	if (isset( $mods->modules['m_user']))
	{
		// Regisztrlt tagok szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'users WHERE permissions >= 0' );
		$row = $db->sql_fetch_array();

		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_users'],
			'S_ITEM' => $row['count']
		));
	}
	
	if (isset( $mods->modules['m_links']))
	{
		// Linkek szma
		$db->sql_query( 'SELECT COUNT(*) AS count FROM '.DBPREFIX.'links' );
		$row = $db->sql_fetch_array();
		
		$template->usetpl('m_statistic_item',array(
			'L_ITEM' => $lang['st_links'],
			'S_ITEM' => $row['count']
		));
	}
		
	$template->usetpl('m_statistic_end', array( 
			
		'L_VER'			=> $lang['st_ver'],
		'S_VER'			=> MP_VER_NUM,
		
		// 'U_ADVANCED'	=> 'index.php?page='.$__page__.'&page=advanced',
		// 'L_ADVANCED'	=> $lang['st_jump']
	));
	
	
	
	/****************************
	 * Legaktvabb
	 */
	
	if ($conf['stat_limit'] != 0 ) {

		// Hrek
		if (isset($mods->modules['m_news'])) 
		{
			$db->sql_query('SELECT c.news AS id, COUNT(*) AS count, n.title AS title
				FROM '.DBPREFIX.'news_comments c
				LEFT JOIN '.DBPREFIX.'news n ON (c.news = n.id)
				GROUP BY news
				ORDER BY count DESC
				LIMIT 0, '.$conf['stat_limit']
			);
			
	
			if ($db->sql_num_rows() != 0) { 
				statistic_lister( $lang['st_mostNews'], $lang['st_mostNewsMtrc'], 
					'index.php?page='.$mods->modules['m_news'].'&amp;id=%s'  );
			}
		}
				
		// Cikkek
		if (isset($mods->modules['m_articles'])) 
		{
			$db->sql_query('SELECT id, title, readed AS count
				FROM '.DBPREFIX.'articles
				WHERE readed != 0
				ORDER BY readed DESC
				LIMIT 0, '.$conf['stat_limit']
			);
	
	
			if ($db->sql_num_rows() != 0) { 
				statistic_lister( $lang['st_mostArticles'], $lang['st_mostArticlesMtrc'], 
					'index.php?page='.$mods->modules['m_articles'].'&amp;id=%s'  );
			}	
		}
			
		// Letltsek
		if (isset($mods->modules['m_downloads'])) 
		{
			$db->sql_query('SELECT id, title, stat AS count
				FROM '.DBPREFIX.'downloads
				WHERE stat != 0
				ORDER BY stat DESC
				LIMIT 0, '.$conf['stat_limit']
			);
			
			if ($db->sql_num_rows() != 0) { 
				statistic_lister( $lang['st_mostDownloads'], $lang['st_mostDownloadsMtrc'], 
					'index.php?page='.$mods->modules['m_downloads'].'&amp;mode=details&amp;id=%s'  );		
			}
		}
			
		// Linkek
		if (isset($mods->modules['m_links'])) 
		{
			$db->sql_query('SELECT id, name AS title, statistic AS count
				FROM '.DBPREFIX.'links
				WHERE statistic != 0
				ORDER BY statistic DESC
				LIMIT 0, '.$conf['stat_limit']
			);
				
			if ($db->sql_num_rows() != 0) { 
				statistic_lister( $lang['st_mostLinks'], $lang['st_mostLinksMtrc'], 
					'index.php?load='.$mods->modules['m_links'].'&amp;id=%s'  );	
			}
		}
					
	} // Legaktvabb
	
	
	$template->usetpl('module_end');
}

} // if defined

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/
 
global $get;

$mode = (isset($get['mode'])) ? $get['mode'] : 'basic';

switch ($mode)
{
	case 'basic' :
	{
		statistic_basic();
		break;
	}
	case 'advanced' :
	{
		statistic_advanced();
		break;
	}
}

?>