<?php
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: m_user.php 104 2008-04-14 12:35:53Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/

if (!defined('LOADED_M_USER')) {

	/*********************************
	 * Kijelentkeztets
	 */
	function User_Logout()
	{
		global $conf, $get, $lang, $mods, $user, $conf;

		$user->LogoutUser();

		if (defined('MU_SELF')) {

			if (!isset($get['redirect'])) { $get['redirect'] = ''; }

			$fwd = Decode_Forwarder( $get['redirect'] );
			$redirect = ($fwd['page'] == $mods->modules['m_user'])
				? $conf['page_default'] : $get['redirect'];

			muRedirect( 'index.php?'.$redirect, $lang['pl_logout_done'] );

		} else {

			Msg_Die( MESSAGE, $lang['pl_logout_done'] );

		}

	}

	/**************************************
	 * j jelsz ignylse
	 */
	function User_ForgotPW()
	{
		global $template, $lang, $conf, $get, $__page__;

		$template->LoadPackedFile('m_user_forgotpw');

		$template->UseTpl('module_begin', array(
			'TITLE'	=> $lang['pl_forgotpw']
		));

		$warn = (isset($get['#WARN'])) ?
			$template->PrepareTpl('m_user_fp_w', array( 'TEXT' => $get['#WARN'] )) : '';

		$template->UseTpl('m_user_forgotpw', array(
			'TEXT'			=> str_replace(
					array('{R}', '{L}'),
					array(
						'index.php?page='.$__page__.'&amp;mode=registration',
						'index.php?page='.$__page__.'&amp;mode=login',
					),
					FormatText( $lang['pl_fpw_text'] )
				),
			'EMAIL_ADDR'	=> (isset($get['#EMAIL_ADDR'])) ? $get['#EMAIL_ADDR']  : '',
			'WARN'			=> $warn,

			'L_EMAIL'		=> $lang['email_addr'],
			'L_SUBMIT'      => $lang['sn_submit'],
		));

		$template->UseTpl('module_end');
	}

	/*********************************
	 * Regisztrcis rlap
	 */
	function User_Registration() //( $nick = '', $email = '' )
	{
		global $template, $lang, $conf, $get, $__page__;

		// Ellenrizzk, hogy egyltaln aktv-e a regisztrci
		if ( $conf['user_enablereg'] != 1 ) {
			Msg_Die( WARNING, $lang['pl_disablereg']);
			return false;
		}

		$template->LoadPackedFile('m_user_registration');

		$i_nick = (isset($get['err_usr'])) ?
			$template->PrepareTpl( 'm_user_reg_invalid', array('TEXT' => $lang['pl_user_used'])) : '';

		$i_email = (isset($get['err_email'])) ?
			$template->PrepareTpl( 'm_user_reg_invalid', array('TEXT' => $lang['pl_email_used'])) : '';

		$name = (isset($get['nu_name'])) ? $get['nu_name'] : '';
		$email1 =  (isset($get['nu_email1'])) ? $get['nu_email1'] : '';
		$email2 =  (isset($get['nu_email2'])) ? $get['nu_email2'] : '';

		if (isset($get['nu_email'])) {
			$email1 = $get['nu_email'];
			$email2 = $get['nu_email'];
		}

		if ($conf['user_regmethod'] == 0) {
			$pass = $template->PrepareTpl('m_user_reg_pwfield', arraY(
				'PW'            => $lang['password'],
				'PWTOO'         => $lang['password_too'],
			));
		} else {
			$pass = '';
		}

		if (isset($get['err_text'])) {
			$warning = $template->PrepareTpl('m_user_reg_warning', array(
				'TEXT'	=> $get['err_text']
			));
		} else {
			$warning = '';
		}

		$notice = ($conf['user_regmethod'] == 0) ? '' :
			'<div class="text">'.(($conf['user_regmethod'] == 1) ? $lang['pl_reg_notify'] : $lang['pl_reg_activation']).'</div>';

		$template->UseTpl('module_begin', array('TITLE' => $lang['menu_registration'] ));

		$template->UseTpl('m_user_registraiton', array(
		    // rendszerbelltsok
			'POST'          => 'index.php',
		    'LGPW'			=> $conf['user_paswminlg'],
		    'LGNICK'		=> $conf['user_nickminlg'],

		    // Vltozk rtkei
		    'NU_EMAIL1'     => htmlspecialchars($email1),
		    'NU_EMAIL2'     => htmlspecialchars($email2),
		    'NU_NICK'		=> htmlspecialchars($name),

		    'I_NICK'		=> $i_nick,
		    'I_EMAIL'		=> $i_email,

		    // JavaScript szvegek
		    'L_REQ_NICK'	=> $lang['sn_js_reqname'],
		    'L_REQ_EMAIL'	=> $lang['sn_js_reqemail'],
		    'L_REQ_PW1'		=> $lang['pl_js_newpw1'],
		    'L_REQ_PW2'		=> $lang['pl_js_newpw2'],
			'L_PW_DIFFER'	=> $lang['pl_js_newpwdif'],

			// Szvegek
			'TEXT'          => str_replace(
				'{URL}',
				'index.php?page='.$__page__.'&amp;mode=privacy',
				FormatText( $lang['pl_reg_text']
			)),
			// Szvegek
			'GETBACKPW'		=> str_replace(
				'{URL}',
				'index.php?page='.$__page__.'&amp;mode=forgotpw',
				FormatText( $lang['pl_reg_forgotpw']
			)),
			'NOTICE'		=> $notice,
			'WARNING'		=> $warning,

			'L_SUBMIT'      => $lang['sn_submit'],

			'NICK'          => $lang['name'],
			'EMAIL1'        => $lang['email_addr'],
			'EMAIL2'        => $lang['email_again'],
			'PASS'			=> $pass
		));

		$template->UseTpl('module_end');

		return true;
	}

	function User_Registration_Done()
	{
		global $lang, $get;

		switch ($get['methodtext'])
		{
			case 0 : $regstat = $lang['pl_reg_done'];				break;
			case 1 : $regstat = $lang['pl_reg_done_notification'];	break;
			case 2 : $regstat = $lang['pl_reg_done_verify'];		break;
		}
		Msg_Die( MESSAGE, $regstat, $lang['menu_registration'] );

		User_LoginForm();
	}

	/*********************************
	 * Bejelentkezs ablak
	 */
	function User_LoginForm()
	{
		global $template, $lang, $conf, $__page__;

		$template->LoadFile('m_user_login');

		$template->UseTpl('module_begin', array(
			'TITLE' => $lang['pl_intitle']
		));

		$template->UseTpl('m_user_login', array(
			'FORWARDER'		=> $conf['page_default'],

			'L_AUTOMATIC'	=> $lang['automatic'],
			'L_NAME'		=> $lang['name'],
			'L_PASSWORD'	=> $lang['password'],
			'L_LOGIN'		=> $lang['login'],
			'L_LOGININFO'	=> str_replace( '{REG}', 'index.php?page='.$__page__.'&amp;mode=registration', $lang['pl_login_logininfo'] ),
			'L_FORGOTPW'	=> str_replace( '{SEND}', 'index.php?page='.$__page__.'&amp;mode=forgotpw', $lang['pl_login_forgot'] ),
		));

		$template->UseTpl('module_end');
	}

	/*********************************
	 * Regisztrlt tag - profil men
	 */
	function User_Profile_Menu()
	{
		global $template, $user, $lang, $__page__;

		$template->LoadFile('m_user_prfmenu');

		$template->UseTpl('module_begin', array(
			'TITLE' => sprintf( $lang['pl_profile_t'], htmlspecialchars($user->userdata['name']) )
		));

		$template->UseTpl('m_user_prfmenu', array(
			'L_STAT' => $lang['info'],
			'L_INFO' => $lang['pl_modify'],
			'L_PASW' => $lang['pl_changepw'],
			'L_LOGOUT' => $lang['pl_logout'],

			'U_STAT' => 'index.php?page='.$__page__.'&amp;mode=profile&amp;sub=stat',
			'U_INFO' => 'index.php?page='.$__page__.'&amp;mode=profile&amp;sub=modify',
			'U_PASW' => 'index.php?page='.$__page__.'&amp;mode=profile&amp;sub=pasw',
			'U_LOGOUT' => 'index.php?load='.$__page__.'&amp;mode=logout',
		));

		$template->UseTpl('module_end');
	}

	/*********************************
	 * Profil - Statisztika
	 */
	function User_Profile_Stat()
	{
		global $template, $lang, $user, $mods;

		$template->LoadPackedFile('m_user_stat');

		// Keretek bevezetse
		$template->UseTpl('module_begin', array( 'TITLE' => $lang['info'] ));
		$template->UseTpl('m_user_stat_begin');

		/**************************
		 * Mezk kirsa
		 */

		// Regisztrls dtuma
		$template->UseTpl('m_user_stat_item', array(
			'TEXT' => $lang['pl_st_regdate'],
			'VALUE' => formatdate($user->userdata['regdate'])
		));

		// Hozzszlsok hrekhez
		if (isset( $mods->modules['m_news'] ))
		{
			$template->UseTpl('m_user_stat_item', array(
				'TEXT' => $lang['st_comments_total'],
				'VALUE' => $user->userdata['news_comments']
			));
		}

		// Keretek lezrsa
		$template->UseTpl('m_user_stat_end');
		$template->UseTpl('module_end');
	}

	/*********************************
	 * Profil - Adatmdosts
	 */
	function User_Profile_Modify()
	{
		global $template, $lang, $user, $conf, $mods;

		// Mintk betltse
		$template->LoadPackedFile('m_user_profile');

		// Publikus E-Mail cm Kapcsol belltsa
		if ( $user->userdata['email_public'] == 1 )
		{
			$pe_yes = ' checked="checked" ';
			$pe_no = '';
		} else {
			$pe_yes = '';
			$pe_no = ' checked="checked" ';
		}

		// E-Mail kld belltsa
		if ( $user->userdata['email_cansend'] == 1 )
		{
			$cs_yes = ' checked="checked" ';
			$cs_no = '';
		} else {
			$cs_yes = '';
			$cs_no = ' checked="checked" ';
		}

		// letkor
		//$old = ($user->userdata != NULL ) ? $user->userdata['user_old'] : '';

		// Alrs lersa
		if ( $conf['user_signHTML'] == 1) { $sign_d = $lang['pl_can']; } else { $sign_d = $lang['pl_cannot']; }

		$sign_d = ( $conf['user_signmaxlg'] > 0 )
			? $lang['pl_sing_d'].' '.sprintf($lang['pl_sing_maxlg'], $conf['user_signmaxlg'] ).' '.$sign_d
			: $sign_d = $lang['pl_sing_d'].' '.$sign_d;

		// E-Mail kld aktivlsa
		if ((isset($mods->modules['m_email'])) && ($conf['email_enable'] != 0)) {
			$emailsender = $template->PrepareTpl('m_user_email_cansend', array(
				'L_EMAIL_CANSEND'	=> $lang['pl_cansend_t'],
				'L_DESC'			=> $lang['pl_cansend'],
				'UECAN_Y'			=> $cs_yes,
				'UECAN_N'			=> $cs_no,
			));
		} else {
			$emailsender = '';
		}


		// Keretek bevezetse
		$template->UseTpl('module_begin', array( 'TITLE' => $lang['pl_modify'] ));

		// rlap megjelentse
		$template->UseTpl('m_user_profile', array(
			'SIGN_MAXLG'		=> $conf['user_signmaxlg'],
			'L_JS_SIGN_MAXLG'	=> sprintf( $lang['pl_signtoolong'], $conf['user_signmaxlg'], '\'+lg+\''),

			'DESC'			=> $lang['pl_profile_desc'],

			'L_TITLE_REG'	=> $lang['pl_regdata'],
			'L_DESC_REG'	=> $lang['pl_required'],

			'L_YOURNAME'	=> $lang['sn_yourname'],
			'YOURNAME'		=> htmlspecialchars($user->userdata['name']),

			'L_EMAIL'		=> $lang['sn_youremail'],
			'EMAIL'			=> htmlspecialchars($user->userdata['email']),

			'EMAIL_CANSEND'	=> $emailsender,

			'L_EMAIL_PUBLIC'=> $lang['pl_publicemail'],
			'L_PUBMAIL'		=> $lang['pl_pubmail'],
			'UEPUB_Y'		=> $pe_yes,
			'UEPUB_N'		=> $pe_no,
			'L_YES'			=> $lang['yes'],
			'L_NO'			=> $lang['no'],

			'L_TITLE_PROFILE'=> $lang['pl_profiledata'],
			'L_DESC_PROFILE'=> $lang['pl_notreq'],

			'L_TITLE_IM'	=> $lang['pl_imdata'],
			'L_DESC_IM'		=> $lang['pl_imdesc'],

			'L_TITLE_OTHER'	=> $lang['pl_otherdata'],
			'L_DESC_OTHER'	=> $lang['pl_otherdesc'],

			'L_JABBER'		=> $lang['yjabber'],
			'JABBER'		=> htmlspecialchars($user->userdata['user_jabber']),

			'L_SKYPE'		=> $lang['yskype'],
			'SKYPE'			=> htmlspecialchars($user->userdata['user_skype']),

			'L_ICQ'			=> $lang['yicq'],
			'ICQ'			=> htmlspecialchars($user->userdata['user_icq']),

			'L_AIM'			=> $lang['yaim'],
			'AIM'			=> htmlspecialchars($user->userdata['user_aim']),

			'L_MSN'			=> $lang['ymsn'],
			'MSN'			=> htmlspecialchars($user->userdata['user_msn']),

			'L_BLOG'		=> $lang['blog'],
			'BLOG'			=> htmlspecialchars($user->userdata['user_blog']),

			'L_YAHOO'		=> $lang['yyahoo'],
			'YAHOO'			=> htmlspecialchars($user->userdata['user_yahoo']),

			'L_WEBSITE'		=> $lang['ywebsite'],
			'WEBSITE'		=> htmlspecialchars($user->userdata['user_website']),

			'L_LOCATION'	=> $lang['ylocation'],
			'LOCATION'		=> htmlspecialchars($user->userdata['user_location']),

			'L_OCC'			=> $lang['yoccupation'],
			'OCC'			=> htmlspecialchars($user->userdata['user_occ']),

			'L_OLD'			=> $lang['yold'],
			'OLD'			=> htmlspecialchars($user->userdata['user_old']),

			'L_INTERESTS'	=> $lang['yinterests'],
			'INTERESTS'		=> htmlspecialchars($user->userdata['user_interests']),

			'L_SIGN'		=> $lang['signature'],
			'L_SIGN_D'		=> $sign_d,
			'SIGN'			=> htmlspecialchars($user->userdata['user_sig']),

			'L_SUBMIT'		=> $lang['sn_submit']

		));

		// Keretek lezrsa
		$template->UseTpl('module_end');
	}

	/*********************************
	 * Profil - jelsz mdostsa
	 */
	function User_Profile_ChangePW()
	{
		global $template, $lang, $conf, $get;

		if (isset($get['_warn'])) {
			Msg_Die( WARNING, $get['_warn'] );
		}

		$template->LoadFile('m_user_changepw');

		$template->UseTpl('module_begin', array( 'TITLE' => $lang['pl_changepw'] ));

		$template->UseTpl('m_user_changepw', array(
			// Rendszerbelltsok
			'MINCH'	=> $conf['user_paswminlg'],

			// Javascriptek szvegei:
			'L_REQ_OLDPW' => $lang['pl_js_oldpw'],
			'L_REQ_NEW1' => $lang['pl_js_newpw1'],
			'L_REQ_NEW2' => $lang['pl_js_newpw2'],
			'L_NEWPW_DIFFER' => $lang['pl_js_newpwdif'],

			// Tblzat
			'L_OLDPW'		=> $lang['pl_oldpw'],
			'L_NEWPW1'		=> $lang['pl_newpw1'],
			'L_NEWPW2'		=> $lang['pl_newpw2'],
			'L_SUBMIT'		=> $lang['sn_submit']
		));

		$template->UseTpl('module_end');
	}

	/**************************************
	 * Adatvdelmi nyilatkozat
	 */
	function User_Privacy()
	{
		global $template, $lang, $conf;

		$file = 'mu-sys/language/'.$conf['lang_default'].'/privacy.txt';

		$text = @fread( @fopen($file, 'r') , @filesize($file) );

		$template->UseTpl('module_begin', array(
			'TITLE'	=> $lang['pl_privacy']
		));

		if ($text == '') {
			$template->UseTpl('#ECHO', $lang['pl_privacyLoadErr'] );
		} else {
			$template->LoadFile('m_user_privacy');
			$template->UseTpl('m_user_privacy', array(
				'TEXT'	=> FormatText( $text )
			));
		}

		$template->UseTpl('module_end');
	}

	/**************************************
	 * Felhasznl aktivlsa
	 */
	function User_Activation()
	{
		global $template, $db, $conf, $lang, $get;

		$db->sql_query('SELECT id, permissions FROM '.DBPREFIX.'users WHERE id = '.$get['uid'].' AND MD5(CONCAT( id, \''.$conf['security_key'].'\'))=\''.$get['sid'].'\' LIMIT 1');
		$row = $db->sql_fetch_array();

		if ($row['id'] == false || $row['permissions'] != -1) {

			$errormsg = $lang['pl_reg_email_verify_faild'];

		} else {

			$db->sql_query('UPDATE '.DBPREFIX.'users SET permissions=0 WHERE id='.$row['id'].' LIMIT 1');
			$errormsg = $lang['pl_reg_email_verify_done'];

		}

		Msg_Die(MESSAGE, $errormsg);
		User_LoginForm();

	}

	/**********************************
	 * Egy tag profiljnak kijelzse
	 */
	function Members_Profile( $id = NULL )
	{
		global $template, $db, $lang, $conf, $mods;

		$db->sql_query( 'SELECT name, email, email_public, email_cansend, regdate, permissions,
				user_icq, user_aim, user_msn, user_yahoo, user_skype,
				user_blog, user_website, user_location, user_occ, user_old, user_interests,
				user_sig, news_comments
			FROM '.DBPREFIX.'users
			WHERE id='.$id.'
			LIMIT 1' );

		if ($db->sql_num_rows() == 0)
		{
			Msg_Die( ERROR, $lang['err_missing'] );
			return false;
		}

		$row = $db->sql_fetch_array();

		$template->LoadPackedFile('m_members_profile');

		$template->UseTpl('module_begin', array( 'TITLE' => sprintf($lang['pl_profile_t'], htmlspecialchars($row['name'])) ));

		/***************
		 * Elrhetsgek megjelentse
		 */
		$template->UseTpl('profile_c_begin', array( 'L_CONTACT' => $lang['ml_contact'] ) );

		// Megnzzk, hogy egyltaln meg van-e adva valamilyen informci
		if (($row['email_public'] == 0) &&
			($row['email_cansend'] == 0) &&
			($row['user_icq'] == NULL) &&
			($row['user_aim'] == NULL) &&
			($row['user_msn'] == NULL) &&
			($row['user_skype'] == NULL) &&
			($row['user_yahoo'] == NULL) &&
			($row['user_blog'] == NULL) &&
			($row['user_website'] == NULL)
		) {
			$template->UseTpl('profile_noitem', array( 'TEXT' => $lang['ml_noinfo'] ));
		}
		else
		{
			// E-Mail cm
			if ($row['email_public'] == 1)
			{
				$template->UseTpl('profile_c_email', array(
					'L_EMAIL'	=> $lang['email'],
					'EMAIL'		=> htmlspecialchars($row['email'])
				));
			}

			// Bels levlkld
			if (($row['email_cansend'] == 1) && ((isset($mods->modules['m_email'])) && (($conf['email_enable'] == 2) || (($user->logined) && ($conf['email_enable'] == 1)))))
			{
				$template->UseTpl('profile_c_mod_email', array(
					'L_MODEMAIL'	=> $lang['em_sendmail'],
					'URL'			=> 'index.php?page='.$mods->modules['m_email'].'&amp;toid='.$id,
					'L_SEND'		=> $lang['em_sendtitle'],
				));
			}


			// MSN Messenger
			if ( $row['user_msn'] != NULL)
			{
				$template->UseTpl('profile_c_msn', array(
					'L_MSN'		=> $lang['msn'],
					'MSN'		=> htmlspecialchars($row['user_msn'])
				));
			}


			// MSN Messenger
			if ( $row['user_skype'] != NULL)
			{
				$template->UseTpl('profile_c_skype', array(
					'L_SKYPE'		=> $lang['skype'],
					'SKYPE'			=> htmlspecialchars($row['user_skype'])
				));
			}

			// YAHOO Messenger
			if ( $row['user_yahoo'] != NULL)
			{
				$template->UseTpl('profile_c_yahoo', array(
					'L_YAHOO'	=> $lang['yahoo'],
					'YAHOO'		=> htmlspecialchars($row['user_yahoo'])
				));
			}

			// AIM Cm
			if ( $row['user_aim'] != NULL)
			{
				$template->UseTpl('profile_c_aim', array(
					'L_AIM'	=> $lang['aim'],
					'AIM'		=> htmlspecialchars($row['user_aim'])
				));
			}

			// ICQ Szm
			if ( $row['user_icq'] != NULL)
			{
				$template->UseTpl('profile_c_icq', array(
					'L_ICQ'	=> $lang['icq'],
					'ICQ'		=> htmlspecialchars($row['user_icq'])
				));
			}
		}

		$template->UseTpl('profile_c_end');

		/***************
		 * Szemlyes informcik megjelentse
		 */
		$template->UseTpl('profile_u_begin', array( 'L_ABOUT' => sprintf($lang['ml_about'], htmlspecialchars($row['name'])) ));

		// Regisztrls ideje
		$template->UseTpl('profile_u_item', array(
			'L_TEXT'	=> $lang['joined'],
			'VALUE'		=> formatdate($row['regdate'], $conf['dateshort'] )
		));

		// Hozzszlsok hrekhez
		$template->UseTpl('profile_u_item', array(
			'L_TEXT'	=> $lang['st_comments_total'],
			'VALUE'		=> $row['news_comments']
		));

		// Lakhely
		if ( $row['user_location'] != NULL)
		{
			$template->UseTpl('profile_u_item', array(
				'L_TEXT'	=> $lang['location'],
				'VALUE'		=> htmlspecialchars($row['user_location'])
			));
		}


		// Blog
		if ( $row['user_blog'] != NULL)
		{
			$template->UseTpl('profile_u_website', array(
				'L_TEXT'	=> $lang['blog'],
				'URL'		=> htmlspecialchars($row['user_blog'])
			));
		}

		// Honlap
		if ( $row['user_website'] != NULL)
		{
			$template->UseTpl('profile_u_website', array(
				'L_TEXT'	=> $lang['website'],
				'URL'		=> htmlspecialchars($row['user_website'])
			));
		}

		// Foglalkozs
		if ( $row['user_occ'] != NULL)
		{
			$template->UseTpl('profile_u_item', array(
				'L_TEXT'	=> $lang['occupation'],
				'VALUE'		=> htmlspecialchars($row['user_occ'])
			));
		}

		// rdekldsi kr
		if ( $row['user_interests'] != NULL)
		{
			$template->UseTpl('profile_u_item', array(
				'L_TEXT'	=> $lang['interests'],
				'VALUE'		=> htmlspecialchars($row['user_interests'])
			));
		}

		$template->UseTpl('profile_u_end');

		$template->UseTpl('module_end');

		return true;
	}

	// Megadjuk, hogy mr betltttk egyszer a modult
	define('LOADED_M_USER', true);
}

/*********************************************************************************
 *
 *                                 BELPSI PONT
 *
 *********************************************************************************/

global $get, $user, $lang, $conf;

if ( defined('MU_MODULES') )
{
	if (!$user->logined)
	{
		$mode = (isset($get['mode'])) ? $get['mode'] : 'login';

		switch ( $mode )
		{
			// Hibs jelsz vagy felhasznlnv panel
			case '#pwerror#' :
			{
				global $lang;

				switch ($get['code']) {
					case LOGIN_PWERR : {
						Msg_Die(WARNING, $lang['pl_pwerror']);
						User_LoginForm();
						break;
					}
					case LOGIN_DISABLED: {
						Msg_Die(WARNING, $lang['pl_disabled']);
						break;
					}
				}

				break;
			}

			// zenet
			case '#msg#' :
			{
				Msg_Die( MESSAGE, $get['_text'], $get['_title'] );
				break;
			}


			// Regisztrcis rlap
			case 'registration' :
			{
				User_Registration();

				break;
			}

			case 'registrarion_done' :
			{
				User_Registration_Done();

				break;
			}

			// Elfelejtett jelsz ablak
			case 'forgotpw' :
			{
				User_ForgotPW();
				break;
			}

			case 'forgotpw_done' :
			{
				Msg_Die( MESSAGE, $lang['pl_fp_done'], $lang['pl_forgotpw'] );

				User_LoginForm();
				break;
			}

			// Bejelentkezs
			case 'login' :
			{
				User_LoginForm();
				break;
			}
			// Aktivls
			case 'activation' : {
				User_Activation();
				break;
			}
			case 'details' : {
				if ($conf['members_onlyreg_prof'] == 1)
				{
					Msg_Die( WARNING, $lang['pl_req_login'], $lang['ml_title']);
				} else {
					Members_Profile( $get['id'] );
				}
				break;
			}
			// Adatvdelmi nyilatkozat
			case 'privacy' :
			{
				User_Privacy();
				break;
			}

			// Regisztrci - nem hasznlhat
			/*case 'registration' : {
				Msg_Die( WARNING, $lang['func_disabled'] );
				break;
			}*/

			// Kamu funkci
			default : {
				User_LoginForm();
				// Msg_Die( WARNING, $lang['func_nothing'] );
				break;
			}
		}
	}
	else
	{
		$mode = (isset($get['mode'])) ? $get['mode'] : 'profile';

		switch ( $mode )
		{
			/********************
			 * Profil men
			 */
			case 'profile' :
			{
				if (isset($get['sub'])) { $sub = $get['sub']; } else { $sub = 'stat'; }

				User_Profile_Menu();

				switch ( $sub )
				{
					// Informcik
					case 'stat' :
					{
						User_Profile_Stat();
						Break;
					}
					// Jelsz mdostsa
					case 'pasw' :
					{
						User_Profile_ChangePW();
						Break;
					}
					// Adatmdosts
					case 'modify' :
					{
						User_Profile_Modify();
						Break;
					}
					// zenet
					case '#msg#' :
					{
						Msg_Die( MESSAGE, $get['_text'], $get['_title'] );
						break;
					}
				}
				break;
			} // profile

			// zenet
			case '#msg#' :
			{
				Msg_Die( MESSAGE, $get['_text'], $get['_title'] );
				break;
			}

			case 'logout' : {
				User_Logout();
				break;
			}

			// Adatvdelmi nyilatkozat - regisztrltak szmra is elrhet
			case 'privacy' : {
				User_Privacy();
				break;
			}
			// Regisztrci s j jelsz krse - nem hasznlhat
			case 'forgotpw' :
			case 'registration' : {
				Msg_Die( WARNING, $lang['func_disabled'] );
				break;
			}
			case 'details' : {
				Members_Profile($get['id']);
				break;
			}

			// Kamu funkci
			default : {
				User_Profile_Menu();
				User_Profile_Stat();
				// Msg_Die( WARNING, $lang['func_nothing'] );
				break;
			}


		}
	}
}
elseif (defined('MU_SELF'))
{
	global $get;

	$mode = (isset($get['mode'])) ? $get['mode'] : '';

	switch ($get['mode'])
	{
		case 'logout' : {
			User_Logout();
			break;
		}
	}
}
else
{
	die('File hacking');
}


?>