<?php 
/*******************************************************************************
 * muPortal Content Management System
 * (c) 2004-2006 muPortal Team
 *******************************************************************************
 * $Id: rss.php 43 2007-04-25 22:15:42Z saxus $
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *******************************************************************************/ 
 
define('MUPORTAL', true);

//Header('Content-type: text/plain'); 
Header('Content-type: text/xml'); 

// Msg_Die rtkek
define('MESSAGE', 100);
define('WARNING', 101);
define('ERROR', 102);
define('CRITICAL', 103);

// Filter rtk
define( 'FLTR_RSS', 49152 );

require('config.php');
require('mu-sys/includes/sql-'.SQLHANDLER.'.php');

global $db, $conf, $rsslang, $lang, $cfg;

$db = new sql_db( $cfg );
unset( $cfg );

// Belltsok betltse
$db->sql_query('SELECT cache FROM '.DBPREFIX.'cache WHERE filter='.FLTR_RSS.' AND id=\'rssConf\' LIMIT 1');
$conf = $db->sql_fetch_array();
$conf = unserialize($conf['cache']);

// GZIP bekapcsolsa
if ($conf['gzip_enable'] == 1) {
	
	if (extension_loaded('zlib') && (!headers_sent()) && (strstr( $_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip' ))) {
		
		ob_start('ob_gzhandler');
		
		define('GZIP_STARTED', true);
		
		// Definiljuk a lezr funcit
		function GZIP_DONE() 
		{
				ob_end_flush ();
		}		
	}
}

include('mu-sys/language/'.$conf['lang_default'].'/rss.php');

$lang = &$rsslang;

// ===========================================================================
//
//								FGGVNYEK
//
// ===========================================================================


/**
 * String rvidtse, ha kell
 */
function StrTrunc ( $str = '', $maxln = 40 )
{
	if (strlen($str) > $maxln) { 
		return substr( $str, 0, $maxln).'...';
	} else { 
		return $str;
	}
}


/**
 * Preview SQL kd generlsa
 */
function Preview( $field, $alias = 'preview' )
{
	global $conf;
	
	if ($conf['rss_maxdesclg'] == 0) {
		return $field.' AS '.$alias;
	} else {
		return 'LEFT('.$field.','.$conf['rss_maxdesclg'].') AS '.$alias;
	}
}


/**
 * Msg_Die helyettest
 */
function Msg_Die( $level, $text, $title = NULL, $dienow = false ) 
{
	echo $text;
	
	if ($dienow || ($level == CRITICAL)) { die(); }
}


/**
 * Cm kirsa
 */
function RSSTitle( $title = '', $url = '', $desc = '' ) 
{
	echo '<title>'.htmlspecialchars(nl2br($title)).'</title>
	<link>'.$url.'</link>
	<description>'.htmlspecialchars(nl2br($desc)).'</description>'."\n\t";
}


/**
 * Egy-egy elem kirsa
 */
function RSSItem ( $title = '', $url = '', $desc = '', $pubDate = null, $category = null)
{
	global $conf;
	
	echo '<item>
		<title>'.htmlspecialchars(nl2br($title)).'</title>
		<link>'.$url.'</link>
		<description>'.htmlspecialchars(nl2br($desc)).'</description>'."\n\t";	
	if ((isset($pubDate)  && ($pubDate !== false)))  { echo "\t".'<pubDate>'.Date('r', $pubDate).'</pubDate>'."\n\t"; }
	if ((isset($category) && ($category !== false))) { echo "\t".'<category>'.htmlspecialchars(nl2br($category)).'</category>'."\n\t"; }
	echo "</item>\n\t";
}

define('D_TODAY', mktime ( 0, 0, 0, Date('n'), (Date('j')), Date('Y') ));
define('D_YESTERDAY', D_TODAY-86400 );
define('D_TOMORROW', D_TODAY+86400 );


/**
 * Kiegszt fggvny a FormatDate -hoz:
 * Ha be van kapcsolva az, hogy a 'ma' s a
 * tegnmap feliratok megjelenhetnek dtumban,
 * akkor ezt hvja meg a FormatDate
 */
function FormatDate_TEXT( $date, $format = NULL )
{
	global $lang, $conf;
			
	// Ma
	if (( $date < D_TOMORROW ) && ( $date >= D_TODAY )) {					
		return sprintf( $lang['today'], Date( (isset($format)) ? '' : $conf['timeformat'], $date ) );	
	} // Tegnap
	elseif (( $date < D_TODAY ) && ( $date >= D_YESTERDAY ))
	{
		return sprintf( $lang['yesterday'], Date( (isset($format)) ? '' : $conf['timeformat'], $date ) );
	} else { // Egybb
		return Date( (isset($format)) ? $format : $conf['dateformat'], $date );
	}
}


/**
 * Unix idblyeget konvertlja t a 
 * config->dateformat-ban megadott formtumra
 */
function FormatDate( $date, $format = NULL ) 
{
	global $conf;
	
	if ($conf['date_today'] == 1) {
		return FormatDate_TEXT( $date, $format );
	} else {		
	    return Date( (isset($format)) ? $format : $conf['dateformat'], $date );
	}
} 

/**
 * MODURL konstans definilsa
 */
function getURLBase( $mod )
{
	global $db;
	
	$db->sql_query('SELECT page FROM '.DBPREFIX.'modules WHERE module = \'m_'.$mod.'\' LIMIT 1');
		
	if ($db->sql_num_rows() == 1) {
		$row = $db->sql_fetch_array();
		define('MODURL', URL.'index.php?page='.$row['page'].'&amp;');
	} else {
		Msg_Die( CRITICAL, 'Nem tallom a m_'.$mod.' modult!');
	}
}


// ===========================================================================
//
//								BELPSI PONT
//
// ===========================================================================

echo '<?xml version="1.0" encoding="ISO-8859-2" ?>
<rss version="2.0">

<channel>'."\n\t";

$rsserr = false;

if ($conf['rss_enable'] == 0) { 

	$rsserr = $rsslang['rss_disabled']; 
	
	RSSTitle( $conf['rss_title'], $conf['rss_url'], $conf['rss_description'] );
		
	RSSItem( $rsslang['rss_disabled'], $conf['rss_url'] );
	
} else {

	$rssrule = explode( '/', ($_SERVER['QUERY_STRING'] != '') ? $_SERVER['QUERY_STRING'] : $conf['rss_default'] );
	
	// Hiba esetn hibazenet, ellenkez esetben betltjk a kezelt
	if (file_exists('mu-sys/rss/r_'.$rssrule[0].'.php' )) {
		
		define('URL', $conf['rss_url']);
		include( 'mu-sys/rss/r_'.$rssrule[0].'.php' ); 
		
	} else {
		
		RSSTitle( $conf['rss_title'], $conf['rss_url'], $conf['rss_description'] );
		RSSItem( $rsslang['unknow_rule'], $conf['rss_url'] );
		
	}
}

echo '</channel>
</rss>';

// GZIP
if (defined('GZIP_STARTED')) { GZIP_DONE(); }

?>