<?php
/***************************************************************************
 *
 * muPORTAL CONTENT MANAGEMENT SYSTEM
 *
 ***************************************************************************
 *                                update.php
 *                            -------------------
 *   kezds               : Kedd, 2004. oktber 20.
 *   copyright            : (C) 2004-2006 muPortal Team
 *   email                : muportal@freemail.hu
 *   Utoljra mdostva   : saxus; 2006. november 12.
 *   utoljra mdostotta : saxus
 *
 ***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/ 

define( 'MUPORTAL', true );

define('UM_MSG', 0);
define('UM_BB', 1);
define('UM_BE', 2);
define('UM_ITEM', 3);



/****************************************************************
 *
 *                          O L D A L A K
 *
 ****************************************************************/

/**********************
 * Megersts
 */
function PAGE_CONFIRM( $failed = false )
{
	global $tp;
	
	ShowHeader(1);
	
	$tp->LoadPackedFile('u1_login');
	
	$tp->UseTpl('loginform_begin');
	
	if (!$failed) {
		$tp->UseTpl('loginform_warn');
	}
	
	$tp->UseTpl('loginform_end', array(
		'USER'		=> (isset($_POST['username'])) ? $_POST['username'] : '',
	));
}


/**************************************
 * 
 */
function PAGE_SETTINGS()
{
	global $tp, $db, $userdata;
	
	ShowHeader(2);
	
	if (!defined('AUTHED')) {
		return false;
	}
	
	$tp->LoadPackedFile('u2_settings');
	
	if (!isset($db->connect)) {
		InitDB( true );
	}
	
	$db->sql_query('SELECT id, name FROM '.DBPREFIX.'users WHERE permissions = 1');
	
	$admins = '';
	
	while ($row = $db->sql_fetch_array()) {
		$admins .= '<option value="'.$row['id'].'"'.(($row['id'] == $userdata['id']) ? ' selected="selected"': '').'>'.$row['name'].'</option>';
	}
		
	$tp->UseTpl('settings', array(
		'S021'		=> ($userdata['dbversion'] == '0.2.1') ? ' checked="checked"' : '',
		'S023'		=> ($userdata['dbversion'] == '0.2.3') ? ' checked="checked"' : '',
		'ADMINS'	=> $admins,
	));
	
	return true;
}



/**************************************
 * 
 */
function PAGE_CONFIGPHP()
{
	global $tp;
	
	ShowHeader(3);

	if (!defined('AUTHED')) {
		return false;
	}	
	
	$tp->LoadPackedFile('u2_settings');
	
	$dbversion = $_POST['dbversion'];
	$protected = $_POST['protected'];
	$insforum  = (isset($_POST['installforum'])) ? 1 : 0;
	
	$tp->UseTpl('configphp', array(
		'DBVERSION'	=> $dbversion,
		'PROTECTED'	=> $protected,
		'INSFORUM'	=> $insforum,
	));
	
	return true;
}


/**************************************
 * 
 */
function PAGE_WRITECONFIGPHP()
{
	global $tp;
	
	ShowHeader(3);
	
	$tp->LoadPackedFile('u2_settings');

	if (!defined('AUTHED')) {
		return false;
	}	
	
	$dbversion	= $_POST['c']['dbversion'];
	$protected	= $_POST['c']['protected'];
	$insforum	= $_POST['c']['insforum'];
	$doupdate	= $_POST['upconfig'];
	
	if ($doupdate == 1) {
	
		// Config.php fjl alapjnak betltse
		$file = 'mu-sys/admin/install/config.txt';
		$config  = @fread( @fopen($file, 'r') , @filesize($file) ); 
		
		global $cfg;
		
		require('config.php');
		
		$config  = str_replace(
			array(
				'{PREFIX}',
				'{HNDLR}',
				'{HOST}',
				'{USER}',
				'{PASW}',
				'{NAME}',
				'{PERS}',
			),
			array(
				DBPREFIX,
				'mysql',
				$cfg['db_server'],
				$cfg['db_user'],
				$cfg['db_pasw'],
				$cfg['db_name'],
				'false',			
			),
			$config 
		);

		$file	= 'config.php';
		$err	= false;
		
		if (is_writeable($file)) {
						
			if (!$handle = @fopen($file, 'w')) {
				$err = 'A telept nem tudta megnyitni a <code>config.php</code> fjlt rsra!';
			} else {
				fwrite($handle, $config);
				fclose($handle);
			}
		} else {
			$err = 'A <code>config.php</code> fjl nem rhat!';
		}
		
		if ($err !== false) {
			$inner = $tp->PrepareTpl('configphp_errwarn', array(
				'MSG'		=> $err,
				'CONFIG'	=> htmlspecialchars($config),
			));
			$title = 'rsi hiba!';
		} else {
			$inner = $tp->PrepareTpl('configphp_done').$tp->PrepareTpl('allready');
			$title = 'frissts ksz';
		}
		
	} else {
		
		$inner = $tp->PrepareTpl('allready');
		$title = '';
	}
	
	$tp->UseTpl('configphp_pg2', array(
		'DBVERSION'	=> $dbversion,
		'PROTECTED'	=> $protected,
		'INSFORUM'	=> $insforum,

		'TITLE'		=> ($title != '') ? 'config.php - '.$title : 'Frissts',
		'INNER'		=> $inner,
	));
	
	return true;
}


/**************************************
 * 
 */
function PAGE_DOUPDATE()
{
	global $tp, $db;
	
	ShowHeader(4);
	
	if (!defined('AUTHED')) {
		return false;
	}
	
	$tp->LoadPackedFile('u4_update');
	$tp->UseTpl('u4_head');
		
	InitDB();
	
	$_updateconf = (isset($_POST['c'])) ? $_POST['c'] : array();
	
	// Tblaszerkezet frisstse
	
	$querys = array(
		'articles'	=> array(
			// Adattpusok mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'articles 
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY category INT(10) UNSIGNED NOT NULL default 0,
			ADD date_t INT(10) UNSIGNED NOT NULL default 0 AFTER date,
			MODIFY userid INT(10) UNSIGNED default NULL,
			MODIFY readed INT(10) UNSIGNED NOT NULL default 0',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'articles SET date_t = UNIX_TIMESTAMP( date )',
			
			// Rgi dtum mez eldobsa
			'ALTER TABLE '.DBPREFIX.'articles DROP date',
			
			// Ideiglenes mez tnevezse, indexek hozzadsa
			'ALTER TABLE '.DBPREFIX.'articles 
			CHANGE date_t date INT(10) NOT NULL default 0,

			ADD INDEX date (date),
			ADD INDEX readed (readed),
			ADD INDEX category (category)',
		),
		
		'articles_category'	=> array(
			// Tblaszerkezet mdostsa, index hozzadsa
			'ALTER TABLE '.DBPREFIX.'articles_category 
			MODIFY id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
			MODIFY position INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD INDEX position (position)'
		),
		
		'banner' => array(
			// Adattpusok mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'banner 
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY count_show INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY count_click INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD data TEXT AFTER clickurl,
			ADD bnrtype TINYINT(1) UNSIGNED NOT NULL DEFAULT 0 AFTER clickurl,
			ADD date_begin_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER date_begin,
			ADD date_end_t INT(10) UNSIGNED NOT NULL DEFAULT 0  AFTER date_end',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'banner SET
				date_begin_t = UNIX_TIMESTAMP( date_begin ), 
				date_end_t = UNIX_TIMESTAMP( date_end ), 
				data = imageurl',
			
			// Ideiglenes s szksgtelen mezk eltvoltsa
			'ALTER TABLE '.DBPREFIX.'banner 
			DROP date_begin, 
			DROP date_end, 
			DROP imageurl',
			
			// Mezk tnevezse, indexek hozzadsa
			'ALTER TABLE '.DBPREFIX.'banner 
			CHANGE date_begin_t date_begin INT(10) NOT NULL default 0,
			CHANGE date_end_t date_end INT(10) NOT NULL default 0,
			
			ADD INDEX date_begin (date_begin),
			ADD INDEX date_end (date_end)',
		),
		
		'downloads' => array(
			// Tblaszerkezet mdostsa, index hozzadsa 
			'ALTER TABLE '.DBPREFIX.'downloads
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY category INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY filesize INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY stat INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY userid INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD date_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER date',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'downloads SET
				date_t = UNIX_TIMESTAMP( date )',
			
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'downloads
			DROP date',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'downloads 
			CHANGE date_t date INT(10) NOT NULL default 0,

			ADD INDEX date (date),
			ADD INDEX stat (stat),
			ADD INDEX category (category)',
		),
		
		'downloads_category' => array(
			// Tblaszerkezet mdostsa, index hozzadsa
			'ALTER TABLE '.DBPREFIX.'downloads_category
			MODIFY id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
			MODIFY position INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD INDEX position (position)'
		),
		
		'links'	=>array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'links
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY userid INT(10) UNSIGNED DEFAULT NULL,
			MODIFY statistic INT(10) UNSIGNED DEFAULT NULL,
			ADD date_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER date,
			ADD description TEXT',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'links SET
				date_t = UNIX_TIMESTAMP( date )',
				
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'links
			DROP date',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'links 
			CHANGE date_t date INT(10) NOT NULL default 0,

			ADD INDEX date (date),
			ADD INDEX statistic (statistic)'
		),
		
		'modules'	=> array(
			// Tblaszerkezet mdostsa, indexek hozzadsa
			'ALTER TABLE '.DBPREFIX.'modules
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY position INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY module VARCHAR(40) NOT NULL DEFAULT \'\',
			MODIFY description VARCHAR(100) NOT NULL DEFAULT \'\',
			ADD INDEX panel (panel),
			ADD INDEX position (position),
			ADD INDEX module (module),
			ADD INDEX type (type),
			ADD INDEX page (page)',
		),
		
		'news'	=> array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'news
			MODIFY id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
			MODIFY userid INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD category INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER id,
			ADD date_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER date,
			ADD highlighted TINYINT(1) NOT NULL DEFAULT 0 AFTER title',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'news SET
				date_t = UNIX_TIMESTAMP( date )',
				
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'news
			DROP date',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'news 
			CHANGE date_t date INT(10) NOT NULL default 0,

			ADD INDEX date (date),
			ADD INDEX category (category),
			ADD INDEX highlighted (highlighted)',
		),
		
		'news_comments'	=> array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'news_comments
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY news INT(10) UNSIGNED NOT NULL DEFAULT 0,
			MODIFY userid INT(10) UNSIGNED NOT NULL DEFAULT 0,
			ADD date_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER date',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'news_comments SET
				date_t = UNIX_TIMESTAMP( date )',
				
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'news_comments
			DROP date',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'news_comments 
			CHANGE date_t date INT(10) NOT NULL default 0,

			ADD INDEX date (date),
			ADD INDEX news (news),
			ADD INDEX userid (userid)',
		),
		
		'news_submited' => array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'news_submited
			MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
			MODIFY userid INT(10) UNSIGNED NULL DEFAULT NULL,
			ADD sdate_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER sdate',
			
			// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'news_submited SET
				sdate_t = UNIX_TIMESTAMP( sdate )',
				
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'news_submited
			DROP sdate',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'news_submited 
			CHANGE sdate_t sdate INT(10) NOT NULL default 0,

			ADD INDEX sdate (sdate),
			ADD INDEX userid (userid)',
		),
		
		'stats_day'	=> array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'stats_day
			ADD tdate INT(8) UNSIGNED NOT NULL DEFAULT 0 AFTER DAY,
			MODIFY visitors INT(10) NOT NULL DEFAULT 0',
			
			// Adatok konvertlsa
			'UPDATE '.DBPREFIX.'stats_day SET
			  tdate = CONCAT(SUBSTRING(DAY, 1, 4), SUBSTRING(DAY, 6, 2) , SUBSTRING(DAY, 9, 2))',
			
			// Felesleges mezk trlse
			'ALTER TABLE '.DBPREFIX.'stats_day
			DROP DAY',
			
			// Tbla tnevezse
			'ALTER TABLE '.DBPREFIX.'stats_day RENAME TO '.DBPREFIX.'stat',
		),
		
		'stats_month' => array(
			'DROP TABLE '.DBPREFIX.'stats_month',
		),
		
		'users'	=> array(
			// Tblaszerkezet mdostsa, ideiglenes mezk hozzadsa
			'ALTER TABLE '.DBPREFIX.'users
		 	MODIFY id INT(10) UNSIGNED NOT NULL auto_increment,
		 	MODIFY permissions TINYINT(2) NOT NULL default 0,
			MODIFY news_comments INT(10) UNSIGNED NOT NULL DEFAULT 0,  
		  	ADD email_cansend tinyint(1) NOT NULL default 0 AFTER email_public,
		  	ADD user_skype varchar(255) default NULL AFTER user_msn,
		  	ADD user_jabber varchar(255) default NULL AFTER user_msn,
		  	ADD user_blog varchar(80) default NULL AFTER user_website,
		  	ADD regdate_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER regdate,
		  	ADD lastdate_t INT(10) UNSIGNED NOT NULL DEFAULT 0 AFTER lastdate',
		  	
		  	// Dtum konvertlsa
			'UPDATE '.DBPREFIX.'users SET
				regdate_t = UNIX_TIMESTAMP( regdate ),
				lastdate_t = UNIX_TIMESTAMP( lastdate )',
				
			// Ideiglenes s szksgtelen mezk eltvoltsa	
			'ALTER TABLE '.DBPREFIX.'users
			DROP regdate,
			DROP lastdate',
			
			// Mezk tnevezse, indxek hozzadsa
			'ALTER TABLE '.DBPREFIX.'users 
			CHANGE regdate_t regdate INT(10) NOT NULL default 0,
			CHANGE lastdate_t lastdate INT(10) NOT NULL default 0,
			
			ADD INDEX name (name),
		  	ADD INDEX permissions (permissions),
		  	ADD INDEX regdate (regdate),
		  	ADD INDEX lastdate (lastdate)',
		),
		
	);
	
	if ($_updateconf['dbversion'] == '021') {
		$querys['users'][] = 'UPDATE '.DBPREFIX.'users SET pasw=MD5(pasw)';
	}
	
	$tp->AddToStack('<h3>Rgi tblk szerkezetnek frisstse</h3><ul>');
	$count_t = 0;
	
	foreach ($querys as $name => $table) {
		
		$tp->AddToStack('<li>'.DBPREFIX.$name.': ');
		$count = 0;
		
		foreach ($table as $sql) {
			$count++;
			$db->sql_query($sql);
		}
		
		$tp->AddToStack($count.' sql krs</li>');
		$count_t += $count;
	}
	$tp->AddToStack('</ul><p>sszesen '.$count_t.' sql krs.</p>');

	
	// j tblk hozzadsa
	
	$querys = array(
		// PACKAGES ----------------
		'packages' =>
			'package varchar(20) NOT NULL default \'\',
			version varchar(16) NOT NULL default \'\',
			installdate int(10) NOT NULL default \'0\'',
		
		// CACHE ---------------
		'cache'	=> 
			'id varchar(16) NOT NULL default \'\',
			filter mediumint(8) unsigned NOT NULL default 0,
			cache longtext NOT NULL,
			PRIMARY KEY  (id),
			KEY filter (filter)',
			
		// CONTENT ---------------
		'content' => 
			'id int(8) unsigned NOT NULL auto_increment,
			bordertype tinyint(1) unsigned NOT NULL default \'0\',
			php tinyint(1) unsigned NOT NULL default \'0\',
			title varchar(100) default \'\',
			content longtext NOT NULL,
			userid int(8) unsigned NOT NULL default \'0\',
			regmode tinyint(3) unsigned NOT NULL default \'0\',
			date_begin int(10) unsigned NOT NULL default \'0\',
			date_end int(10) unsigned default NULL,
			PRIMARY KEY  (id),
			KEY date_begin (date_begin)',
			  
		// MENUS_ITEMS ---------------
		'menus_items' => 
			'id int(10) unsigned NOT NULL auto_increment,
			modid int(10) NOT NULL default \'0\',
			position int(10) NOT NULL default \'0\',
			regmode tinyint(2) NOT NULL default \'0\',
			title varchar(100) NOT NULL default \'\',
			url varchar(255) NOT NULL default \'\',
			PRIMARY KEY  (id),
			KEY modid (modid),
			KEY regmode (regmode),
			KEY position (position)',
		
		// NEWS_CATEGORY ---------------
		'news_category' => 
			'id mediumint(8) unsigned NOT NULL auto_increment,
			title varchar(64) NOT NULL default \'\',
			description text NOT NULL,
			PRIMARY KEY  (id),
			KEY title (title)',
	);
	
	// Ha kell frumot telepteni
	if ($_updateconf['insforum'] == 1) {
		$querys['forum_messages'] = 
		 	'id int(10) unsigned NOT NULL auto_increment,
			tid int(10) unsigned NOT NULL default \'0\',
			author varchar(32) default NULL,
			email varchar(64) default NULL,
			userid int(10) unsigned default NULL,
			postdate int(10) unsigned NOT NULL default \'0\',
			ip varchar(15) NOT NULL default \'\',
			text text NOT NULL,
			PRIMARY KEY  (id),
			KEY postdate (postdate),
			KEY tid (tid)';
		
		$querys['forum_topics'] =
			'id int(10) unsigned NOT NULL auto_increment,
			mode int(1) unsigned NOT NULL default \'1\',
			title varchar(64) NOT NULL default \'\',
			own_author varchar(32) default NULL,
			own_userid int(10) unsigned default NULL,
			ip varchar(15) NOT NULL default \'\',
			createdate int(10) unsigned NOT NULL default \'0\',
			lastmid int(10) unsigned NOT NULL default \'0\',
			PRIMARY KEY  (id),
			KEY mode (mode),
			KEY lastmid (lastmid)';
	}
	
	
	$tp->AddToStack('<h3>j tblk hozzadsa</h3><ul>');
	
	foreach ($querys as $name => $sql) {
		// DEBUG
		// $db->sql_query('DROP TABLE IF EXISTS '.DBPREFIX.$name);
		
		$tp->AddToStack('<li>'.DBPREFIX.$name.'... ');
		$db->sql_query('CREATE TABLE '.DBPREFIX.$name.' ('.$sql.')');
		$tp->AddToStack('Ksz.</li>');
	}
	
	$tp->AddToStack('</ul>');
	
	global $conf;	$conf['debug'] = 1;
	
	// j belltsok hozzadsa
	
	$tp->AddToStack('<h3>j belltsok hozzadsa</h3><ul><li>Hozzads...');
	
	$db->sql_query('SELECT * FROM '.DBPREFIX.'config');
	$conf = array();
	while ( $row = $db->sql_fetch_array()) {
		$conf[$row['name']] = $row['value'];
	}
	
	$path = str_replace('update.php', '', $_SERVER['HTTP_REFERER']);
	$confs = array(
		'panels' => '3',
		'date_today' => '1',
		'timeformat' => 'H:i',
		'site_url' => $path,
		'enable_stat' => '1',
		'enable_banners' => '0',
		'rss_enable' => '1',
		'rss_title' => 'muPortal tartalomkezelo rendszer',
		'rss_description' => 'muPortal tartalomkezelo rendszer',
		'rss_url' => $path,
		'rss_limit' => '10',
		'default_listlg' => '20',
		'rss_maxdesclg' => '0',
		'rss_default' => 'news',
		'email_enable' => '2',
		'gzip_enable' => '1',
		'smtp_from' => 'postmaster@domainnev.hu',
		'smtp_fromname' => 'postmaster',
		'smtp_pasw' => '',
		'smtp_method' => 'smtp',
		'smtp_host' => 'smtp.isp.hu',
		'smtp_port' => '25',
		'smtp_charset' => 'iso-8859-2',
		'smtp_html' => '0',
		'smtp_user' => '',
		'user_regmethod' => '2',
		'system_theme' => 'tpl-base',
		'news_highlight' => '1',
		'security_key' => getRandStr(32),
		'security_aklifetime' => '60',
		'cookie_domain' => '',
		'cookie_path' => '',
		'system_acc' => '1',
		'dbversion' => '0.3.0',
		'stat_limit' => '10',
		'default_listmode' => 'l',
		'listitems_ml' => '20',
		'listitems_ms' => '10',
		'users_last_cleared' => time(),
		'protected_user' => ((isset($_updateconf['protected'])) ? trim($_updateconf['protected']) : '0'),
	);
	
		// Ha kell frumot telepteni
	if ($_updateconf['insforum'] == 1) {
		//$confs['forum_enable'] 			= '1';
		$confs['m_forum_topiclimit']	= '15';
		$confs['m_forum_regmode']		= '0';
		$confs['m_forum_topicmode']		= '0';
		$confs['m_forum_cmt_limit']		= '25';
	}
	
	$count = 0;
	foreach ($confs as $key => $value) 
	{
		$db->sql_query('INSERT INTO '.DBPREFIX.'config (name, value) VALUES (\''.$key.'\', \''.$value.'\')');
		$count++;
	}
	
	$tp->AddToStack($count.' j bellts hozzadva</li></ul>');
	
	$tp->AddToStack('<h3>Rgi belltsok mdostsa</h3><ul>');
	
		$db->sql_query('UPDATE '.DBPREFIX.'config SET value=\'page='.$conf['page_default'].'\' 
			WHERE name=\'page_default\' LIMIT 1');
		$tp->AddToStack('<li>page_default... Ksz</li>');
		
		if (($conf['dateformat'] == 'Y. m. d. H:d:s') || ($conf['dateformat'] == 'Y. m. d. H:d'))
		{
			$db->sql_query('UPDATE '.DBPREFIX.'config SET value=\'Y. m. d. H:i\' 
				WHERE name=\'dateformat\' LIMIT 1');
			$tp->AddToStack('<li>dateformat... Ksz</li>');
		}
		
		if ($_updateconf['insforum'] == 1) {
			$db->sql_query('UPDATE '.DBPREFIX.'config SET value=\'1\' 
				WHERE name=\'forum_enable\' LIMIT 1');
			$tp->AddToStack('<li>forum_enable... Ksz</li>');
		}
	
	$tp->AddToStack('</ul>');
	
	
	// Elavult modulok letiltsa
	
	$tp->AddToStack('<h3>Elavult modulok letiltsa</h3><ul>');
		$querys = array('m_infoblock', 'p_mainmenu');
		
		$db->sql_query('UPDATE '.DBPREFIX.'modules SET panel=0 WHERE module IN (\''.implode('\', \'', $querys).'\')');
		
		$tp->AddToStack('<li>'.$db->sql_affected_rows().' modul letiltva ('.implode(', ', $querys).').</li>');
		
	$tp->AddToStack('</ul>');
	
	// Moduladatok frisstse
	
	$tp->AddToStack('<h3>Moduladatok frisstse</h3><ul>');
		$querys = array(
			'm_download' => 'm_downloads'
		);
		
		$count = 0;
		foreach ($querys as $old => $new) {
			$count++;
			$db->sql_query('UPDATE '.DBPREFIX.'modules SET module=\''.$new.'\' 
				WHERE module=\''.$old.'\' LIMIT 1');
		}
		
		$tp->AddToStack('<li>'.$count.' modul frisstve.</li>');
		
		$tp->AddToStack('<li>'.$db->sql_affected_rows().' modul letiltva ('.implode(', ', $querys).').</li>');
		
	$tp->AddToStack('</ul>');
	
	// j modulok hozzadsa
	
	$tp->AddToStack('<h3>J modulok regisztrlsa</h3><ul>');
	
		$querys = array(
			array(
				0	=> 'm_email',
				1	=> 'email',
				2	=> 'E-mail kld rlap',
				3	=> 3,		// type
				4	=> 2,		// panel
				5	=> 10		// position
			),
			array(
				0	=> 'm_content',
				1	=> 'content',
				2	=> 'Egyszer tartalom kezelse',
				3	=> 3,		// type
				4	=> 2,		// panel
				5	=> 10		// position
			),
			array(
				0	=> 'p_menumgr',
				1	=> '*',
				2	=> 'Fmen',
				3	=> 3,		// type
				4	=> 1,		// panel
				5	=> 1		// position
			),
		);
		
		if ($_updateconf['insforum'] == 1) {
			$querys[] = array(
				0	=> 'm_forum',
				1	=> 'forum',
				2	=> 'Frum modul',
				3	=> 3,		// type
				4	=> 2,		// panel
				5	=> 10		// position
			);
		}
		
		foreach ($querys as $mods)
		{
			$tp->AddToStack('<li>'.$mods[0].' hozzadsa... ');
			
			$db->sql_query('INSERT INTO '.DBPREFIX.'modules 
				(position, panel, type, page, module, description)
			VALUES
				('.$mods[5].', '.$mods[4].', '.$mods[3].', 
				\''.$mods[1].'\', \''.$mods[0].'\', \''.$mods[2].'\')');
			
			$tp->AddToStack('Ksz.</li>');
		}
	
	$tp->AddToStack('</ul>');
	
	// Csomagok regisztrlsa
	
	$tp->AddToStack('<h3>Csomagok regisztrlsa</h3><ul>');
	
		$querys = array('core', 'core-utils', 'news', 'articles', 'downloads', 
			'links');
			
		if ($_updateconf['insforum']) {
			$querys[] = 'forum';
		}
		
		foreach ($querys as $name) {
			$db->sql_query('INSERT INTO '.DBPREFIX.'packages (package, version, installdate)
				VALUES (\''.$name.'\', \'0.3.0\', \''.time().'\')');
			$tp->AddToStack('<li>'.$name.' 0.3.0... Ksz.</li>');
		}
		
	$tp->AddToStack('</ul>');
	
	// Menk ltrehozsa
		
	$tp->AddToStack('<h3>Menk ltrehozsa</h3><ul>');
	
		$querys = array();
		
		$querys[] = array(
			0 => 'Hrek',
			1 => 'index.php?page=news',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Hrarchvum',
			1 => 'index.php?page=archive',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Hrklds',
			1 => 'index.php?page=sendnews',
			2 => '-1',
		);

		$querys[] = array(
			0 => 'Cikkek',
			1 => 'index.php?page=articles',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Linkek',
			1 => 'index.php?page=links',
			2 => '0',
		);

		$querys[] = array(			
			0 => 'Letltsek',
			1 => 'index.php?page=downloads',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Frum',
			1 => 'index.php?page=forum',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Profil',
			1 => 'index.php?page=user&mode=profile',
			2 => '2',
		);

		$querys[] = array(
			0 => 'Regisztrci',
			1 => 'index.php?page=user&mode=registration',
			2 => '1',
		);

		$querys[] = array(
			0 => 'Taglista',
			1 => 'index.php?page=members',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Statisztika',
			1 => 'index.php?page=statistic',
			2 => '0',
		);

		$querys[] = array(
			0 => 'Kapcsolatfelvtel',
			1 => 'index.php?page=contact',
			2 => '0',
		);

		$querys[] = array(
			0 => '-',
			1 => '',
			2 => '3',
		);

		$querys[] = array(
			0 => 'Adminisztrci',
			1 => 'admin.php',
			2 => '3',
		);
		
		$db->sql_query('SELECT id FROM '.DBPREFIX.'modules WHERE module=\'p_menumgr\' LIMIT 1');
		$row = $db->sql_fetch_array();
		$menumodid = $row['id'];
		
		$count = 0;
		foreach ($querys as $pos => $item) {
			$db->sql_query('INSERT INTO '.DBPREFIX.'menus_items 
				(modid, position, regmode, title, url)
			VALUES
				('.$menumodid.', '.$pos.', '.$item[2].', \''.$item[0].'\', \''.$item[1].'\')');
				$count++;
		}
		$tp->AddToStack('<li>'.$count.' menelem hozzadva</li>');
	
	$tp->AddToStack('</ul>');
	
	$tp->UseTpl('u4_end');
	
	return true;
}


/**************************************
 * 
 */
function PAGE_DONE()
{
	global $tp;
	
	ShowHeader(5);
	
	$tp->LoadPackedFile('u4_update');
	
	$tp->UseTpl('u5_done');
}











/**************************************
 * Sg megjelentse
 */
function PAGE_HELP()
{
	global $tp;
	
	ShowHeader(0);
	
	$tp->LoadFile('ux_help');
	
	$tp->UseTpl('ux_help');
}

/****************************************************************
 *
 *              R E N D S Z E R F  G G V  N Y E K
 *
 ****************************************************************/

/**************************************
 * 
 */
function InitDB( $force = false )
{
	global $db, $cfg;
	
	require_once('config.php');
	if (!defined('SQLHANDLER')) {
		define('SQLHANDLER', 'mysql');
	}
	require_once('mu-sys/includes/sql-'.SQLHANDLER.'.php');
	
	if (defined('MUPORTAL_INSTALLED') || $force) {
		$db = new sql_db( $cfg );
		unset($cfg);
	}
}

function GetUserIP()
{
	$ip = FALSE; 
	
	if (!empty($_SERVER["HTTP_CLIENT_IP"])) { $ip = $_SERVER["HTTP_CLIENT_IP"]; } 
	    
		if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) { $ips = explode (", ", $_SERVER['HTTP_X_FORWARDED_FOR']);
			
			if ($ip) { array_unshift($ips, $ip); $ip = FALSE; } 
	
				for ($i = 0; $i < count($ips); $i++) { 
					if (!eregi ("^(10|172\.16|192\.168)\.", $ips[$i])) { 
						if (version_compare(phpversion(), "5.0.0", ">=")) {
								
								if (ip2long($ips[$i]) != false) { 
									$ip = $ips[$i]; 
									break; } 
										
							} else {
	               	 
								if (ip2long($ips[$i]) != -1) { 
									$ip = $ips[$i]; 
									break; } 
							} 
					} 
			} 
	} 
		
	return $ip; 
}

/******************************
 * Msg_Die $code rtkeinek deffinilsa
 */
define('MESSAGE', 100);
define('WARNING', 101);
define('ERROR', 102);
define('CRITICAL', 103);

function Msg_Die ( $code, $msg_text = '')
{
	Die( $msg_text );
}

function message( $type = UM_MSG, $text = '' )
{
	switch ($type) {
		case UM_MSG : {
			echo '<p>'.$text.'</p>';
			break;
		}
		case UM_BB : {
			if ($text !='') { echo '<h3>'.$text.'</h3>'; };
			echo '<ul>';
			break;
		}
		case UM_BE : {
			echo '</ul>';
			if ($text !='') { echo '<p>'.$text.'</p>'; };
			break;
		}
		case UM_ITEM : {
			echo '<li>'.$text.'</li>';
			break;
		}
	}
}
	

/**********************
 * Telepts aktulis sttusznak megjelentse
 */
function ShowHeader( $state = 1 )
{
	global $tp;
	
	$s = array_fill(1,6,'');
	
	$s[$state] = ' class="sel"';
	
	$tp->UseTpl( 'head', array (
		'S1' => $s[1],
		'S2' => $s[2],
		'S3' => $s[3],
		'S4' => $s[4],
		'S5' => $s[5],
		'MV' => MP_VER_NAME
	));
}

if (!function_exists('getRandStr')) {
		function getRandStr( $ln = 8 ) {
		        return substr( str_shuffle('0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz0123456789abcdefghijklmnopqrstvwxyz'), 0, $ln );
		}
	}



/****************************************************************
 *
 *                B E L  P  S I    P O N T     
 *
 ****************************************************************/

/******************
 * INICIALIZLS
 */
session_start();

global $userdata;

if (isset($_SESSION['muUpdate_Auth'])) {
	$userdata = &$_SESSION['muUpdate_Auth'];
	define('AUTHED', true);
}
 
// Ha ltezik a 'config.php' fjl, akkor betltjk.
// if (file_exists('config.php')) { 
//	require_once('config.php');
// }

if (file_exists('mu-sys/includes/version.php')) {
	require_once('mu-sys/includes/version.php'); 
} else {
	Die('Minimum 0.3.0-s verzij muPortal keretrendszer szksges az adatbzis frisstshez! Krlek tltsd fel az j fjlokat');
}

// Mintarendszer inicializlsa
require_once('mu-sys/includes/templates.php'); 
$tp = new template();
$tp->basedir = 'mu-sys/admin/install/';
$tp->LoadpackedFile('u_base');

if (isset($_GET['page'])) {
	
	$page = $_GET['page'];
	
	switch ( $page )
	{
		case 'help' :
		{
			PAGE_HELP();
			break;
		}
	}
	
} else {

	if (!defined('AUTHED')) {
		
		if (isset($_POST['page'])) { $page = $_POST['page']; } else { $page = 'confirm'; }
		
		switch ( $page )
		{
			case 'confirm' : {
				PAGE_CONFIRM();
				break;
			}
			case 'settings' : {
				InitDB(true);
				
				$username = trim($_POST['username']);
				$userpasw = trim($_POST['userpasw']);
				
				$db->sql_query('SELECT id, pasw FROM '.DBPREFIX.'users WHERE name=\''.$username.'\' LIMIT 1');
				
				if ($db->sql_num_rows() != 1) {
					PAGE_CONFIRM( true );
				} else {
					
					$row = $db->sql_fetch_array();

					$dbversion = false;
					
					if ($row['pasw'] == $userpasw) {
						$dbversion = '0.2.1';
					} elseif ($row['pasw'] == md5($userpasw)) {
						$dbversion = '0.2.3';
					}
					
					$row['dbversion'] = $dbversion;
					
					if ($dbversion === false) {
						PAGE_CONFIRM( true );
					} else {
						$_SESSION['muUpdate_Auth'] = $row;
						global $userdata;
						$userdata = $row;
						define('AUTHED', true);
						
						PAGE_SETTINGS( true );
					}
					
					
				}
				break;
			}
		}
		
	} else {
		
		if (isset($_POST['page'])) { $page = $_POST['page']; } else { $page = 'confirm'; }
		
		switch ( $page )
		{
			case 'confirm' : {
				PAGE_CONFIRM();
				break;
			}
			case 'settings' : 
			{
				PAGE_SETTINGS();
				break;
			}
			case 'configphp' : 
			{
				PAGE_CONFIGPHP();
				break;
			}
			case 'configphp' : 
			{
				PAGE_CONFIGPHP();
				break;
			}
			case 'writeconfigphp' : 
			{
				PAGE_WRITECONFIGPHP();
				break;
			}
			case 'doupdate' : 
			{
				PAGE_DOUPDATE();
				break;
			}
			case 'done' :
			{
				PAGE_DONE();
				break;
			}
		}	
	}
}

$tp->UseTpl('end');

$tp->Execute();


?>